       PROGRAM PILOTDEQC
C
C**** *PILOTDEQC*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         PILOT DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1U( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C         R. CINTRA *CPTEC*
C         ULTIMA ALTERACAO EM 12.2000
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comrec.h' 
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /rec_writen/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
c
C
      character*15 cstop
      character*23 charaux
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
c
C
      CALL INITVAR( IERR )
      
C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='pilot.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN',organization='relative',recl=1536)
C     ----------------------------------------------------------------
C*          2.   READ IN BULLETIN.
C                -----------------
 200  CONTINUE
c
      ierr = 0
C     ------------------------------------------------------------------
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
C     ------------------------------------------------------------------
C*          3.   FORMAT BULLETIN.
C                ----------------
 300  CONTINUE
C
      CALL PROCRFB( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(IERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          4.   DECODE BULLETIN HEADER.
C                -----------------------
 400  CONTINUE
C
      CALL PROCHDR( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          5.   CHECK TEXT OF BULLETIN.
C                -----------------------
 500  CONTINUE
C
      CALL PROCTXT( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C
C     ------------------------------------------------------------------
C*          6.   CALL APPROPRIATE ROUTINE TO DECODE TEMP DATA.
C                ---------------------------------------------
 600  CONTINUE
C
      CALL PROCT1U( IERR )
C
C
      GO TO 200
C
C     ------------------------------------------------------------------
 1000 CONTINUE
C
C
      close(unit=99)
c----|-----------------------------------------------------------------|-------|
c		Criar uma estatistica do processamento das  
c               mensagens Serao incluida no arquivo cabecalho.dat.
c
c             ________________________________________________
c             | VARIAVEL   |        DESCRICAO                |
C             |============|=================================|
c	      |	numbull    |   Numero de boletins lidos,     |
C             |------------|---------------------------------|
c             | numbullerr |   Numero de boletins com erro,  |
C             |------------|---------------------------------|
c             | numreport  |   Numero de mensagens lidas,    |
C             |------------|---------------------------------|
c	      |	numreperr  |   Numero de mensagens com erro, |
C             |------------|---------------------------------|
c    	      |	irecswriten|   Numero de mensagens gravadas, |
C             |------------|---------------------------------|
c	      |	irepetida  |   Numero de mensagens repetidas |
C             |------------|---------------------------------|
c             | inil       |   Numero de mensagens ignoradas |
c             |______________________________________________|
c               
c------------------------------------------------------------------------------

      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(91,file='mesg_err.dat',status='old',access='append')
c
      write(91,20)
      write(91,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida,inil
 10   format('| PILOT     |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |'
     c       ,I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |')
      write(91,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|')
c
c------------------------------------------------------------------------------
      close(91)
c
      stop
      END
      
      SUBROUTINE READIN( IERR )
C
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C	   ULTIMA ALTERACAO 20.01.99.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
 
      CHARACTER*16384 YCHAR
      Character*16384 buff_aux
      Character*4 four_chars
      Character*4 endmsg
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
      DATA NSKIP/0/
c     Data aux/'03010D0D'Z/       ! ^C^A^M^M (separador de mensagens)
      Data aux/'0D0D0103'Z/       ! ^C^A^M^M (separador de mensagens)
C
 
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR= 0
      NWPT= 1
      NBPT= 0
      NSUB= 0
C
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
      IERR=0
C
      OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE='pilot.dat',
     1     STATUS='OLD')
 
C
      Write(endmsg,10) aux     ! ^C^A^M^M (separador de mensagens)
 10   Format(a4)
 110  CONTINUE
      index = 1
      ilen = 1
      four_chars = char(0) // char(0) // char(0) // char(0)
c     
      Do While(four_chars .ne. endmsg)
      READ (3,'(Q,A)',ERR=200,END=300,IOSTAT=IOS) ILEN,YCHAR
      buff_aux(index:index+ilen-1) = ychar(1:ilen)
c     ------------------------------------------------------------------
c      Alteracao (Gamb) para cobrir problema do fortran v3.8. 
c       Na leitura do arquivo stream_LF,tem como final de registro um LF e CR,
c       sendo que este ultimo faz parte da mensagem, e por isso foi novamente 
c       acrescentado. 
c
c            A T E N C A O - checar as novas versoes do fortran/OSF.
c
c                    Rosangela.  04.07.96
c     ------------------------------------------------------------------
      index = index + ilen
      ilen = ilen + 1
      buff_aux(index:index) = char(13)  ! O CR nao vem na leitura
      ychar(ilen:ilen) = char(13)
      four_chars = ychar(ilen-3:ilen)
c
      end do
c
      ilen = index - 1
      ychar(1:ilen) = buff_aux(1:ilen)
c
C
      if(ilen.gt.4) NUMBULL=NUMBULL + 1
C
C*          1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C*          1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.LE.NSKIP) GO TO 100
C
C*          1.4  TRANSFER BULLETIN TO 'KCHAR', ONE CHARACTER PER WORD
C                -----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
      RETURN
C     -----------------------------------------------------------------
 200  CONTINUE
C
      IERR=1
      WRITE(*,9901) IOS
      PRINT*,'READIN: ILEN=',ILEN
      RETURN
C     -----------------------------------------------------------------
 300  CONTINUE
C
      IEOF=1
      PRINT*,'READIN: END OF FILE IEOF=',IEOF
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ----------------------------------------------------------------
 9901 FORMAT(1H0,'+ + + ERROR IN READING BULLETIN FILE. IOSTAT=',
     C I6,' DECIMAL')
 9902 FORMAT(1H ,'BULLETIN NUMBER IS ',I6)
 9903 FORMAT(1H0,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=',
     C I6,' DECIMAL')
C     ----------------------------------------------------------------
      END
      
      SUBROUTINE PROCRFB ( IERR )
C**** *PROCRFB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO FORMAT BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCRFB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C     ------------------------------------------------------------------
C*          1.   KEEP SOURCE OF DATA AND DATE/TIME OF ARRIVAL.
C                ---------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,3
C
      KHEAD(I)=MINDIC      ! THIS WILL BE CHANGED ACCORDING TO THE KEY.
C
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2.  DEFINE T1 AND T2 FROM ABBREVIATED HEADING.
C               ------------------------------------------
 200  CONTINUE

      DO 202 I=1,ILEN
C
      IF(KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 203
C
 202  CONTINUE
C
      IT1=27
      GO TO 210
C
 203  CONTINUE
C
      IT1=KCHAR(I  )-64
      IT2=KCHAR(I+1)-64
C
      IF(IT1.NE.21) THEN
                       IERR=1
                       IT1=27
                       RETURN
                    END IF
C
C     CHECK IF 'T2' CHARACTER IS LETTER.
C
      IF(IT2.LT.0.OR.IT2.GT.26) IT1=27
C
C*          2.1  LAST CHARACTER OF BULLETIN CAN BE IN ANY OF THE LAST
C                -----------------------------------------------------
C                5 WORDS. IF CHARACTER  IS 'ETX' REPLACE BY 'GS' .
C                -------------------------------------------------
C                IF NEITHER CAN BE FOUND INSERT 'GS' AS LAST CHARACTER.
C                ------------------------------------------------------
 210  CONTINUE
C
      IST=ILEN-5
C
      DO 211 I=1,ILEN
C
      IF (KCHAR(I).EQ.3.OR.KCHAR(I).EQ.29) THEN
                                              KCHAR(I)= 29
                                              IGS=I
                                              RETURN
                                           END IF
C
 211  CONTINUE
C
      I=I-1
      KCHAR(I)= 29
      IGS=I
C
      RETURN
      END
      
      SUBROUTINE PROCTXT ( IERR )
C
C**** *PROCTXT*
C
C
C     PURPOSE.
C     --------
C          CHECKS WHETHER BULLETIN CONTAINS USEFUL DATA .
C          THE FOLLOWING BULLETINS ARE CONSIDERED TO CONTAIN
C          NO USEFUL DATA.
C                 1. TEXT OF 'NIL' , OR VARIANTS OF THIS.
C                 2. TEXT OF 'NO DATA AVAILABLE'.
C                 3. TEXT OF 'NO REPORTS AVAILABLE'.
C                      1. - 3.  ARE DETERMINED SIMPLY BY CHECKING
C                      THE LENGTH OF THE TEXT . IF IT IS LESS
C                      THAN 26 THERE CANT BE ANY USEFUL DATA IN IT
C                 4. UK AND GERMAN DOMESTIC BULLETINS WHICH DO
C                    NOT CONFORM TO WMO CODES.
C
C          INPUT     : BULLETIN IN ARRAY 'KCHAR' ,
C                      ONE CHARACTER PER WORD.
C
C          OUTPUT    : KERR = 0 INDICATES BULLETIN CONTENTS REQUIRED.
C                           = 1 MEANS TEXT OF 'NIL' ETC.
C                           = 2 UK OR GERMAN DOMESTIC BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCTXT(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *SAVBULL(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR.
C                ----------------------
 100  CONTINUE
C
      KERR= 0
C
C
C*          1.1  CHECK IF BULLETIN IS TOO SHORT I.E. "NIL" BULLETIN.
C                ---------------------------------------------------
 110  CONTINUE
C
      ILE = IGS - IMI
      IF(ILE .LT. 26) THEN
                         KERR = 7
                         NUMBERR(7) = NUMBERR(7) + 1
                                KCHAR(IGS)=KCHAR(IGS).OR.128
C                               GO TO 900
                      END IF
C
C
C*          1.2  CHECK IF THE BULLETIN IS DOMESTIC FROM UK OR GERMANY.
C                -----------------------------------------------------
C                THIS IS DONE BY CHECKING IF THE BULLETIN HAS
C                --------------------------------------------
C                CCCC OF (EG--,ED--) OTHER THAN (EGRR,EDZW).
C                -------------------------------------------
 120  CONTINUE
C
      IPT=IAH+4
      CALL NEXTLET(IPT,JAH)
C
C     IF BULLETINS HAVE 'CCCC' NOT 'ED--' OR 'EG--' , RETURN.
C
      IF ( KCHAR(IPT).NE.69 ) RETURN
      IF ( KCHAR(IPT+1).NE.71.AND.KCHAR(IPT+1).NE.68 ) RETURN
C
C        FIRST UK
C
             IF (KCHAR(IPT+1).EQ.71)
     C                      THEN
                                 IF(KCHAR(IPT+2) .NE. 82 .OR.
     1                              KCHAR(IPT+3) .NE. 82)
     2                                   KERR = 8
                            ELSE
C
C        THEN GERMANY
C
                                 IF(KCHAR(IPT+2) .NE. 90 .OR.
     1                              KCHAR(IPT+3) .NE. 87)
     2                                   KERR = 8
                            END IF
C
C     MARK CCCC GROUP IF REQUIRED.
C
      IF ( KERR.EQ.8 ) THEN
                              KCHAR(IPT+4) = KCHAR(IPT+4).OR.128
                              NUMBERR(8) = NUMBERR(8) + 1
                          END IF
C
C           1.3 TREAT IN ACCORDANCE WITH DEFINED OPTIONS.
C               -----------------------------------------
 130  CONTINUE
C
C     RETURN IF NO ERROR.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
 900  CONTINUE
C
      N = KERR - 1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C           1.4  PRINT BULLETIN IF REQUIRED.
C                ---------------------------
 140  CONTINUE
C
      IF (N1.EQ.1) THEN
                       WRITE (*,9900) KERR
                       CALL PRTBULL (1,IGS)
                   END IF
C
C           1.5 WRITE TO ERROR FILE IF REQUIRED.
C               --------------------------------
 150  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
      RETURN
C     -----------------------------------------------------------------
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C     -----------------------------------------------------------------
      END
      
      SUBROUTINE PROCHDR ( IERR )
C
C**** *PROCHDR
C
C
C     PURPOSE.
C     --------
C         DEODE BULLETIN HEADER AND INSERT REQUIRED PARAMETERS
C         IN DECODED REPORT HEADER.
C
C         LOCATES BEGINNING  AND END OF ABBREVIATED HEADER AND
C         'MIMIMJMJ' LINES.
C
C         INPUT     : BULLETIN IN KCHAR(1) - KCHAR(IGS)
C
C                     BULLETIN RECORD HEADER IN KINT(1) - KINT(5)
C
C                     'IT1' = 27 INDICATING BULLETIN HAS NOT BEEN
C                            IDENTIFIED FROM 'TT' OF ABBREVIATED HEADER.
C
C         OUTPUT    : KDEC(10) = DAY OF MONTH ( INTEGER ) . YY
C                     KDEC(11) = TIME OF BULLETIN - HOURS ( INTEGER ) . G
C                     KDEC(12) = TIME OF BULLETIN - MINS ( INTEGER ) . GG
C
C                     KDEC(14) = 0 IF ORIGIN OF REPORT IS FGGE.
C                                1  "   "     "    "    " BRACKNELL.
C                                2  "   "     "    "    " OFFENBACH.
C
C                     KDEC(21) =1 IF BULLETIN IS 'COR' , OTHERWISE
C                                    = 0 .
C
C                     KDEC(21) = 1 IF BULLERIN IS 'CCA'
C                     KDEC(21) = 2 IF BULLERIN IS 'CCB'
C                     KDEC(21) = 3 IF BULLERIN IS 'CCC'
C                     KDEC(21) = 4 IF BULLERIN IS 'CCD'
C                     .
C                     .
C
C                     KDEC(18) = DATE OF BULLETIN ARRIVAL ( ON VAX )
C                     KDEC(19) = TIME  "    "        "      "     "
C
C                     IAH =    "      " BEGINNING OF 'ABBREVIATED HEADER'
C                     JAH =    "      "     END   "       "         "
C
C                     IMI =    "      " BEGINNING OF 'MIMIMJMJ' LINE.
C                     JMI =    "      "     END   "       "       "
C
C                     KERR = 0 IF NO ERROR FATAL TO DECODING ENCOUNTERED.
C                         = 1 IF BULLETIN HAS LESS THAN 3 LINES.
C                         = 2 IF BULLETIN IS NOT RECOGNISED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCHDR( IERR )*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I,N1,N2,N3,N4,N5,N,IRET)*
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *SAVBULL(IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION ILST(26)
      DATA ILST/65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     1          81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR AND SET REPORT HEADER AREA
C                ------------------------------------------------
C                TO MISSING DATA INDICATOR.
C                --------------------------
 100  CONTINUE
C
      KERR=0
C
      DO 101 I=1,24
C
      KDEC(I)= MINDIC
C
 101  CONTINUE
C
C*          1.1  FLAG FIELDS SET TO ZERO.
C                ------------------------
 110  CONTINUE
C
      KDEC(13)=0
      KDEC(15)=0
      KDEC(21)=0
C
C*          2.  LOCATE BEGINNING AND END OF 'STARTING LINE' ,
C               ---------------------------------------------
C               'ABBREVIATED HEADER' AND 'MIMIMJMJ LINE ' .
C               -------------------------------------------
C
c
       isl=1
       CALL NEXTPRT ( isl,IGS )
       jsl=isl 
       CALL NEXTEND ( jsl,IGS )
       iah=jsl
       CALL NEXTPRT ( iah,IGS )
       jah=iah
       CALL NEXTEND ( jah,IGS )
       imi=jah
       CALL NEXTPRT ( imi,IGS )
       jmi=imi
       CALL NEXTEND ( jmi,IGS )
c
C
C*          2.1 IF THESE 3 LINES CANNOT BE LOCATED , BULLETIN CONSISTS
C               ------------------------------------------------------
C               OF LESS THAN 3 LINES.
C               ---------------------
 210  CONTINUE
C
      IF ( JMI.GT.IGS ) THEN
C
C                           SET ERROR NUMBER AND MARK ERROR.
C
                            KERR = 1
                            KCHAR(IGS)=KCHAR(IGS).OR.128
                            NUMBERR(1) = NUMBERR(1) + 1
                            GO TO 300
                        END IF
C
C
C
C*          2.2  BULLETIN CANNOT BE IDENTIFIED FROM 'TT' .
C                -----------------------------------------
 220  CONTINUE
C
      IF ( IT1.EQ.27 ) THEN
C
C                          SET ERROR NUMBER AND MARK ERROR.
C
                           KERR = 2
                           KCHAR(IAH+2)=KCHAR(IAH+2).OR.128
                           NUMBERR(2) = NUMBERR(2) + 1
                           GO TO 300
                       END IF
C
C
C*          2.3  NO CHECKS ARE MADE ON TTAAII OR CCCC GROUPS.
C                --------------------------------------------
 230  CONTINUE
C
C
C
C*          2.4  LOCATE AND DECODE 'YYGGGG' GROUP .
C                ----------------------------------
 240  CONTINUE
C
C     SCAN 'KCHAR' FOR FIRST FIGURE AFTER 'II' FIGURES.
C
      IPT = IAH + 6
      CALL NEXTFIG ( IPT,JAH )
      IF ( IPT.GE.JAH ) THEN
                          KERR = 5
                        ELSE
C
C                         EXTRACT YY,GG AND GG AND CONVERT TO INTEGERS
C                         IN WORDS 10-12 OF 'KINT' .
C
                          CALL EXTGRP( IPT,2,2,2,0,0,10,IRET )
                          IPT = IABS(IPT)
C
C                         TEST VALIDITY OF YY,GG AND GG.
C                         THIS TEST MAKES CHECKING RETURN CODE 'IRET'
C                         UNNECESSARY.
C
                          IF ( KINT(10).LT.1.OR.KINT(10).GT.31 )
     C                             THEN
                                        KERR = 5
                                        KINT(10) = MINDIC
                                   END IF
C
                          IF ( KINT(11).LT.0.OR.KINT(11).GT.23 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
                          IF ( KINT(12).LT.0.OR.KINT(12).GT.59 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
C
C                                  COPY TO DECODED REPORT HEADER AREA
C                                  AND RESET WORDS IN 'KINT'.
C
                                   DO 241 I=10,12
                                          KDEC(I) = KINT(I)
                                          KINT(I) = MINDIC
  241                              CONTINUE
C
                        END IF
C
C     MARK ERROR IN YYGGGG GROUP.
C
      IF ( KERR.EQ.5 ) THEN
                              KCHAR(IPT)=KCHAR(IPT).OR.128
                              NUMBERR(5) = NUMBERR(5) + 1
                          END IF
C
C*          2.5 THE ONLY CHECK ON 'BBB' IS FOR 'COR'.
C               -------------------------------------
 250  CONTINUE
C
C     FIND NEXT LETTER IN ABBREVIATED HEADER LINE AND CHECK IF 'C' (67)
C
      CALL NEXTLET ( IPT,JAH )
C
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.79) THEN
                                                       KDEC(21)=1
                                                       GO TO 260
                                                    END IF
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.67)
     1     THEN
              DO 251 IJ=1,26
              IF(KCHAR(IPT+2).EQ.ILST(IJ)) THEN
                                              KDEC(21)=IJ
                                              GO TO 260
                                           END IF
C
 251          CONTINUE
C
           END IF
C
C
C
C*          2.6 INSERT ORIGIN AND DATE/TIME OF ARRIVAL OF BULLETIN.
C               ---------------------------------------------------
 260  CONTINUE
C
C     ORIGIN IS DERIVED FROM KEY . BRACKNELL FILE
C     NAMES START WITH 'B' AND OFFENBACH WITH 'C'. THIS FILENAME IS
C     IN ASCCI CODE       ( 'B' =66 , 'C' = 67)
C
      KDEC(14) = MINDIC    !    ORIGIN WILL BE DEFINED FROM KEY.
C
C
      KDEC(18) = MINDIC               ! DATE AND TIME OF ARRIVAL
      KDEC(19) = MINDIC               !
C
C
C
C*          2.7 TREAT ERROR BULLETIN IN ACCORDANCE WITH DEFINED OPTIONS.
C               --------------------------------------------------------
 270  CONTINUE
C
C     RETURN IF NO ERRORS FOUND.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
C*          3. HANDLE ERROR BULLETIN.
C              ----------------------
 300  CONTINUE
C
      N = KERR-1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C*          3.1 PRINT BULLETIN IF REQUIRED.
C               ---------------------------
 310  CONTINUE
C
      IF ( N1.EQ.1 ) THEN
                         WRITE (*,9900) KERR
                         CALL PRTBULL ( 1,IGS)
                     END IF
C
C*          3.2 WRITE BULLETIN TO ERROR FILE IF REQUIRED.
C               -----------------------------------------
 320  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
C
C*          3.3  ONLY ERRORS 1 AND 2 ARE FATAL TO DECODING , SO CLEAR
C                -----------------------------------------------------
C                ERROR INDICATOR BEFORE RETURNING.
C                ---------------------------------
 330  CONTINUE

c     IF ( KERR.GT.2 ) KERR = 0
      if(kerr.gt.2) then  
        kerr = 0
c       ierr = 0
      end if
C
      RETURN
C
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C
      END
      
      SUBROUTINE PROCT1U ( IERR )
C
C**** *PROCT1U*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING UPPER AIR
C         DATA ( BULLETINS WITH 'T1' OF 'U' )
C
C         INPUT    : IERR IS NOT USED ON INPUT.
C
C                    IT2  = 1-26 CORRESPONDING TO 'T2' OF A-Z.
C
C         OUTPUT   : IERR IS UNALTERED UNLESS A FATAL ERROR OCCURRS ,
C                     WHEN IT IS SET TO 1.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCT1U(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *BULLUP(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  CALL APPROPRIATE ROUTINE, 'IT2' CONTAINS AN INTEGER IN THE
C                ---------------------------------------------------------
C               RANGE 1-26, CORRESPONDING TO 'T2' OF ABBREVIATED HEADER.
C                -------------------------------------------------------
 100  CONTINUE
C
C
      GOTO ( 110,120,130,140,150,160,170,180,190,200,210,220,230,
     C       240,250,260,270,280,290,300,310,320,330,340,350,360) IT2
C
C     -----------------------------------------------------------------
C*              1.1  BULLETINS WITH 'TT' = 'UA'.
C                    ----------------------------------------------
 110  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.2  BULLETINS WITH 'TT' = 'UB'.
C                    ---------------------------
 120  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.3  BULLETINS WITH 'TT' = 'UC'.
C                    ---------------------------
  130 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.4  BULLETINS WITH 'TT' = 'UD'.
C                    ---------------------------
  140 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.5  BULLETINS WITH 'TT' = 'UE'.
C                    ----------------------------
  150 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.6  BULLETINS WITH 'TT' = 'UF'.
C                    ---------------------------
  160 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.7  BULLETINS WITH 'TT' = 'UG'.  PILOT PART B.
C                    ----------------------------
  170 CONTINUE
      CALL BULLUG( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.8  BULLETINS WITH 'TT' = 'UH'.  PILOT PART C.
C                    ---------------------------
  180 CONTINUE
      CALL BULLUH( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.9  BULLETINS WITH 'TT' = 'UI'.  PILOT PART A AND B.
C
  190 CONTINUE
      CALL BULLUI( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.0  BULLETINS WITH 'TT' = 'UJ'.
C                    ---------------------------
 200  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.1  BULLETINS WITH 'TT' = 'UK'.
C                    ---------------------------
 210  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.2  BULLETINS WITH 'TT' = 'UL'.
C                    ---------------------------
 220  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.3  BULLETINS WITH 'TT' = 'UM'.
C                    ---------------------------
 230  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.4  BULLETINS WITH 'TT' = 'UN'.
C                    ---------------------------
 240  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.5  BULLETINS WITH 'TT' = 'UO'.
C                    ---------------------------
 250  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.6  BULLETINS WITH 'TT' = 'UP'.  PILOT PART A.
C                    ---------------------------
 260  CONTINUE
      CALL BULLUP( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.7  BULLETINS WITH 'TT' = 'UQ'.  PILOT PART D.
C                    ---------------------------
 270  CONTINUE
      CALL BULLUQ( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.8  BULLETINS WITH 'TT' = 'UR'.
C                    ---------------------------
 280  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.9  BULLETINS WITH 'TT' = 'US'.
C                    ---------------------------
 290  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.0  BULLETINS WITH 'TT' = 'UT'.
C                    ---------------------------
 300  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.1  BULLETINS WITH 'TT' = 'UU'.
C
 310  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.2  BULLETINS WITH 'TT' = 'UV'.
C
 320  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.3  BULLETINS WITH 'TT' = 'UW'.
C
 330  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.4  BULLETINS WITH 'TT' = 'UX'.
C
 340  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.5  BULLETINS WITH 'TT' = 'UY'.  PILOT PART C AND D.
C
 350  CONTINUE
      CALL BULLUY( IERR )
      RETURN
C     ------------------------------------------------------------------
C*              3.6  BULLETINS WITH 'TT' = 'UZ'.
C
 360  CONTINUE
      RETURN
C
      END
      
      SUBROUTINE BULLUP ( IERR )
C
C**** *BULLUP*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF PILOT REPORTS.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLUP(IERR)*
C
C          INPUT    : BULLETIN IN CCITT 5 CHARACTER , 1 CHARACTER PER
C                     WORD IN 'KCHAR'.
C
C                      POINTERS TO BEGINNING AND END OF 'STARTING LINE',
C                     'ABBREVIATED HEADING','MIMIMJMJ LINE' AND END OF
C                     BULLETIN.
C
C                     IERR NOT USED.
C
C          OUTPUT   : DECODED REPORTS WRITTEN TO FILE AND ERROR REPORTS
C                     TO ERROR FILE.
C
C                     IERR = 1 , IF ANY FILE HANDLING ERROR.
C
C
C
C     METHOD.
C     -------
C
C         THIS ROUTINE HAS MULTIPLE ENTRY POINTS , ONE FOR
C         EACH OF THE POSSIBLE 'TT' CODES USED IN PILOT
C         BULLETIN HEADINGS . THIS ROUTINE CALLS THE APPROPRIATE
C         DECODING ROUTINES FOR EACH PART OF THE REPORTS BY
C         EXAMINING EACH 'MIMIMJMJ' GROUP.
C
C         THIS APPROACH HAS BEEN ADOPTED BECAUSE OF THE
C         FREQUENCY WITH WHICH INCORRECT BULLETINS ARE
C         RECEIVED (E.G. ALL PARTS OF A PILOT IN 1 BULLETIN)
C         AND MAINTAINS THE SUBROUTINE NAMING CONVENTIONS
C         USED.
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *XXXXXXX(XXXX)*
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOVEMBER  -84.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
                 ENTRY BULLUG ( IERR )
                 ENTRY BULLUH ( IERR )
                 ENTRY BULLUI ( IERR )
                 ENTRY BULLUQ ( IERR )
                 ENTRY BULLUY ( IERR )
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
c
      common /reperr/ numreperr
      common /inil/ inil
C
      DATA IBLOCKS/10*-1/
      DATA IDONEA /200*-1/
      DATA IDONEB /200*-1/
      DATA IDONEC /200*-1/
      DATA IDONED /200*-1/
      DATA IPRLIM /2000/
      DATA MODIFY /0/
C
      DATA ISTASA/
     C   100*-1/
      DATA ISTASB/
     C   100*-1/
      DATA ISTASC/
     C   100*-1/
      DATA ISTASD/
     C   100*-1/
      DATA IERSHIP / 0 /
      DATA IERALLA /0/
      DATA IERALLB /0/
      DATA IERALLC /0/
      DATA IERALLD /0/
C
      DATA IPRALLA /0/
      DATA IPRALLB /0/
      DATA IPRALLC /0/
      DATA IPRALLD /0/
C     ------------------------------------------------------------------
C*          1.   SET FLAFS AND WORKING POINTERS.
C                -------------------------------
 100  CONTINUE
C
C     PRINT BULLETIN IF REQUIRED.
C
C     CALL PRTBULL(1,IGS)
C
      ITIM = -1
C
      IF(ITIM .GE. 0)
     C   THEN
            ITIMES(1) = ITIM - 3
            IF(ITIMES(1) .LT. 0) ITIMES(1) = 21
            ITIMES(2) = ITIM + 2
         ELSE
            ITIMES(1) = 0
            ITIMES(2) = 24
         END IF
C
C
C     WORKING POINTER IS SET TO START OF 'MIMIMJMJ' LINE.
C
      IPT = IMI
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN TO
C     ERROR FILE.
C
      IHEAD = 0
C
C     SET DATA BASE REPORT TYPE INDICATORS IN DECODED REPORT HEADER
C     AND PART OF REPORT INDICATOR.
C
C     DATA BASE REPORT TYPE  : 32 = PILOT
C                              33 = PILOT SHIP
C
C     PART INDICATOR         : 1 = PART A
C                              2 = PART B
C                              3 = PART C
C                              4 = PART D
C
C
C
  101 K = IPT + 15
C
C     CHECK IF LAND STATION ( 'MIMI' = PP )
C
      DO 200 I = IPT,K
         IF ( KCHAR(I).EQ.80.AND.KCHAR(I+1).EQ.80)
     C        THEN
                  KDEC(4) = 32
                  IPT = I
                  GO TO 600
              END IF
  200 CONTINUE
C
C
C     CHECK IF SHIP REPORT ( 'MIMI' = QQ ), ALSO CHECK IF THIS
C     IS SHIP WITH NAME STARTING QQ (LIKE UUQR), BY CHECKING
C     IF THERE IS AN OTHER GROUP QQ--.
C
      DO 300 II = IPT,K
         IF( KCHAR(II) .EQ. 81 .AND. KCHAR(II+1) .EQ. 81 )
     C        THEN
                  KDEC(4) = 33
C
                  DO 310 J=II+2,K
                  IF ( KCHAR(J) .EQ. 81 .AND. KCHAR(J+1) .EQ. 81)
     C               THEN
                        IPT = J
                        I = J
                        GO TO 600
                     END IF
310               CONTINUE
C
                  IPT = II
                  I = II
                  GO TO 600
              END IF
300   CONTINUE
C
C
C     INVALID 'MIMI'.WRITE REPORT TO ERROR FILE.
C
  500 KCHAR(IPT) = KCHAR(IPT).OR.128
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
      IF(IEQ .GT. IGS) RETURN
C
C     SEE IF REPORT TOO SHORT
C
      ILN = IEQ - IPT
      IF(ILN .LT. 17) GO TO 1500
C
      KDEC(4) = 32
      CALL SAVREP ( IHEAD,IERR )
c
      isaverr = ierr
      ierr = 0
      kerr = 1
c
      numrep(7) = numrep(7) + 1
c
      GO TO 1500
C
C
C     IDENTIFY PART OF REPORT.
C
  600 KDEC(23) = 0
      IF (KCHAR(I+2).EQ.65.OR.KCHAR(I+3).EQ.65) KDEC(23) = 1
      IF (KCHAR(I+2).EQ.66.OR.KCHAR(I+3).EQ.66) KDEC(23) = 2
      IF (KCHAR(I+2).EQ.67.OR.KCHAR(I+3).EQ.67) KDEC(23) = 3
      IF (KCHAR(I+2).EQ.68.OR.KCHAR(I+3).EQ.68) KDEC(23) = 4
C
      K = KDEC(23) + 1
C
C
C     LOCATE END OF REPORT AND INCREMENT COUNT.
C
C
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
      IF(IEQ .GT. IGS) RETURN
C
C
C     CHECK IF = - SIGN IS MISSING,TRYING TO FIND NEXT
C     PPAA, PPBB, PPCC, PPDD GROUP.
C
      CALL NEXTMI(IPT,IEQ,IIPT)
      IF(IIPT .LT. IEQ) IEQ= IIPT
C
      NUMREP(K+5) = NUMREP(K+5) + 1
C
C
      GO TO (500,700,900,1100,1300) K
C
C
C     DECODE PILOT REPORT PART A.
C
 700  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UPINT(IHEAD,IERR)
c
      isaverr = ierr
C
C
      IF(KERR .NE. 0) GO TO 1500
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UPDEC(IHEAD,IERR)
      GO TO 1500
C
C
C     DECODE PILOT REPORT PART B.
C
 900  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UGINT ( IHEAD,IERR )
c
      isaverr = ierr
C
C
      IF ( KERR.NE.0 ) GO TO 1500
C
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UGDEC ( IHEAD,IERR )
      GO TO 1500
C
C
C     DECODE PILOT REPORT PART C.
C
 1100 CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UHINT ( IHEAD,IERR )
c
      isaverr = ierr
C
      IF ( KERR.NE.0 ) GO TO 1500
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UHDEC ( IHEAD,IERR )
      GO TO 1500
C
C
C     DECODE PILOT REPORT PART D.
C
 1300 CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UQINT ( IHEAD,IERR )
c
      isaverr = ierr
C
      IF ( KERR.NE.0 ) GO TO 1500
C
C
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UQDEC ( IHEAD,IERR )
      GO TO 1500
c
C
C
C     LOCATE START OF NEXT REPORT.
C
C
 1500 if (kerr .eq. 1 .or. kerr .eq. 2) inil = inil + 1
c
      if(isaverr.ne.0) numreperr = numreperr + 1
      isaverr = 0
      kerr = 0
      ierr = 0
c
      IPT = IEQ + 1
      CALL NEXTPRT ( IPT,IGS )
c
C
C
C
C     CHECK FOR END OF BULLETIN.
C
C
      IF ( IPT.GE.IGS )
     C    THEN
C             END OF BULLETIN , SO IF ANY REPORT HAS BEEN WRITTEN TO
C             ERROR FILE , ADD 'GS' CHARACTER BEFORE RETURNING.
C
              IF ( IHEAD.EQ.0 ) RETURN
              IHEAD = 2
              CALL SAVREP ( IHEAD,IERR )
C
              RETURN
          END IF
C
C
C
C     RESET REPORTS DATA BASE TYPE AND REPORT PART INDICATORS.
C
C
      KDEC(23) = 0
      KDEC(4) = 0
C
C     SEARCH THE BEGINNING OF NEXT REPORT AND CHANGE THE POINTER IMI
C
      NPT = IEQ
      CALL NEXTLET(NPT,IGS)
      IF(NPT .GE. IGS) RETURN
      IMI = NPT
      CALL NEXTEND(NPT,IGS)
      IF(NPT .GE. IGS) RETURN
      JMI = NPT
C
      GO TO 101
C
      END
      
      
      SUBROUTINE UGDEC ( IHEAD,IERR )
C
C**** *UGDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE PILOT REPORT PART B FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT.
C**   INTERFACE.
C     ----------
C
C         *CALL* *UGDEC(IERR)*
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C         OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  MAY -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU /0/
      DATA IPRNUM /0/
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP FLAGS AND POINTERS.
C                --------------------------
 100  CONTINUE
C
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
C
      DO 1 I=25,600
      KDEC(I)=MINDIC
1     CONTINUE
C       *************************************
C       *                                   *
C       *             SECTION 1             *
C       *                                   *
C       *   (IDENTIFICATION AND POSITION)   *
C       *************************************
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C*     DAY AND TIME
C
C
      IF(KINT(2).LT.0.OR.KINT(2).GT.23) THEN
                                           RETURN
                                        END IF  
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C     CHECK IF SHIP PILOT
C
C
      IF(KDEC(4) .EQ. 33)
     1           THEN
C
C                   LAT & LONG
C
                    CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1                          KDEC(5),KDEC(6))
C
                    IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC) RETURN
C
C                   ALTIT=0, FOR SEA STATION
C
                    KDEC(8)=0
C
                 END IF
C
C
C
C
C
101   CONTINUE
C
C***  IDENT   STATION/SHIP IDENTIFICATION
C             IN KINT(12) - KINT(16)
C
C
      KDEC(7)=88
C
C
C
C***  INSTRUMENT SPECCIFICATION
C
      kdec(13)=9
      if(kint(3).ne.mindic) kdec(13)=kint(3)
C
C
C***  REPORT LENGTH
C
      KDEC(24)=384
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LE. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
      IROU = IROU +1
C
4000  CONTINUE

C       *********************************************************
C       *                                                       *
C       *                      SECTION 3                        *
C       *                                                       *
C       *       (FIXED LEVELS AND/OR SIGNIFICANT LEVELS)        *
C       *********************************************************
C ----- FIXED LEVELS  ----------------------------------------
C
         IPOS = 22
C
C -----  LOOP OVER 20 POSSIBLE SETS OF LEVELS
C
         DO 4200 I=1,20
         IND = 17 + (I-1)*11
         IBASE = 0
         IF(KINT(IND) .EQ. 9)
     C      THEN
               IREF = 300
            ELSE
               IF(KINT(IND) .EQ. 8)
     C            THEN
                     IREF = 500
                  ELSE
                     IF(KINT(IND) .EQ. 1)
     C                  THEN
                           IREF = 300
                           IBASE = 30000
                        ELSE
                           GO TO 4200
                        END IF
                  END IF
            END IF
C
         IF(KINT(IND+1).EQ.MINDIC) GO TO 4200 
         ITENS = KINT(IND+1) * 10
         IF(ITENS .LT. 0 .OR. ITENS .GT. 90) GO TO 4200
C
C
C -----     LOOP OVER 3 POSSIBLE LEVELS IN THE SET
C
            DO 4100 J=1,3
            IND2 = IND + 5 + (J-1)*2
C
C           IF FIRST LEVEL AND 'H = /' THIS IS SURFACE
C
            IF(KINT(IND+1+J) .EQ. MINDIC .AND. I .EQ. 1 .AND.
     C         J .EQ. 1) KINT(IND+1+J) = 0
C
            IF(KINT(IND+1+J) .EQ. MINDIC .OR. KINT(IND2) .EQ. MINDIC
     C         .OR. KINT(IND2+1) .EQ. MINDIC) GO TO 4100
C
            IHIGH = IBASE + (ITENS + KINT(IND+J+1)) * IREF
C
               DO 4050 II = IPOS,22,-3
               IF(KDEC(II) .NE. MINDIC .AND. IHIGH .LT. KDEC(II))
     C           GO TO 4300
4050           CONTINUE
C
            IPOS = IPOS + 3
            KDEC(IPOS) = IHIGH
            CALL DDFFF(KINT(IND2),KINT(IND2+1),IWW,K,MINDIC,
     C                 KDEC(IPOS+1),KDEC(IPOS+2))
4100        CONTINUE

4200     CONTINUE

4300     CONTINUE
C
C ----- SIGNIFICANT  LEVELS  ------------------------------------------
C
         LEVNUM = 0
C
         IF(KINT(237) .NE. 21212) GO TO 9900
C
            DO 4500 J=1,60
            IND = 239 + (J-1)*4
            IF(KINT(IND) .EQ. MINDIC) GO TO 4500
C
            LEVNUM = LEVNUM + 1
            IPOS = 205 + (LEVNUM-1)*3
C
C****       NN PPP   PRESSURE AT THE LEVEL
C
            KDEC(IPOS) = KINT(IND) * 10
C
C           CHECK IF THOUSAND DIGIT IS OMITTED
C
            IF(KDEC(IPOS) .LE. 2000)
     C         THEN
                  IF(LEVNUM .EQ. 1) KDEC(IPOS) = KDEC(IPOS) + 10000
C
                  IF(LEVNUM .GT. 1 .AND. LEVNUM .LE. 4)
     C               THEN
C
C                       CHECK IF PREVIOUS LEVEL IS > 1000MB
C                       AND IF IT IS LOWER THAN THIS ONE
C
                        IF(KDEC(IPOS-3) .GT. 10000)
     C                     THEN
                              IF( (KDEC(IPOS-3)-10000) .GT. KDEC(IPOS))
     C                            KDEC(IPOS) = KDEC(IPOS) + 10000
                           END IF
                     END IF
               END IF
C
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IPOS) .GE. KDEC(IPOS-3) .AND.
     C               KDEC(IPOS-3) .NE. MINDIC)
     C               THEN
                        KDEC(IPOS) = MINDIC
                        LEVNUM = LEVNUM - 1
                        GO TO 4500
                     END IF
               END IF
C
C****       DD FFF   WIND AT THE LEVEL
C
            CALL DDFFF(KINT(IND+1),KINT(IND+2),IWW,K,MINDIC,
     C                 KDEC(IPOS+1),KDEC(IPOS+2))
C
4500        CONTINUE

C       ***********************************************
C       *                 SECTION 9                   *
C       *                                             *
C       *              (REGIONAL DATA)                *
C       ***********************************************

C ------  NO REGIONAL DATA HANDLED  -----------------------------
C
C
C
9900  CONTINUE
C
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 460 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 460
      NIL2 = 0
      GO TO 465
460   CONTINUE
C
465   CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF
C
C
9950  CONTINUE
C
C==========================================================
C====    PRINTING OF ERRORS & REPORTS & KINT & KDEC    ====
C==========================================================
C
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 700 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
700   CONTINUE
C
      DO 710 I=1,100
      IF(ISTA .EQ. ISTASB(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
710   CONTINUE
C
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLB .GT. 0) IPRI = 1
C
      IF(KDEC(2) .LT. ITIMES(1) .OR. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
      IF(IPRALLB .EQ. 1)
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
C
C
      IF(IPRNUM .GT. IPRLIM) GO TO 99800
C
      IPRI = 0
C
      IF(IPRI .GT. 0)
     C   THEN
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IPRNUM=IPRNUM+1
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        IPRNUM=IPRNUM+1
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKINT(KINT,1,600,MINDIC)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(1H ,///)
20000 FORMAT(1H ,/////2X,' PART B  NUMBER =',I5,/)
C
99800 CONTINUE
C
c      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL PILOEXP( 2,IERR )
      CALL MRGPIL( IERR )
      CALL QCPILOT(kdec(4),IERR )
      CALL BUFRENC( IERR )
C
      IERR=0
C
99900 CONTINUE
      RETURN
      END
      
      SUBROUTINE UGINT ( IHEAD,IERR )
C
C**** *UGINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT PILOT REPORTS PART B FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C                     IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE.
C                           = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                     IERR NOT USED ON INPUT.
C
C         OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                     DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UGINT ( IHEAD,IERR )*
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF PILOT).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOVEMBER  -84.
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
C
      DIMENSION IREG(9),INAT(9)
      DATA IREG /
     C    51515, 52525, 53535, 54545, 55555, 56565, 57575, 58585, 59595/
      DATA INAT /
     C    61616, 62626, 63636, 64646, 65656, 66666, 67676, 68686, 69696/
C
C     ------------------------------------------------------------------
C           1.  CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C               -------------------------------------------------------
C               CHARACTER OF REPORT.
C               --------------------
 100  CONTINUE
C
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      MODIFY = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      INDH = 0
      INDP = 0
      INDLEV = 0
      LEVNUM = 0
      IREMPOS = 17
C
C
C***
C*    CHECK FOR 'NIL' REPORT.
C***
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.25 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(8,0,IFIRST,NUMERR)
             KERR = 0
         END IF
C
C
C
C***
C*     SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C***
C
      DO 200 I=1,600
         KINT(I) = MINDIC
  200 CONTINUE
C
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 300 I=12,14
         KINT(I) = 88
  300 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C***
C*    CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C***
C
      DO 400 I=1,3
         KDEC(I) = MINDIC
  400 CONTINUE
C
      DO 500 I=5,9
         KDEC(I) = MINDIC
  500 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = KDEC(15).AND.4
C
      KDEC(17) = MINDIC
      KDEC(22) = MINDIC
C
C
C
1000  CONTINUE
C
C
C   ***********************************************************
C   *                      SECTION 1                          *
C   *                                                         *
C   *     (IDENTIFICATION AND POSITION, THIS IS DIFFERENT     *
C   *      FOR LAND STATIONS AND SHIP REPORTS)                *
C   ***********************************************************
C               YY GG /
C               -- -- -
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*10000)
                CALL NEXPRT2(IPT,IEQ,*10000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1                .AND. (KCHAR(IPT) .LE. 56))
     2                 CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
                IF(KINT(1).LE.0.AND.KINT(1).GT.31) THEN
                   KERR=1
                   GO TO 10000
                END IF
C
                JPT = IPT

  700 IF ( KDEC(4).EQ.32 )
     C      THEN
C
C               LAND STATION
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*701)
                GO TO 702
C
 701            CONTINUE
C           
                KERR=2
                GO TO 10000
C
 702            CONTINUE
C 
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .eq. 0)
     C              THEN
                       IF(NIL .EQ. 1)
     C                    THEN
                             KDEC(20)=1
                             kerr=1
                             RETURN
                          END IF
                    END IF
C
                IF ( IRET.EQ.1 )
     C              THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(8,1,IFIRST,NUMERR)
C
C
                        GO TO 10000
                    END IF
C
                IF ( IRET.EQ.2 )
     C             THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2

                        CALL ERRSTA(8,2,IFIRST,NUMERR)
C
                        GO TO 10000
                    END IF
C
C
                 IF(IRET .EQ. 3)
     1              THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
                      CALL ERRSTA(8,2,IFIRST,NUMERR)
C
                      GO TO 10000
                   END IF
C
            ELSE
C
C                PILOT SHIP
C
                 IF(KDEC(4) .EQ. 33)
     1              THEN
C
                        KINT(4)=0
                        
C                       RETAIN POINTER TO STATION IDENTIFIER .
C
                        KPT=IMI
C
C
C                       CHECK THE CALL SIGN
C
                        IBUOY = 0
                        K = IMI
                        J = K + 4
C
                        DO 750 I=K,J
                        IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750                   CONTINUE
C
C
C                       IF A LETTER GROUP IS FOUND CHECK THAT THIS IS
C                       NOT MIMIMJMJ GROUP 'QQBB'. IN THIS CASE THE SHIP
C                       CALL SIGN GROUP IS PRESUMED MISSING.
C
                        IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85)
     C                  .AND.
     C                  (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                      THEN
                               IBUOY = 2
                            END IF
C
C
                        IF(IBUOY .NE. 0)
     C                     THEN
C
C                             SHIP,RIG OR PLATFORM. IDENTIFIER
C                             NUMBER SET TO 0.
C
C
                         ID=0
                              KINT(4) = 0
C
                              IF (IBUOY.EQ.1)
     C                           THEN
C
C                                   MOVE POINTER PAST CALL SIGN . THE
C                                   FIRST CHARACTER OF THE NEXT GROUP IS
C                                   LOCATED AS SOME SHIPS USE THE FULL
C                                   NAME ( WHICH CAN CONSIST OF 2 WORDS
C                                   INSTEAD OF CALL SIGN. SO IF THE NEXT
C                                   GROUP DOESN'T START WITH 'QQ' (WHICH
C                                   IS THE BEGINNING OF MIMIMJMJ GROUP)
C                                   IT MUST BE PART OF THE SHIP'S NAME
C                                   USED INSTEAD OF CALL SIGN.
C
                                    IIPT=K
                                    CALL NEXSEP2(IIPT,IEQ,*10000)
                                    ID = IIPT - KPT
                                    CALL NEXTLET (IIPT,IEQ)
C
                                    IF(KCHAR(IIPT) .NE. 81 .OR.
     C                                 KCHAR(IIPT+1) .NE. 81)
     C                                 THEN
                                          CALL NEXSEP2(IIPT,IEQ,*10000)
                                          ID = IIPT - K
                                       END IF
C
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*10000)
                             CALL NEXPRT2(IIPT,IEQ,*10000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*10000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*10000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*10000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR = 4
                              CALL ERRSTA(8,1,IFIRST,NUMERR)
                              GO TO 10000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR=4
                              CALL ERRSTA(8,2,IFIRST,NUMERR)
                              GO TO 10000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*10000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                               LAT,LON)
C
                        CALL MARDSEN(LAT,LON,KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
C
                               KERR = 4
                               CALL ERRSTA(8,1,IFIRST,NUMERR)
C
                               GO TO 10000
C
                            END IF
C
                    ELSE
C
C                       THIS IS NOT A PILOT REPORT
C
                        KERR = 3
                        CALL ERRSTA(8,1,IFIRST,NUMERR)
C
                        GO TO 10000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4) .EQ. 33 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KERR = 3
                       CALL ERRSTA(8,1,IFIRST,NUMERR)
                       GO TO 10000
C
                   END IF
           END IF
           
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
       IF(NIL .EQ. 1) RETURN

4000  CONTINUE
C
C   ********************************************************
C   *                     SECTION 4                        *
C   *                                                      *
C   *   (FIXED REGIONAL LEVELS AND/OR SIGNIFICANT LEVELS   *
C   ********************************************************
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 21212) GO TO 4500
C
      DO 4050 I = 1 , 9
      IF(IVAL .EQ. IREG(I)) GO TO 10000
      IF(IVAL .EQ. INAT(I)) GO TO 10000
4050  CONTINUE

C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL .EQ. 9 .OR. IVAL .EQ. 8)
     C   THEN
C
C****        9/8/1 TN U1 U2 U3  ......  TENS & UNITS DIGITS OF ALTITUDE
C            - - - -- -- -- --
C
            INDLEV = INDLEV + 1
            IPOS = 17 + (INDLEV-1)*11
C
C
            CALL EXTGRP(IPT,1,1,1,1,1,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(8,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*10000)
                  CALL NEXPRT2(IPT,IEQ,*10000)
                  GO TO 4000
               END IF
C
C
C
            N = KINT(IPOS+1)
C
C
C              SEE HOW MANY WIND GROUPS THERE ARE.  THERE ARE SUPPOSED
C              TO BE ONLY THREE WIND GROUPS (MAX) AFTER 'ID-GROUP'
C              44NP1P1 / 55NP1P1.  HOWEVER QUITE A COMMON PRACTICE
C              IS TO HAVE THE ID-GROUP ONLY ONCE AND ALL THE WIND-GROUPS
C              AFTER THIS.  THEREFORE THIS PRACTICE IS ALSO ACCEPTED
C              ASSUMING DATA ARE CORRECT.
C
               NUMBER = 0
               DO 4100 I = 1,3
               IF(NUMBER .GT. 0 .AND. KINT(IPOS+I+1) .LT. KINT(IPOS+I))
     C         GO TO 4100
               IF(KINT(IPOS+I+1) .NE. MINDIC) NUMBER = I
4100           CONTINUE
C
C
               IPOS = 22 + (INDLEV-1) * 11
C
C****          DD FFF   .......  WIND DIRECTION & SPEED
C              -- ---
C
               DO 4200 I=1,NUMBER
               IPOS2 = IPOS + (I-1)*2
               CALL NEXPRT2(IPT,IEQ,*10000)
               CALL EXTVAL(IPT,1,IVAL)
               IF(IVAL .EQ. 9 .OR. IVAL .EQ. 8) GO TO 4000
C
               CALL EXTVAL(IPT,5,IVAL)
               DO 4130 J=1,9
                  IF(IVAL .EQ. IREG(J)) GO TO 10000
                  IF(IVAL .EQ. INAT(J)) GO TO 10000
4130           CONTINUE
C
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS2,IRET)
C
               IF ( (IRET .NE. 0)  .OR. (KINT(IPOS2) .GT. 36 .AND.
     C            KINT(IPOS2) .NE. MINDIC) )
     C               THEN
                        KERR = 7
C
                        CALL ERRSTA(8,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS2
C
                        DO 4150 J = IPOS2,IPOS2+1
                        KINT(J) = MINDIC
4150                    CONTINUE
                        CALL NEXSEP2(IPT,IEQ,*10000)
                        CALL NEXPRT2(IPT,IEQ,*10000)
                        IF(I .EQ. NUMBER) GO TO 4000
                     END IF
C
4200           CONTINUE
C
         ELSE
            GO TO 4900
         END IF
C
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 4000
C
C****  21212  ......  SIGNIFICANT LEVEL INDICATOR
C      -----
C
C
4500  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      IPOS = 237
      CALL EXTGRP(IPT,5,0,0,0,0,IPOS,IRET)
      IF (IRET .NE. 0)
     C   THEN
            KERR = 10
C
            CALL ERRSTA(8,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
            GO TO 4900
         END IF

4600  CONTINUE
C
C
C**** NINI PIPIPI  ......  PRESSURE AT SIGNIFICANT LEVEL
C     ---- ------
C
C
      LEVNUM = LEVNUM + 1
      IPOS = 238 + (LEVNUM-1) * 4
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
C     CHECK IF THIS REALLY IS THE NEXT LEVEL
C
      IF(KCHAR(IPT) .NE. KCHAR(IPT+1)) GO TO 4900
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
      IF (IRET .NE. 0)
     C   THEN
            KERR = 5
            CALL ERRSTA(8,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
C
            GO TO 4700
         END IF
C
C
C**** DD FFF  ......  WIND AT SIGNIFICANT LEVEL
C     -- ---
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C   THEN
            KERR = 7
C
            CALL ERRSTA(8,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            DO 4650 J = IPOS,IPOS+3
            KINT(J) = MINDIC
4650        CONTINUE
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
            GO TO 4600
         END IF
C
C
      GO TO 4600

4700  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      IF(KCHAR(IPT) .EQ. KCHAR(IPT+1)) GO TO 4600
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 4700
C
C
C
4900  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,5,IVAL)
C
      IF(IVAL .EQ. 21212) GO TO 4500
C
      DO 5000 I = 1 , 9
      IF(IVAL .EQ. IREG(I)) GO TO 10000
      IF(IVAL .EQ. INAT(I)) GO TO 10000
5000  CONTINUE
C
      CALL EXTVAL(IPT,1,IVAL)
      IF( IVAL .EQ. 9 .OR. IVAL .EQ. 8) GO TO 4000
C
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 4900
C

10000 CONTINUE
C
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
C
C
                             IPT = KEEP
                             CALL FIXPILO
                             IFIRST=1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 6000 I = IREMPOS,600
                                   KINT(I) = MINDIC
6000                               CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR = 0
                             if(kerr.gt.4) then
                                kerr = 0
c                               ierr = 0
                             end if
c
                          END IF

C
      RETURN
      END
      
      SUBROUTINE UHDEC ( IHEAD,IERR )
C
C**** *UHDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE PILOT REPORT PART C FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT.
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C         OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UHDEC ( IHEAD,IERR )*
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  MAY -84
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DIMENSION LEVSTAN(5)
C
      DATA LEVSTAN / 70, 50, 30, 20, 10/
C
C
      DATA IROU /0/
      DATA IPRNUM /0/
C
C     ------------------------------------------------------------------
C
C*          1.  DEFINE INDICATORS AND CLEAR FLAGS.
C                ---------------------------------
 100  CONTINUE
C
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C
C*    SET DECODED REPORT TO MISSING DATA VALUE
C
C
      DO 1 I=25,600
      KDEC(I)=MINDIC
1     CONTINUE

C       *************************************
C       *                                   *
C       *             SECTION 1             *
C       *                                   *
C       *   (IDENTIFICATION AND POSITION)   *
C       *************************************

C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C
C
C
C***   DAY AND TIME
C
C
      IF(KINT(2).LT.0.OR.KINT(2).GT.23) THEN
                                           RETURN
                                        END IF  
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C***
C*    CHECK IF SHIP PILOT
C***
C
      IF(KDEC(4) .EQ. 33)
     1           THEN
C
C***                LAT & LONG
C
                    CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1                          KDEC(5),KDEC(6))
                    IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC) RETURN
C
C***                ALTIT=0, FOR SEA STATION
C
                    KDEC(8)=0
C
                 END IF
C
C
 101  CONTINUE
C
C***  IDENT   STATION/SHIP IDENTIFICATION
C
C
      KDEC(7)=88
C
C
C
C***  INSTRUMENT SPECCIFICATION
C
      kdec(13)=9
      if(kint(3).ne.mindic) kdec(13)=kint(3)
C
C
C***  REPORT LENGTH
C
C
      KDEC(24)=384
C
C
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF

C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LE. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
C
      IROU = IROU +1
C
2000  CONTINUE
c       ************************************************
C       *                                              *
C       *                SECTION 2                     *
C       *                                              *
C       *       (STANDARD ISOBARIC SURFACES)           *
C       ************************************************
C
C
         DO 2500 I = 1,3
         IND = 17 + (I-1)*9
         IF(KINT(IND) .EQ. 44 .OR. KINT(IND) .EQ. 55)
     C      THEN
C
C              NUMBER OF LEVELS IN THIS GROUP
C
               NUMBER = KINT(IND+1)
C
C              GET THE FIRST LEVEL OF THE GROUP
C
                  DO 2100 J=1,5
                  IF(KINT(IND+2) .EQ. LEVSTAN(J))
     C               THEN
                        INDLEV = J
                        IPOS = 25 + (J-1)*3
                        GO TO 2200
                     END IF
2100              CONTINUE
C
               GO TO 2500
C
2200           CONTINUE
C
                  DO 2300 J = 1,NUMBER
                  IF( (INDLEV+J-1) .GT. 5) GO TO 2500
                  IND2 = IND + 3 + (J-1)*2
                  KDEC(IPOS) = LEVSTAN(INDLEV+J-1) * 10
                  CALL DDFFF(KINT(IND2),KINT(IND2+1),IWW,K,MINDIC,
     C                       KDEC(IPOS+1),KDEC(IPOS+2))
                  IF(KDEC(IPOS+1) .EQ. MINDIC .OR. KDEC(IPOS+2) .EQ.
     C               MINDIC) KDEC(IPOS) = MINDIC
                  IPOS = IPOS + 3
2300              CONTINUE
C
            END IF
C
2500     CONTINUE

C       *******************************************************
C       *                                                     *
C       *                     SECTION 3                       *
C       *                                                     *
C       *   (MAXIMUM WIND LEVEL(S) AND VERTICAL WIND SHEAR)   *
C       *******************************************************
C
C
3000  CONTINUE
C
C
C -----  BY MEANS OF PRESSURE  -------------------------------------
C
C
         DO 3100 I=1,3
         IND = 44 + (I-1)*7
         IF(KINT(IND) .NE. 77 .AND. KINT(IND) .NE. 66) GO TO 3100
         IF(KINT(IND + 1) .EQ. 999) GO TO 3200
C
         IPOS = 52 + (I-1)*5
         IF(KINT(IND+1) .NE. MINDIC)
     C      THEN
               KDEC(IPOS) = KINT(IND+1)
               CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     C                    KDEC(IPOS+1),KDEC(IPOS+2))
C
               IF(KINT(IND+4) .EQ. 4)
     C            THEN
                     KDEC(IPOS+3) = KINT(IND + 5)
                     KDEC(IPOS+4) = KINT(IND + 6)
                  END IF
C
               IF(  ( KDEC(IPOS+1) .EQ. MINDIC .OR.
     C                KDEC(IPOS+2) .EQ. MINDIC   )
     C                       .AND.
     C              ( KDEC(IPOS+3) .EQ. MINDIC .OR.
     C                KDEC(IPOS+4) .EQ. MINDIC   )   )
     C                KDEC(IPOS) = MINDIC
C
            END IF
3100     CONTINUE
C
C
3200     CONTINUE
C
C
C -----  BY MEANS OF GEOPOTENTIAL  --------------------------------
C
         DO 3500 I=1,3
C
         IND = 65 + (I-1)*7
         IF(KINT(IND) .NE. 7 .AND. KINT(IND) .NE. 6) GO TO 3500
         IF(KINT(IND + 1) .EQ. 999) GO TO 3600
C
         IPOS = 67 + (I-1)*5
         IF(KINT(IND+1) .NE. MINDIC)
     C      THEN
               KDEC(IPOS) = KINT(IND+1) * 10
C
               CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     C                    KDEC(IPOS+1),KDEC(IPOS+2))
C
               IF(KINT(IND+4) .EQ. 4)
     C            THEN
                     KDEC(IPOS+3) = KINT(IND + 5)
                     KDEC(IPOS+4) = KINT(IND + 6)
                  END IF
C
               IF(  ( KDEC(IPOS+1) .EQ. MINDIC .OR.
     C                KDEC(IPOS+2) .EQ. MINDIC   )
     C                       .AND.
     C              ( KDEC(IPOS+3) .EQ. MINDIC .OR.
     C                KDEC(IPOS+4) .EQ. MINDIC   )   )
     C                KDEC(IPOS) = MINDIC
C
            END IF
3500     CONTINUE
C
C
C
3600     CONTINUE

C       ***********************************************
C       *                 SECTION 9                   *
C       *                                             *
C       *              (REGIONAL DATA)                *
C       ***********************************************
C
C
C ------  NO REGIONAL DATA HANDLED  -------------------------------
C
9900  CONTINUE
C
C
C
C
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 460 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 460
      NIL2 = 0
      GO TO 465
460   CONTINUE
C
465   CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF

C==========================================================
C====    PRINTING OF ERRORS & REPORTS & KINT & KDEC    ====
C==========================================================
C
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 700 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
700   CONTINUE
C
      DO 710 I=1,100
      IF(ISTA .EQ. ISTASA(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
710   CONTINUE
C
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLC .GT. 0) IPRI = 1
C
      IF(KDEC(2) .LT. ITIMES(1) .OR. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
      IF(IPRALLC .EQ. 1)
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
C
C
      IF(IPRNUM .GT. IPRLIM) GO TO 99800
C
      IPRI = 0
C
      IF(IPRI .GT. 0)
     C   THEN
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IPRNUM=IPRNUM+1
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        IPRNUM=IPRNUM+1
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKINT(KINT,1,600,MINDIC)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(1H ,///)
20000 FORMAT(1H ,/////2X,' PART C  NUMBER =',I5,/)
C
99800 CONTINUE
C
c      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL PILOEXP( 3,IERR )
      CALL MRGPIL( IERR )
      CALL QCPILOT( kdec(4),IERR )
      CALL BUFRENC( IERR )
      IERR=0
C
99900 CONTINUE
      RETURN
      END
      
      SUBROUTINE UHINT ( IHEAD,IERR )
C
C**** *UHINT*
C
C
C     PURPOSE.
C     --------
C
C          CONVERT PILOT REPORTS PART C FROM CCITT 5 CHARACTER
C          FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UHINT ( IHEAD,IERR )*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                     IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE.
C                           = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                     IERR NOT USED ON INPUT.
C
C         OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                     DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF PILOT).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *XXXX* *XXXXXXX(XXXX)*
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  NOVEMBER  -84.
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
C
C     ------------------------------------------------------------------
C           1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              -------------------------------------------------------
C              CHARACTER OF REPORT.
C              ---------------------
 100  CONTINUE
C
C
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      MODIFY = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      INDH = 0
      INDP = 0
      NUMSTAN = 0
      IREMPOS = 17
C
C
C***
C*    CHECK FOR 'NIL' REPORT.
C***
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.25 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(9,0,IFIRST,NUMERR)
             KERR = 0
         END IF
C
C
C
C***
C*     SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C***
C
      DO 200 I=1,600
         KINT(I) = MINDIC
  200 CONTINUE
C
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 300 I=12,14
         KINT(I) = 88
  300 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C***
C*    CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C***
C
      DO 400 I=1,3
         KDEC(I) = MINDIC
  400 CONTINUE
C
      DO 500 I=5,9
         KDEC(I) = MINDIC
  500 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = KDEC(15).AND.4
C
      KDEC(17) = MINDIC
C
      KDEC(22) = MINDIC
C
C
C
1000  CONTINUE

C   ***********************************************************
C   *                      SECTION 1                          *
C   *                                                         *
C   *     (IDENTIFICATION AND POSITION, THIS IS DIFFERENT     *
C   *      FOR LAND STATIONS AND SHIP REPORTS)                *
C   ***********************************************************
C
C
C               YY GG /
C               -- -- -

 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*10000)
                CALL NEXPRT2(IPT,IEQ,*10000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1                .AND. (KCHAR(IPT) .LE. 56))
     2                 CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
                IF(KINT(1).LE.0.AND.KINT(1).GT.31) THEN
                   KERR=1
                   GO TO 10000
                END IF
C
                JPT = IPT
C
  700 IF ( KDEC(4).EQ.32 )
     C      THEN
C
C               LAND STATION
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*701)
                GO TO 702
C
 701            CONTINUE
C      
                KERR=2
                GO TO 10000
C
 702            CONTINUE
C   
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .eq. 0)
     C              THEN
                       IF(NIL .EQ. 1)
     C                    THEN
                             KDEC(20)=1
                             kerr=1
                             RETURN
                          END IF  
                    END IF
C
                IF ( IRET.EQ.1 )
     C              THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(9,1,IFIRST,NUMERR)
C
C
                        GO TO 10000
                    END IF
C
                IF ( IRET.EQ.2 )
     C             THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2

                        CALL ERRSTA(9,2,IFIRST,NUMERR)
C
                        GO TO 10000
                    END IF
C
C
                 IF(IRET .EQ. 3)
     1              THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
                      CALL ERRSTA(9,2,IFIRST,NUMERR)
C
                      GO TO 10000
                   END IF
C
            ELSE
C
C                PILOT SHIP
C
                 IF(KDEC(4) .EQ. 33)
     1              THEN
C
                        KINT(4)=0
C
C
C
C                       RETAIN POINTER TO STATION IDENTIFIER .
C
                        KPT=IMI
C
C
C                       CHECK THE CALL SIGN
C
                        IBUOY = 0
                        K = IMI
                        J = K + 4
C
                        DO 750 I=K,J
                        IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750                   CONTINUE
C
C
C                       IF A LETTER GROUP IS FOUND CHECK THAT THIS IS
C                       NOT MIMIMJMJ GROUP 'QQBB'. IN THIS CASE THE SHIP
C                       CALL SIGN GROUP IS PRESUMED MISSING.
C
                        IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85)
     C                  .AND.
     C                  (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                      THEN
                               IBUOY = 2
                            END IF
C
C
                        IF(IBUOY .NE. 0)
     C                     THEN
C
C                             SHIP,RIG OR PLATFORM. IDENTIFIER
C                             NUMBER SET TO 0.
C
C
                         ID=0
                              KINT(4) = 0
C
                              IF (IBUOY.EQ.1)
     C                           THEN
C
C                                   MOVE POINTER PAST CALL SIGN . THE
C                                   FIRST CHARACTER OF THE NEXT GROUP IS
C                                   LOCATED AS SOME SHIPS USE THE FULL
C                                   NAME ( WHICH CAN CONSIST OF 2 WORDS
C                                   INSTEAD OF CALL SIGN. SO IF THE NEXT
C                                   GROUP DOESN'T START WITH 'QQ' (WHICH
C                                   IS THE BEGINNING OF MIMIMJMJ GROUP)
C                                   IT MUST BE PART OF THE SHIP'S NAME
C                                   USED INSTEAD OF CALL SIGN.
C
                                    IIPT=K
                                    CALL NEXSEP2(IIPT,IEQ,*10000)
                                    ID = IIPT - KPT
                                    CALL NEXTLET (IIPT,IEQ)
C
                                    IF(KCHAR(IIPT) .NE. 81 .OR.
     C                                 KCHAR(IIPT+1) .NE. 81)
     C                                 THEN
                                          CALL NEXSEP2(IIPT,IEQ,*10000)
                                          ID = IIPT - K
                                       END IF
C
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*10000)
                             CALL NEXPRT2(IIPT,IEQ,*10000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*10000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*10000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*10000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR = 4
                              CALL ERRSTA(9,1,IFIRST,NUMERR)
                              GO TO 10000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR=4
                              IF (IFIRST.EQ.0)
     C                           THEN
                                    CALL ERRSTA(9,2,IFIRST,NUMERR)
                                 END IF
                              GO TO 10000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*10000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                               LAT,LON)
                        CALL MARDSEN(LAT,LON,KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
                               KERR = 4
                               CALL ERRSTA(9,1,IFIRST,NUMERR)
C
                               GO TO 10000
C
                            END IF
C
                    ELSE
C
C                       THIS IS NOT A PILOT REPORT
C
                        KERR = 3
                        CALL ERRSTA(9,1,IFIRST,NUMERR)
C
                        GO TO 10000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF

C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4) .EQ. 33 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KERR = 3
                       CALL ERRSTA(9,1,IFIRST,NUMERR)
                       GO TO 10000
C
                   END IF
           END IF
C
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
C
C
      IPOS = 17
C
C
2000  CONTINUE
C
C   ************************************************
C   *                SECTION 2                     *
C   *                                              *
C   *         (STANDARD ISOBARIC SURFACES)         *
C   ************************************************
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,2,IVAL)
C
      IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55)
     C   THEN
C
C            44NP1P1 OR 55NP1P1  ....... NUMBER OF LEVELS AND THE
C            -------    -------  ....... PRESSURE ON FIRST ONE
C
            NUMSTAN = NUMSTAN + 1
            IPOS = 17 + (NUMSTAN-1)*9
C
C
            CALL EXTGRP(IPT,2,1,2,0,0,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(9,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*10000)
                  CALL NEXPRT2(IPT,IEQ,*10000)
                  GO TO 3000
               END IF
C
C
C           DD FFF   .......  WIND DIRECTION & SPEED
C           -- ---
C
            N = KINT(IPOS+1)
            IF(N .EQ. MINDIC .OR. N .EQ. 0) GO TO 3000
C
C
C
               DO 2500 I=1,N
               CALL NEXTPRT(IPT,IEQ)
               IF(IPT .GE. IEQ)
     C            THEN
                     KERR = 7
                     CALL ERRSTA(9,1,IFIRST,NUMERR)
                     GO TO 3000
                  END IF
C
               CALL EXTVAL(IPT,2,IVAL)
               IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55 .OR. IVAL .EQ. 66 .OR.
     C           IVAL .EQ. 77) GO TO 3000
C
               IPOS2 = IPOS + 3 + (I-1)*2
C
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS2,IRET)
C
               IF ( (IRET .NE. 0)  .OR. (KINT(IPOS2) .GT. 36 .AND.
     C            KINT(IPOS2) .NE. MINDIC) )
     C               THEN
                        KERR = 7
C
                        CALL ERRSTA(9,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                        DO 2400 J = IPOS2,IPOS2+1
                        KINT(J) = MINDIC
2400                    CONTINUE
                        CALL NEXSEP2(IPT,IEQ,*10000)
                        GO TO 2000
                     END IF
C
2500           CONTINUE
C
         END IF

3000  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,2,IVAL)
      CALL EXTVAL(IPT,1,IVAL2)
C
      IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55) GO TO 2000
      IF(IVAL .EQ. 66 .OR. IVAL .EQ. 77) GO TO 4000
      IF(IVAL2 .EQ. 6 .OR. IVAL2 .EQ. 7) GO TO 4500
C
      KERR = 5
      CALL ERRSTA(9,1,IFIRST,NUMERR)
      IREM = MAX0(IPOS,17)
      IF(NUMERR .EQ. 1) IREMPOS = IREM
C
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 3000

4000  CONTINUE
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 77999) GO TO 10000
C
C
C   ***************************************************
C   *                  SECTION 8                      *
C   *                                                 *
C   *     (MAX. WIND LEVELS & VERTICAL WIND SHEAR)    *
C   ***************************************************
C
      INDP = INDP + 1
C
C
C     77 PMPMPM   ......  PRESSURE AT THE LEVEL
C     -- ------
C
      IPOS = 44 + (INDP-1)*7
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
      IF(IRET .NE. 0)
     C    THEN
             KERR = 12
             CALL ERRSTA(9,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = 558
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     DMDM FMFMFM   ......  WIND DIRECTION & SPEED
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF(IRET .NE. 0 .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C                     KINT(IPOS+2) .NE. MINDIC))
     C    THEN
             KERR = 13
             CALL ERRSTA(9,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     4 VBVB VAVA   ......  VERTICAL WIND SHEAR
C     - ---- ----
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL .EQ. 4)
     C   THEN
            CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
            IF(IRET .NE. 0)
     C          THEN
                   KERR = 14
                   CALL ERRSTA(9,1,IFIRST,NUMERR)
                   IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                   CALL NEXSEP2(IPT,IEQ,*10000)
                   CALL NEXPRT2(IPT,IEQ,*10000)
                   GO TO 3000
                END IF
          END IF
C
      GO TO 3000

4500  CONTINUE
C
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 77999) GO TO 10000
C
C
      INDH = INDH + 1
      IPOS = 65 + (INDH-1)*7
C
C
C     7HMHMHM  OR  6HMHMHM   ......  GEOPOTENTIAL AT THE LEVEL
C     -------      -------
C
C
      CALL EXTGRP(IPT,1,4,0,0,0,IPOS,IRET)
      IF(IRET .NE. 0)
     C    THEN
             KERR = 12
             CALL ERRSTA(9,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     DMDM FMFMFM   ......  WIND IDRECTION & SPEED AT THE LEVEL
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C         THEN
                  KERR = 13
                  CALL ERRSTA(9,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  DO 4600 I = IPOS,IPOS+3
                  KINT(I) = MINDIC
4600              CONTINUE
                  CALL NEXSEP2(IPT,IEQ,*10000)
C
                  GO TO 3000
               END IF
C
C
C     4 VBVB VAVA   ......  VERTICAL WIND SHEAR AT THE LEVEL
C     - ---- ----
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL .EQ. 4)
     C   THEN
            CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
            IF(IRET .NE. 0)
     C          THEN
                   KERR = 9
                   CALL ERRSTA(9,1,IFIRST,NUMERR)
                   IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                   CALL NEXSEP2(IPT,IEQ,*10000)
                   CALL NEXPRT2(IPT,IEQ,*10000)
                   GO TO 3000
                END IF
          END IF
C
C
      GO TO 3000

10000 CONTINUE
C
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
C
C
                             IPT = KEEP
                             CALL FIXPILO
                             IFIRST=1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 6000 I = IREMPOS,600
                                   KINT(I) = MINDIC
6000                               CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR = 0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                             end if
c
                          END IF
      RETURN
      
      END
      
      SUBROUTINE UPDEC ( IHEAD,IERR )
C
C**** *UPDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE PILOT REPORT PART A FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UPDEC ( IHEAD,IERR )*
C            INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C            OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  MAY -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DIMENSION LEVSTAN(9)
C
      DATA LEVSTAN / 85, 70, 50, 40, 30, 25, 20, 15, 10 /
C
C
      DATA IROU /0/
      DATA IPRNUM /0/
C     ------------------------------------------------------------------
C*          1.   DEFINE INDICATORS AND FLAFS.
C                ----------------------------
 100  CONTINUE
C
C
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0

C***
C*    SET DECODED REPORT TO MISSING DATA VALUE
C***
C
      DO 1 I=25,600
      KDEC(I)=MINDIC
1     CONTINUE
C
C       *************************************
C       *                                   *
C       *             SECTION 1             *
C       *                                   *
C       *   (IDENTIFICATION AND POSITION)   *
C       *************************************
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C
C
C
C***   DAY AND TIME
C
C
      IF(KINT(2).LT.0.OR.KINT(2).GT.23) THEN
                                           RETURN
                                        END IF  
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C***
C*    CHECK IF SHIP PILOT
C***
C
      IF(KDEC(4) .EQ. 33)
     1           THEN
C
C***                LAT & LONG
C
                    CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1                          KDEC(5),KDEC(6))
                    IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC) RETURN
C
C***                ALTIT=0, FOR SEA STATION
C
                    KDEC(8)=0
C
                 END IF
C
101   CONTINUE
C
C***  IDENT   STATION/SHIP IDENTIFICATION
C
C
      KDEC(7)=88
C
C
C***  INSTRUMENT SPECCIFICATION
C
      kdec(13)=9
      if(kint(3).ne.mindic) kdec(13)=kint(3)
C
C
C
C***  REPORT LENGTH
C
C
      KDEC(24)=384
C
C
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LE. 0 .OR. KDEC(1) .GT. 31) RETURN
      IF(KDEC(2) .LT. 0 .OR. KDEC(2) .GT. 24) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
      IROU = IROU +1

2000  CONTINUE
C       ************************************************
C       *                                              *
C       *                SECTION 2                     *
C       *                                              *
C       *       (STANDARD ISOBARIC SURFACES)           *
C       ************************************************
C
C
         DO 2500 I = 1,3
         IND = 17 + (I-1)*9
         IF(KINT(IND) .EQ. 44 .OR. KINT(IND) .EQ. 55)
     C      THEN
C
C              NUMBER OF LEVELS IN THIS GROUP
C
               NUMBER = KINT(IND+1)
C
C              GET THE FIRST LEVEL OF THE GROUP
C
                  DO 2100 J=1,9
                  IF(KINT(IND+2) .EQ. LEVSTAN(J))
     C               THEN
                        INDLEV = J
                        IPOS = 25 + (J-1)*3
                        GO TO 2200
                     END IF
2100              CONTINUE
C
               GO TO 2500
C
2200           CONTINUE
C
                  DO 2300 J = 1,NUMBER
                  IF( (INDLEV+J-1) .GT. 9) GO TO 2500
                  IND2 = IND + 3 + (J-1)*2
                  KDEC(IPOS) = LEVSTAN(INDLEV+J-1) * 100
                  CALL DDFFF(KINT(IND2),KINT(IND2+1),IWW,K,MINDIC,
     C                       KDEC(IPOS+1),KDEC(IPOS+2))
                  IF(KDEC(IPOS+1) .EQ. MINDIC .OR. KDEC(IPOS+2) .EQ.
     C               MINDIC) KDEC(IPOS) = MINDIC
                  IPOS = IPOS + 3
2300              CONTINUE
C
            END IF
C
2500     CONTINUE

C       *******************************************************
C       *                                                     *
C       *                     SECTION 3                       *
C       *                                                     *
C       *   (MAXIMUM WIND LEVEL(S) AND VERTICAL WIND SHEAR)   *
C       *******************************************************
C
C
3000  CONTINUE
C
C
C -----  BY MEANS OF PRESSURE  -------------------------------------
C
C
         DO 3100 I=1,3
         IND = 44 + (I-1)*7
         IF(KINT(IND) .NE. 77 .AND. KINT(IND) .NE. 66) GO TO 3100
         IF(KINT(IND + 1) .EQ. 999) GO TO 3200
C
         IPOS = 52 + (I-1)*5
         IF(KINT(IND+1) .NE. MINDIC)
     C      THEN
               KDEC(IPOS) = KINT(IND+1) * 10
               CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     C                    KDEC(IPOS+1),KDEC(IPOS+2))
C
               IF(KINT(IND+4) .EQ. 4)
     C            THEN
                     KDEC(IPOS+3) = KINT(IND + 5)
                     KDEC(IPOS+4) = KINT(IND + 6)
                  END IF
C
               IF(  ( KDEC(IPOS+1) .EQ. MINDIC .OR.
     C                KDEC(IPOS+2) .EQ. MINDIC   )
     C                       .AND.
     C              ( KDEC(IPOS+3) .EQ. MINDIC .OR.
     C                KDEC(IPOS+4) .EQ. MINDIC   )   )
     C                KDEC(IPOS) = MINDIC
C
            END IF
3100     CONTINUE
C
C
3200     CONTINUE
C
C
C -----  BY MEANS OF GEOPOTENTIAL  --------------------------------
C
         DO 3500 I=1,3
C
         IND = 65 + (I-1)*7
         IF(KINT(IND) .NE. 7 .AND. KINT(IND) .NE. 6) GO TO 3500
         IF(KINT(IND + 1) .EQ. 999) GO TO 3600
C
         IPOS = 67 + (I-1)*5
         IF(KINT(IND+1) .NE. MINDIC)
     C      THEN
               KDEC(IPOS) = KINT(IND+1) * 10
C
               CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     C                    KDEC(IPOS+1),KDEC(IPOS+2))
C
               IF(KINT(IND+4) .EQ. 4)
     C            THEN
                     KDEC(IPOS+3) = KINT(IND + 5)
                     KDEC(IPOS+4) = KINT(IND + 6)
                  END IF
C
               IF(  ( KDEC(IPOS+1) .EQ. MINDIC .OR.
     C                KDEC(IPOS+2) .EQ. MINDIC   )
     C                       .AND.
     C              ( KDEC(IPOS+3) .EQ. MINDIC .OR.
     C                KDEC(IPOS+4) .EQ. MINDIC   )   )
     C                KDEC(IPOS) = MINDIC
C
            END IF
3500     CONTINUE

3600     CONTINUE
C
C
C       ***********************************************
C       *                 SECTION 9                   *
C       *                                             *
C       *              (REGIONAL DATA)                *
C       ***********************************************

C ------  NO REGIONAL DATA HANDLED  -------------------------------
C
9900  CONTINUE

C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 460 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 460
      NIL2 = 0
      GO TO 465
460   CONTINUE
C
465   CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF

C==========================================================
C====    PRINTING OF ERRORS & REPORTS & KINT & KDEC    ====
C==========================================================
C
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 700 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
700   CONTINUE
C
      DO 710 I=1,100
      IF(ISTA .EQ. ISTASA(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
710   CONTINUE
C
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLA .GT. 0) IPRI = 1
C
      IF(KDEC(2) .LT. ITIMES(1) .OR. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
      IF(IPRALLA .EQ. 1)
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
C
C
      IF(IPRNUM .GT. IPRLIM) GO TO 99800
C
      IPRI = 0
C
      IF(IPRI .GT. 0)
     C   THEN
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IPRNUM=IPRNUM+1
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        IPRNUM=IPRNUM+1
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKINT(KINT,1,600,MINDIC)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(1H ,///)
20000 FORMAT(1H ,/////2X,' PART A  NUMBER =',I5,/)
C
99800 CONTINUE
C
c      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL PILOEXP( 1,IERR )
      CALL MRGPIL( IERR )
      CALL QCPILOT( kdec(4),IERR )
      CALL BUFRENC( IERR )
      IERR=0
C
99900 CONTINUE
      RETURN
      END
      
      SUBROUTINE UPINT(IHEAD,IERR)
C
C**** *UPINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT PILOT REPORTS PART A FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UPINT ( IHEAD,IERR )*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                      IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                                WRITTEN TO ERROR FILE.
C                            = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                      IERR NOT USED ON INPUT.
C
C           OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                       DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF PILOT).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C     AUTHOR.
C     -------
C
C
C          A. HOLOPAINEN  NOVEMBER -84.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
C
      DATA IROU /0/
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              -------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
 100  CONTINUE
C
C
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      MODIFY = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      INDH = 0
      INDP = 0
      NUMSTAN = 0
      IREMPOS = 17
      IROU = IROU + 1
C
C
C***
C*    CHECK FOR 'NIL' REPORT.
C***
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.25 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(7,0,IFIRST,NUMERR)
             KERR = 0
         END IF
C
C
C
C***
C*     SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C***
C
      DO 200 I=1,600
         KINT(I) = MINDIC
  200 CONTINUE
C
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 300 I=12,14
         KINT(I) = 88
  300 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C***
C*    CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C***
C
      DO 400 I=1,3
         KDEC(I) = MINDIC
  400 CONTINUE
C
      DO 500 I=5,9
         KDEC(I) = MINDIC
  500 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = KDEC(15).AND.4
C
      KDEC(17) = MINDIC
C
C
      KDEC(22) = MINDIC
C
C
1000  CONTINUE

C   ***********************************************************
C   *                      SECTION 1                          *
C   *                                                         *
C   *     (IDENTIFICATION AND POSITION, THIS IS DIFFERENT     *
C   *      FOR LAND STATIONS AND SHIP REPORTS)                *
C   ***********************************************************
C
C
C               YY GG /
C               -- -- -
C
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*10000)
                CALL NEXPRT2(IPT,IEQ,*10000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1                .AND. (KCHAR(IPT) .LE. 56))
     2                 CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
c
                IF(KINT(1).LE.0.AND.KINT(1).GT.31) THEN
                   KERR=1
                   GO TO 10000
                END IF
C
                JPT = IPT
C
C
C
C
  700 IF ( KDEC(4).EQ.32 )
     C      THEN
C
C               LAND STATION
C
C
C
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*701)
                GO TO 702
C
 701            CONTINUE
C
                KERR=2
                GO TO 10000
C
 702            CONTINUE       
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .eq. 0)
     C              THEN
                       IF(NIL .EQ. 1)
     C                    THEN
                             KDEC(20)=1
                             kerr=1
                             RETURN
                          END IF               
                    END IF
C
                IF ( IRET.EQ.1 )
     C              THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(7,1,IFIRST,NUMERR)
C
C
                        GO TO 10000
                    END IF
C
                IF ( IRET.EQ.2 )
     C             THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2

                        CALL ERRSTA(7,2,IFIRST,NUMERR)
C
                        GO TO 10000
                    END IF
C
C
                 IF(IRET .EQ. 3)
     1              THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
                      CALL ERRSTA(7,2,IFIRST,NUMERR)
C
                      GO TO 10000
                   END IF
C
            ELSE
C
C                PILOT SHIP
C
                 IF(KDEC(4) .EQ. 33)
     1              THEN
C
                        KINT(4)=0
C
C
C
C                       RETAIN POINTER TO STATION IDENTIFIER .
C
                        KPT=IMI
C
C
C                       CHECK THE CALL SIGN
C
                        IBUOY = 0
                        K = IMI
                        J = K + 4
C
                        DO 750 I=K,J
                        IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750                   CONTINUE
C
C
C                       IF A LETTER GROUP IS FOUND CHECK THAT THIS IS
C                       NOT MIMIMJMJ GROUP 'QQBB'. IN THIS CASE THE SHIP
C                       CALL SIGN GROUP IS PRESUMED MISSING.
C
                        IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85)
     C                  .AND.
     C                  (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                      THEN
                               IBUOY = 2
                            END IF
C
C
                        IF(IBUOY .NE. 0)
     C                     THEN
C
C                             SHIP,RIG OR PLATFORM. IDENTIFIER
C                             NUMBER SET TO 0.
C
C
                         ID=0
                              KINT(4) = 0
C
                              IF (IBUOY.EQ.1)
     C                           THEN
C
C                                   MOVE POINTER PAST CALL SIGN . THE
C                                   FIRST CHARACTER OF THE NEXT GROUP IS
C                                   LOCATED AS SOME SHIPS USE THE FULL
C                                   NAME ( WHICH CAN CONSIST OF 2 WORDS
C                                   INSTEAD OF CALL SIGN. SO IF THE NEXT
C                                   GROUP DOESN'T START WITH 'QQ' (WHICH
C                                   IS THE BEGINNING OF MIMIMJMJ GROUP)
C                                   IT MUST BE PART OF THE SHIP'S NAME
C                                   USED INSTEAD OF CALL SIGN.
C
                                    IIPT=K
                                    CALL NEXSEP2(IIPT,IEQ,*10000)
                                    ID = IIPT - KPT
                                    CALL NEXTLET (IIPT,IEQ)
C
                                    IF(KCHAR(IIPT) .NE. 81 .OR.
     C                                 KCHAR(IIPT+1) .NE. 81)
     C                                 THEN
                                          CALL NEXSEP2(IIPT,IEQ,*10000)
                                          ID = IIPT - K
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*10000)
                             CALL NEXPRT2(IIPT,IEQ,*10000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*10000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*10000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*10000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
                                       END IF
C
C
                         END IF
C
                   END IF
C
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR = 4
                              CALL ERRSTA(7,1,IFIRST,NUMERR)
                              GO TO 10000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR=4
                              IF (IFIRST.EQ.0)
     C                           THEN
                                    CALL ERRSTA(7,2,IFIRST,NUMERR)
                                 END IF
                              GO TO 10000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*10000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                               LAT,LON)
                        CALL MARDSEN(LAT,LON,KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
                               KERR = 4
                               CALL ERRSTA(7,1,IFIRST,NUMERR)
C
                               GO TO 10000
C
                            END IF
C
                    ELSE
C
C                       THIS IS NOT A PILOT REPORT
C
                        KERR = 3
                        CALL ERRSTA(7,1,IFIRST,NUMERR)
C
                        GO TO 10000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF

C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4) .EQ. 33 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KERR = 3
                       CALL ERRSTA(7,1,IFIRST,NUMERR)
                       GO TO 10000
C
                   END IF
           END IF
C
C
      IPOS = 17
C
C
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN

2000  CONTINUE
C
C   ************************************************
C   *                SECTION 2                     *
C   *                                              *
C   *         (STANDARD ISOBARIC SURFACES)         *
C   ************************************************
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,2,IVAL)
C
      IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55)
     C   THEN
C
C            44NP1P1 OR 55NP1P1  ....... NUMBER OF LEVELS AND THE
C            -------    -------  ....... PRESSURE ON FIRST ONE
C
            NUMSTAN = NUMSTAN + 1
            IPOS = 17 + (NUMSTAN-1)*9
C
C
            CALL EXTGRP(IPT,2,1,2,0,0,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(7,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*10000)
                  CALL NEXPRT2(IPT,IEQ,*10000)
                  GO TO 3000
               END IF
C
C
C           DD FFF   .......  WIND DIRECTION & SPEED
C           -- ---
C
            N = KINT(IPOS+1)
            IF(N .EQ. MINDIC .OR. N .LE. 0 ) GO TO 3000
C
C
C
               DO 2500 I=1,N
               CALL NEXTPRT(IPT,IEQ)
               IF(IPT .GE. IEQ)
     C            THEN
                     KERR = 7
                     CALL ERRSTA(7,1,IFIRST,NUMERR)
                     GO TO 3000
                  END IF
C
               CALL EXTVAL(IPT,2,IVAL)
               IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55 .OR. IVAL .EQ. 66 .OR.
     C            IVAL .EQ. 77) GO TO 3000
C
               IPOS2 = IPOS + 3 + (I-1)*2
C
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS2,IRET)
C
               IF ( (IRET .NE. 0)  .OR. (KINT(IPOS2) .GT. 36 .AND.
     C            KINT(IPOS2) .NE. MINDIC) )
     C               THEN
                        KERR = 7
C
                        CALL ERRSTA(7,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                        IREMBEG = IPOS2
C========               IF(I .GT. 1) IREMBEG = IPOS2-2
C
                        DO 2400 J = IREMBEG,IPOS2+1
                        KINT(J) = MINDIC
2400                    CONTINUE
                        CALL NEXSEP2(IPT,IEQ,*10000)
                     END IF
C
2500           CONTINUE
C
         END IF

3000  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,2,IVAL)
      CALL EXTVAL(IPT,1,IVAL2)
C
      IF(IVAL .EQ. 44 .OR. IVAL .EQ. 55) GO TO 2000
      IF(IVAL .EQ. 66 .OR. IVAL .EQ. 77) GO TO 4000
      IF(IVAL2 .EQ. 6 .OR. IVAL2 .EQ. 7) GO TO 4500
C
      KERR = 5
      CALL ERRSTA(7,1,IFIRST,NUMERR)
      IREM = MAX0(17,IPOS)
      IF(NUMERR .EQ. 1) IREMPOS = IREM
C
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 3000

4000  CONTINUE
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 77999) GO TO 10000
C
C
C   ***************************************************
C   *                  SECTION 8                      *
C   *                                                 *
C   *     (MAX. WIND LEVELS & VERTICAL WIND SHEAR)    *
C   ***************************************************
C
      INDP = INDP + 1
C
C
C     77 PMPMPM   ......  PRESSURE AT THE LEVEL
C     -- ------
C
      IPOS = 44 + (INDP-1)*7
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
      IF(IRET .NE. 0)
     C    THEN
             KERR = 12
             CALL ERRSTA(7,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = 558
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     DMDM FMFMFM   ......  WIND DIRECTION & SPEED
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF(IRET .NE. 0 .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C                     KINT(IPOS+2) .NE. MINDIC))
     C    THEN
             KERR = 13
             CALL ERRSTA(7,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
             DO 4200 I=IPOS+2,IPOS+3
             KINT(I) = MINDIC
4200         CONTINUE
C
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     4 VBVB VAVA   ......  VERTICAL WIND SHEAR AT THE LEVEL
C     - ---- ----
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL .EQ. 4)
     C   THEN
            CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
            IF(IRET .NE. 0)
     C          THEN
                   KERR = 14
                   CALL ERRSTA(7,1,IFIRST,NUMERR)
                   IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                   CALL NEXSEP2(IPT,IEQ,*10000)
                   CALL NEXPRT2(IPT,IEQ,*10000)
                   GO TO 3000
                END IF
          END IF
C
      GO TO 3000

4500  CONTINUE
C
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 77999) GO TO 10000
C
C
      INDH = INDH + 1
      IPOS = 65 + (INDH-1)*7
C
C
C     7HMHMHM  OR  6HMHMHM   ......  GEOPOTENTIAL AT THE LEVEL
C     -------      -------
C
C
      CALL EXTGRP(IPT,1,4,0,0,0,IPOS,IRET)
      IF(IRET .NE. 0)
     C    THEN
             KERR = 12
             CALL ERRSTA(7,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
             CALL NEXSEP2(IPT,IEQ,*10000)
             CALL NEXPRT2(IPT,IEQ,*10000)
             GO TO 3000
          END IF
C
C
C     DMDM FMFMFM   ......  WIND DIRECTION & SPEED AT THE LEVEL
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C         THEN
                  KERR = 13
                  CALL ERRSTA(7,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  DO 4600 I = IPOS,IPOS+3
                  KINT(I) = MINDIC
4600              CONTINUE
                  CALL NEXSEP2(IPT,IEQ,*10000)
C
                  GO TO 3000
               END IF
C
C
C     4 VBVB VAVA   ......  VERTICAL WIND SHEAR AT THE LEVEL
C     - ---- ----
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,1,IVAL)
      IF(IVAL .EQ. 4)
     C   THEN
            CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
            IF(IRET .NE. 0)
     C          THEN
                   KERR = 9
                   CALL ERRSTA(7,1,IFIRST,NUMERR)
                   IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                   CALL NEXSEP2(IPT,IEQ,*10000)
                   CALL NEXPRT2(IPT,IEQ,*10000)
                   GO TO 3000
                END IF
          END IF
C
C
      GO TO 3000

10000 CONTINUE
C
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
C
                             IPT = KEEP
                             CALL FIXPILO
                             IFIRST=1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 6000 I = IREMPOS,600
                                   KINT(I) = MINDIC
6000                               CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR = 0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                             end if
c
                          END IF
      RETURN
      END
      
      SUBROUTINE UQDEC ( IHEAD,IERR )
C
C**** *UQDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE PILOT REPORT PART D FROM INTERMEDIATE
C         FORMAT TO FULL DECODED FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UQDEC ( IHEAD,IERR )*
C
C           INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C           OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *ERRSTA(XXXX)*
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  MAY -84
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU /0/
      DATA IPRNUM /0/
C
C     ------------------------------------------------------------------
C*          1.   SET UP INDICATORS AND FLAGS.
C                ----------------------------
 100  CONTINUE
C
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0

C***
C*    SET DECODED REPORT TO MISSING DATA VALUE
C***
C
      DO 1 I=25,600
      KDEC(I)=MINDIC
1     CONTINUE

C       *************************************
C       *                                   *
C       *             SECTION 1             *
C       *                                   *
C       *   (IDENTIFICATION AND POSITION)   *
C       *************************************
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C
C
C
C***   DAY AND TIME
C
C
      IF(KINT(2).LT.0.OR.KINT(2).GT.23) THEN
                                           RETURN
                                        END IF  
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C***
C*    CHECK IF SHIP PILOT
C***
C
      IF(KDEC(4) .EQ. 33)
     1           THEN
C
C***                LAT & LONG
C
                    CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1                          KDEC(5),KDEC(6))
                    IF(KDEC(5).EQ.MINDIC.OR.KDEC(6).EQ.MINDIC) RETURN
C
C***                ALTIT=0, FOR SEA STATION
C
                    KDEC(8)=0
C
                 END IF
                 
101   CONTINUE
C
C***  IDENT   STATION/SHIP IDENTIFICATION
C
      KDEC(7)=88

C***  INSTRUMENT SPECCIFICATION
C
      kdec(13)=9
      if(kint(3).ne.mindic) kdec(13)=kint(3)
C
C
C***  REPORT LENGTH
C
C
      KDEC(24)=384
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LE. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
      IROU = IROU +1
C
4000  CONTINUE

C       *********************************************************
C       *                                                       *
C       *                      SECTION 3                        *
C       *                                                       *
C       *       (FIXED LEVELS AND/OR SIGNIFICANT LEVELS)        *
C       *********************************************************
C
C ----- FIXED LEVELS  ----------------------------------------
C
         IPOS = 22
C
C -----  LOOP OVER 20 POSSIBLE SETS OF LEVELS
C
         DO 4200 I=1,20
         IND = 17 + (I-1)*11
         IBASE = 0
         IF(KINT(IND) .EQ. 9)
     C      THEN
               IREF = 300
            ELSE
               IF(KINT(IND) .EQ. 8)
     C            THEN
                     IREF = 500
                  ELSE
                     IF(KINT(IND) .EQ. 1)
     C                  THEN
                           IREF = 300
                           IBASE = 30000
                        ELSE
                           GO TO 4200
                        END IF
                  END IF
            END IF
C
         if(kint(ind+1).eq.mindic) go to 4200
C
         ITENS = KINT(IND+1) * 10
         IF(ITENS .LT. 0 .OR. ITENS .GT. 90) GO TO 4200
C
C
C -----     LOOP OVER 3 POSSIBLE LEVELS IN THE SET
C
            DO 4100 J=1,3
            IND2 = IND + 5 + (J-1)*2
C
C           IF FIRST LEVEL AND 'H = /' THIS IS SURFACE
C
            IF(KINT(IND+1+J) .EQ. MINDIC .AND. I .EQ. 1 .AND.
     C         J .EQ. 1) KINT(IND+1+J) = 0
C
            IF(KINT(IND+1+J) .EQ. MINDIC .OR. KINT(IND2) .EQ. MINDIC
     C         .OR. KINT(IND2+1) .EQ. MINDIC) GO TO 4100
C
            IHIGH = IBASE + (ITENS + KINT(IND+J+1)) * IREF
C
               DO 4050 II = IPOS,22,-3
               IF(KDEC(II) .NE. MINDIC .AND. IHIGH .LT. KDEC(II))
     C           GO TO 4300
4050           CONTINUE
C
            IPOS = IPOS + 3
            KDEC(IPOS) = IHIGH
            CALL DDFFF(KINT(IND2),KINT(IND2+1),IWW,K,MINDIC,
     C                 KDEC(IPOS+1),KDEC(IPOS+2))
4100        CONTINUE
C
C
4200     CONTINUE
C
C
4300     CONTINUE
C
C
C ----- SIGNIFICANT  LEVELS  ------------------------------------------
C
C
         IF(KINT(237) .NE. 21212) GO TO 9900
C
         LEVNUM = 0
C
            DO 4500 J=1,60
            IND = 239 + (J-1)*4
            IF(KINT(IND) .EQ. MINDIC) GO TO 4500
C
            LEVNUM = LEVNUM + 1
            IPOS = 205 + (LEVNUM-1)*3
C
C****       NN PPP   PRESSURE AT THE LEVEL
C
            KDEC(IPOS) = KINT(IND)
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IPOS) .GE. KDEC(IPOS-3) .AND.
     C               KDEC(IPOS-3) .NE. MINDIC)
     C               THEN
                        KDEC(IPOS) = MINDIC
                        LEVNUM = LEVNUM - 1
                        GO TO 4500
                     END IF
               END IF
C
C****       DD FFF   WIND AT THE LEVEL
C
            CALL DDFFF(KINT(IND+1),KINT(IND+2),IWW,K,MINDIC,
     C                 KDEC(IPOS+1),KDEC(IPOS+2))
C
4500        CONTINUE

C       ***********************************************
C       *                 SECTION 9                   *
C       *                                             *
C       *              (REGIONAL DATA)                *
C       ***********************************************

C ------  NO REGIONAL DATA HANDLED  -----------------------------
C
C
C
9900  CONTINUE
C
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 460 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 460
      NIL2 = 0
      GO TO 465
460   CONTINUE
C
465   CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF
C==========================================================
C====    PRINTING OF ERRORS & REPORTS & KINT & KDEC    ====
C==========================================================
C
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 700 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
700   CONTINUE
C
      DO 710 I=1,100
      IF(ISTA .EQ. ISTASD(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
710   CONTINUE
C
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLD .GT. 0) IPRI = 1
C
      IF(KDEC(2) .LT. ITIMES(1) .OR. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
      IF(IPRALLD .EQ. 1)
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
C
C
      IF(IPRNUM .GT. IPRLIM) GO TO 99800
C
      IPRI = 0
C
      IF(IPRI .GT. 0)
     C   THEN
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IPRNUM=IPRNUM+1
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        IPRNUM=IPRNUM+1
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKINT(KINT,1,600,MINDIC)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(1H ,///)
20000 FORMAT(1H ,/////2X,' PART D  NUMBER =',I5,/)
C
99800 CONTINUE
C
c      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL PILOEXP( 4,IERR )
      CALL MRGPIL( IERR )
      CALL QCPILOT( kdec(4),IERR )
      CALL BUFRENC( IERR )
      IERR=0
C
99900 CONTINUE
      RETURN
      END
      
      SUBROUTINE UQINT ( IHEAD,IERR )
C
C**** *UQINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT PILOT REPORTS PART D FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UQINT ( IHEAD,IERR )*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C                     IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE.
C                           = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                     IERR NOT USED ON INPUT.
C
C         OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                 DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF PILOT).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C                   NUMERR = NUMBER OF NON-FATAL ERRORS
C                   IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  NOVEMBER  -84.
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
C
      DIMENSION IREG(9),INAT(9)
      DATA IREG /
     C    51515, 52525, 53535, 54545, 55555, 56565, 57575, 58585, 59595/
      DATA INAT /
     C    61616, 62626, 63636, 64646, 65656, 66666, 67676, 68686, 69696/
C
C
C     ------------------------------------------------------------------
C            1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C               -------------------------------------------------------
C               CHARACTER OF REPORT.
C               --------------------
 100  CONTINUE
C
C
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      MODIFY = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      INDH = 0
      INDP = 0
      INDLEV = 0
      LEVNUM = 0
      IREMPOS = 17
C
C
C***
C*    CHECK FOR 'NIL' REPORT.
C***
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.25 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(10,0,IFIRST,NUMERR)
             KERR = 0
         END IF
C***
C*     SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C***
C
      DO 200 I=1,600
         KINT(I) = MINDIC
  200 CONTINUE
C
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 300 I=12,14
         KINT(I) = 88
  300 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C***
C*    CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C***
C
      DO 400 I=1,3
         KDEC(I) = MINDIC
  400 CONTINUE
C
      DO 500 I=5,9
         KDEC(I) = MINDIC
  500 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = KDEC(15).AND.4
C
      KDEC(17) = MINDIC
      KDEC(22) = MINDIC

1000  CONTINUE

C   ***********************************************************
C   *                      SECTION 1                          *
C   *                                                         *
C   *     (IDENTIFICATION AND POSITION, THIS IS DIFFERENT     *
C   *      FOR LAND STATIONS AND SHIP REPORTS)                *
C   ***********************************************************
C
C               YY GG /
C               -- -- -

 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*10000)
                CALL NEXPRT2(IPT,IEQ,*10000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1                .AND. (KCHAR(IPT) .LE. 56))
     2                 CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
                IF(KINT(1).LE.0.AND.KINT(1).GT.31) THEN
                   KERR=1
                   GO TO 10000
                END IF
C
                JPT = IPT
C
  700 IF ( KDEC(4).EQ.32 )
     C      THEN
C
C               LAND STATION
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*701)
                GO TO 702
C
 701            CONTINUE
C
                KERR=2
                GO TO 10000
 702            CONTINUE 
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .eq. 0)
     C              THEN
                       IF(NIL .EQ. 1)
     C                    THEN
                             KDEC(20)=1
                             kerr=1
                             RETURN
                          END IF    
                    END IF
C
                IF ( IRET.EQ.1 )
     C              THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(10,1,IFIRST,NUMERR)
C
C
                        GO TO 10000
                    END IF
C
                IF ( IRET.EQ.2 )
     C             THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2

                        CALL ERRSTA(10,2,IFIRST,NUMERR)
C
                        GO TO 10000
                    END IF
C
C
                 IF(IRET .EQ. 3)
     1              THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
                      CALL ERRSTA(10,2,IFIRST,NUMERR)
C
                      GO TO 10000
                   END IF
C
            ELSE
C
C                PILOT SHIP
C
                 IF(KDEC(4) .EQ. 33)
     1              THEN
C
                        KINT(4)=0
C
C                       RETAIN POINTER TO STATION IDENTIFIER .
C
                        KPT=IMI
C
C
C                       CHECK THE CALL SIGN
C
                        IBUOY = 0
                        K = IMI
                        J = K + 4
C
                        DO 750 I=K,J
                        IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750                   CONTINUE
C
C
C                       IF A LETTER GROUP IS FOUND CHECK THAT THIS IS
C                       NOT MIMIMJMJ GROUP 'QQBB'. IN THIS CASE THE SHIP
C                       CALL SIGN GROUP IS PRESUMED MISSING.
C
                        IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85)
     C                  .AND.
     C                  (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                      THEN
                               IBUOY = 2
                            END IF
C
C
                        IF(IBUOY .NE. 0)
     C                     THEN
C
C                             SHIP,RIG OR PLATFORM. IDENTIFIER
C                             NUMBER SET TO 0.
C
C
                         ID=0
                              KINT(4) = 0
C
                              IF (IBUOY.EQ.1)
     C                           THEN
C
C                                   MOVE POINTER PAST CALL SIGN . THE
C                                   FIRST CHARACTER OF THE NEXT GROUP IS
C                                   LOCATED AS SOME SHIPS USE THE FULL
C                                   NAME ( WHICH CAN CONSIST OF 2 WORDS
C                                   INSTEAD OF CALL SIGN. SO IF THE NEXT
C                                   GROUP DOESN'T START WITH 'QQ' (WHICH
C                                   IS THE BEGINNING OF MIMIMJMJ GROUP)
C                                   IT MUST BE PART OF THE SHIP'S NAME
C                                   USED INSTEAD OF CALL SIGN.
C
                                    IIPT=K
                                    CALL NEXSEP2(IIPT,IEQ,*10000)
                                    ID = IIPT - KPT
                                    CALL NEXTLET (IIPT,IEQ)
C
                                    IF(KCHAR(IIPT) .NE. 81 .OR.
     C                                 KCHAR(IIPT+1) .NE. 81)
     C                                 THEN
                                          CALL NEXSEP2(IIPT,IEQ,*10000)
                                          ID = IIPT - K
                                       END IF
C
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*10000)
                             CALL NEXPRT2(IIPT,IEQ,*10000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*10000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*10000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*10000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR = 4
                              CALL ERRSTA(10,1,IFIRST,NUMERR)
                              GO TO 10000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*10000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
                              KERR=4
                              IF (IFIRST.EQ.0)
     C                           THEN
                                    CALL ERRSTA(10,2,IFIRST,NUMERR)
                                 END IF
                              GO TO 10000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*10000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                               LAT,LON)
                        CALL MARDSEN(LAT,LON,KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1)
     C                           THEN
                                    KDEC(20)=1
                                    kerr=1
                                    RETURN
                                 END IF
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
                               KERR = 4
                               CALL ERRSTA(10,1,IFIRST,NUMERR)
C
                               GO TO 10000
C
                            END IF
C
                    ELSE
C
C                       THIS IS NOT A PILOT REPORT
C
                        KERR = 3
                        CALL ERRSTA(10,1,IFIRST,NUMERR)
C
                        GO TO 10000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4) .EQ. 33 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KERR = 3
                       CALL ERRSTA(10,1,IFIRST,NUMERR)
                       GO TO 10000
C
                   END IF
           END IF
C
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN

4000  CONTINUE
C
C   ********************************************************
C   *                     SECTION 4                        *
C   *                                                      *
C   *   (FIXED REGIONAL LEVELS AND/OR SIGNIFICANT LEVELS   *
C   ********************************************************
C
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 21212) GO TO 4500
C
C
C     SEE IF THIS IS THE BEGINNING OF REGIONAL OR NATIONAL DATA
C
      IF( IVAL .EQ. 51515  .OR. IVAL .EQ. 52525 .OR.
     C    IVAL .EQ. 53535  .OR. IVAL .EQ. 54545 .OR.
     C    IVAL .EQ. 55555  .OR. IVAL .EQ. 56565 .OR.
     C    IVAL .EQ. 57575  .OR. IVAL .EQ. 58585 .OR.
     C    IVAL .EQ. 59595 ) GO TO 10000
C
      IF( IVAL .EQ. 61616  .OR. IVAL .EQ. 62626 .OR.
     C    IVAL .EQ. 63636  .OR. IVAL .EQ. 64646 .OR.
     C    IVAL .EQ. 65656  .OR. IVAL .EQ. 66666 .OR.
     C    IVAL .EQ. 67675  .OR. IVAL .EQ. 68686 .OR.
     C    IVAL .EQ. 69696 ) GO TO 10000
C
C
C
      CALL EXTVAL(IPT,1,IVAL)
C
      IF(IVAL .EQ. 9 .OR. IVAL .EQ. 8 .OR. IVAL .EQ. 1)
     C   THEN
C
C****        9/8/1 TN U1 U2 U3  ......  TENS & UNITS DIGITS OF ALTITUDE
C            - - - -- -- -- --
C
            INDLEV = INDLEV + 1
            IPOS = 17 + (INDLEV-1)*11
C
C
            CALL EXTGRP(IPT,1,1,1,1,1,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(10,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*10000)
                  CALL NEXPRT2(IPT,IEQ,*10000)
                  GO TO 4000
               END IF

            N = KINT(IPOS+1)
C
C
C              SEE HOW MANY WIND GROUPS THERE ARE.  THERE ARE SUPPOSED
C              TO BE ONLY THREE WIND GROUPS (MAX) AFTER 'ID-GROUP'
C              44NP1P1 / 55NP1P1.  HOWEVER QUITE A COMMON PRACTICE
C              IS TO HAVE THE ID-GROUP ONLY ONCE AND ALL THE WIND-GROUPS
C              AFTER THIS.  THEREFORE THIS PRACTICE IS ALSO ACCEPTED
C              ASSUMING DATA ARE CORRECT.
C
               NUMBER = 0
               DO 4100 I = 1,3
               IF(NUMBER .GT. 0 .AND. KINT(IPOS+I+1) .LT. KINT(IPOS+I))
     C            GO TO 4100
               IF(KINT(IPOS+I+1) .NE. MINDIC) NUMBER = I
4100           CONTINUE
C
C
               IPOS = 22 + (INDLEV-1) * 11
C
C****          DD FFF   .......  WIND DIRECTION & SPEED
C              -- ---
C
               DO 4200 I=1,NUMBER
               IPOS2 = IPOS + (I-1)*2
               CALL NEXPRT2(IPT,IEQ,*10000)
               CALL EXTVAL(IPT,1,IVAL)
               IF(IVAL .EQ. 9 .OR. IVAL .EQ. 8) GO TO 4000
C
               CALL EXTVAL(IPT,5,IVAL)
                  DO 4130 J = 1,9
                  IF(IVAL .EQ. IREG(J)) GO TO 10000
                  IF(IVAL .EQ. INAT(J)) GO TO 10000
4130              CONTINUE
C
C
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS2,IRET)
C
               IF ( (IRET .NE. 0)  .OR. (KINT(IPOS2) .GT. 36 .AND.
     C            KINT(IPOS2) .NE. MINDIC) )
     C               THEN
                        KERR = 7
C
                        CALL ERRSTA(10,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS2
C
                        DO 4150 J = IPOS2,IPOS2+1
                        KINT(J) = MINDIC
4150                    CONTINUE
                        CALL NEXSEP2(IPT,IEQ,*10000)
                        CALL NEXPRT2(IPT,IEQ,*10000)
                        IF(I .EQ. NUMBER) GO TO 4000
                     END IF
C
4200           CONTINUE
C
         ELSE
C
            CALL NEXSEP2(IPT,IEQ,*10000)
C
         END IF
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      GO TO 4000
C
C****  21212  ......  SIGNIFICANT LEVEL INDICATOR
C      -----
4500  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      IPOS = 237
      CALL EXTGRP(IPT,5,0,0,0,0,IPOS,IRET)
      IF (IRET .NE. 0)
     C   THEN
            KERR = 10
C
            CALL ERRSTA(10,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
            GO TO 4900
         END IF
C
4600  CONTINUE
C
C
C**** NINI PIPIPI  ......  PRESSURE AT SIGNIFICANT LEVEL
C     ---- ------
C
      LEVNUM = LEVNUM + 1
C
      IPOS = 238 + (LEVNUM-1) * 4
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C====   PARANNA    ============================
C     CHECK IF THIS REALLY IS THE NEXT LEVEL
C
      IF(KCHAR(IPT) .NE. KCHAR(IPT+1)) GO TO 4900
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
      IF (IRET .NE. 0)
     C   THEN
            KERR = 5
            CALL ERRSTA(10,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
C
            GO TO 4700
         END IF
C
C
C**** DD FFF  ......  WIND AT SIGNIFICANT LEVEL
C     -- ---
C
      CALL NEXPRT2(IPT,IEQ,*10000)
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C   THEN
            KERR = 7
C
            CALL ERRSTA(10,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            DO 4650 J = IPOS,IPOS+3
            KINT(J) = MINDIC
4650        CONTINUE
            CALL NEXSEP2(IPT,IEQ,*10000)
            CALL NEXPRT2(IPT,IEQ,*10000)
            GO TO 4600
         END IF
C
C
      GO TO 4600

4700  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      IF(KCHAR(IPT) .EQ. KCHAR(IPT+1)) GO TO 4600
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 4700

4900  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*10000)
      CALL EXTVAL(IPT,5,IVAL)
C
      IF(IVAL .EQ. 21212) GO TO 4500
C
      IF( IVAL .EQ. 51515  .OR. IVAL .EQ. 52525 .OR.
     C    IVAL .EQ. 53535  .OR. IVAL .EQ. 54545 .OR.
     C    IVAL .EQ. 55555  .OR. IVAL .EQ. 56565 .OR.
     C    IVAL .EQ. 57575  .OR. IVAL .EQ. 58585 .OR.
     C    IVAL .EQ. 59595 ) GO TO 10000
C
      IF( IVAL .EQ. 61616  .OR. IVAL .EQ. 62626 .OR.
     C    IVAL .EQ. 63636  .OR. IVAL .EQ. 64646 .OR.
     C    IVAL .EQ. 65656  .OR. IVAL .EQ. 66666 .OR.
     C    IVAL .EQ. 67675  .OR. IVAL .EQ. 68686 .OR.
     C    IVAL .EQ. 69696 ) GO TO 10000
C
      CALL EXTVAL(IPT,1,IVAL)
      IF( IVAL .EQ. 9 .OR. IVAL .EQ. 8) GO TO 4000
C
      CALL NEXSEP2(IPT,IEQ,*10000)
      GO TO 4900
C
C
C***************************************************
C*                                                 *
C*               SECTIONS 5 & 6                    *
C*                                                 *
C*       REGIONAL & NATIONAL DATA (NOT USED)       *
C*                                                 *
C***************************************************
C
C
10000 CONTINUE
C
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
C
C
                             IPT = KEEP
                             CALL FIXPILO
                             IFIRST=1
                             NUMRERR(10) = NUMRERR(10) + 1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 6000 I = IREMPOS,600
                                   KINT(I) = MINDIC
6000                               CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR = 0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                             end if
c
                          END IF
C
C
C
C
      RETURN
      END
      
      SUBROUTINE FIXPILO
C
C**** *FIXPILO*
C
C
C     PURPOSE.
C     --------
C
C         FIX ERRORS FOUND IN PILOT DATA
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FIXPILO*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C          OUTPUT    : - REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN FIXED FORM
C                        IF FIX WAS FOUND
C                      - MODIFY = 1  IF FIX WAS MADE
C                                 0  OTHERWISE
C
C
C     METHOD.
C     -------
C
C         THE POSSIBLE FIXES ARE 
C             - REMOVE 'E E E' S
C             - IF = IS MISSING (DETERMINED BY CHECKING IF
C                    PPAA, PPBB, PPCC OR PPDD ARE FOUND IN
C                    THE MIDDLE OF REPORT), ADD = TO THE END
C                    OF REPORT.
C             - IF THE LENGHT OF A GROUP IS INCORRECT;
C                    LENGTH = 10  ACCEPT DATA ('SP' MISSING)
C                    LENGTH = 11  SEE IF THE 6.TH CHAR. SHOULD
C                                 HAVE BEEN 'SP'
C                    LENGTH .LT. 5  SEE IF A FIVE FIGURE GROUP
C                                          HAS BEEN SPLIT INTO TWO.
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOVEMBER  -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR PARITY BIT.
C                -----------------
 100  CONTINUE
C
C
      MODIFY = 0
      IEQORIG = IEQ
C
      DO 101 I=IPT,IGS
         KCHAR(I) = KCHAR(I) .AND. 127
101   CONTINUE
C
C
      CALL REMEEE
C
C     SEE IF = -SIGN WAS MISSING BY CHECKING IF 'PPAA , PPBB , PPCC OR
C     PPDD ' CAN BE FOUND IN THE MIDDLE OF THE REPORT.
C
C
      NPT = IPT
      IEQADD = 0
      CALL NEXTFIG(NPT,IEQ)
      IF(NPT .GE. IEQ) GO TO 10000
C
400   CONTINUE
C
      MIMI = 0
C
      CALL NEXSEP2(NPT,IEQ,*10000)
      CALL NEXPRT2(NPT,IEQ,*10000)
C
      IF( ( KCHAR(NPT  ) .EQ. 80   .AND.   KCHAR(NPT+1) .EQ. 80)  .AND.
     C   (( KCHAR(NPT+2) .EQ. 65   .AND.   KCHAR(NPT+3) .EQ. 65  ) .OR.
     C    ( KCHAR(NPT+2) .EQ. 66   .AND.   KCHAR(NPT+3) .EQ. 66  ) .OR.
     C    ( KCHAR(NPT+2) .EQ. 67   .AND.   KCHAR(NPT+3) .EQ. 67  ) .OR.
     C    ( KCHAR(NPT+2) .EQ. 68   .AND.   KCHAR(NPT+3) .EQ. 68  ) ) )
     C     MIMI = 1
C
      IF(MIMI .EQ. 1)
     C   THEN
C
            MPT = NPT
            CALL PRESEP(MPT,IPT,*10000)
            CALL PREPRT(MPT,IPT,*10000)
C
            MODIFY = 1
            IEQADD = IEQADD + 1
C
               DO 500 I = IEQ+1 , IGS+1 , -1
               KCHAR(I) = KCHAR(I-1)
500            CONTINUE
C
            KCHAR(MPT+1) = 61
            IF(IEQADD .EQ. 1) IEQ = MPT+1
            IGS = IGS+1
         END IF
C
      GO TO 400
C
10000 CONTINUE
C
C
C
C     SEE IF THERE ARE GROUPS OF DIFFERENT LENGTH FROM 5
C
C
      NPT = IPT
      CALL NEXTFIG(NPT,IEQ)
      IF(NPT .GE. IEQ) GO TO 20000
C
200   CONTINUE
C
      MPT = NPT
      CALL NEXPRT2(MPT,IEQ,*20000)
      NPT = MPT
      CALL NEXSEP2(NPT,IEQ,*20000)
      LEN = NPT - MPT
C
C     SEE IF THE GROUP IS TOO LONG
C
      IF(LEN .GT. 5)
     C   THEN
C
C           IF LENGTH = 10 , NO ERROR
C
            IF(LEN .EQ. 10) GO TO 200
C
C
C           QUITE A COMMON ERROR IS THAT 'SPACE' BETWEEN
C           TWO GROUPS IS 8 OR 0 OR NOT FIGURE
C
            IF(LEN .EQ. 11)
     C         THEN
                  IF(KCHAR(MPT+5) .EQ. 56 .OR. KCHAR(MPT+5) .EQ. 48)
     C               THEN
C
                        KCHAR(MPT+5) = 32
                        MODIFY = 1
                        GO TO 200
                     ELSE
                        IF( (KCHAR(MPT+5) .LT. 48 .OR. KCHAR(MPT+5) .GT.
     C                       57) .AND. KCHAR(MPT+5) .NE. 32 )
     C                     THEN
C
                              KCHAR(MPT+5) = 32
                              MODIFY = 1
                              GO TO 200
                           END IF
                     END IF
                  GO TO 200
               END IF
         END IF
C
C     SEE IF THE GROUP IS SPLIT INTO TWO GROUPS
C
      IF(LEN .LT. 5)
     C   THEN
            NNPT = NPT
            CALL NEXPRT2(NNPT,IEQ,*20000)
            CALL NEXTVAL(NNPT,32,IEQ)
            IF(NNPT .GT. IEQ) GO TO 20000
            LEN2 = NNPT - NPT - 1
            LEN3 = LEN + LEN2
            IF(LEN3 .EQ. 5)
     C         THEN
C
                  DO 300 I = NPT,NNPT-2
                  KCHAR(I) = KCHAR(I+1)
  300             CONTINUE
                  KCHAR(NNPT-1) = 32
                  MODIFY = 1
               END IF
         END IF
C
      GO TO 200
C
20000 CONTINUE

90000 FORMAT(1H ,//2X,' THE ORIGINAL REPORT POS 1 ',/)
90001 FORMAT(1H ,//2X,' THE ORIGINAL REPORT POS 2 ',/)
91000 FORMAT(1H ,//2X,' THE MODIFIED REPORT ',/)
C
      RETURN
      END
      
      SUBROUTINE PRTEMP(NUMBER)
C
C**** *PRTEMP*
C
C
C     PURPOSE.
C     --------
C
C         PRINTS TEMP BULLETIN AND IT'S INTERMEDIATE
C         FORMAT ('KINT') AND DECODED FORMAT ('KDEC')
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTEMP(NUMBER)*
C
C          INPUT     : NUMBER - THE NUMBER OF THE REPORT
C                      KINT   - THE BULLETIN IN INTERMEDIATE FORMAT
C                      KDEC   - THE BULLETIN IN DECODED FORMAT
C                      KDEC(23) = 1 FOR PART A
C                               = 2 FOR PART B
C                               = 3 FOR PART C
C                               = 4 FOR PART D
C
C
C     AUTHOR.
C     -------
C
C     A.HOLOPAINEN  SEP.83
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION NERR(30)
      DIMENSION ILN(4)
C
      DATA ILN / 200, 600, 200, 600/
C
C
C     ------------------------------------------------------------------
C*          1.  PRINT TEMP REPORT.
C                -----------------
 100  CONTINUE
C
      DO 101 I=1,30
      NERR(I)=0
 101  CONTINUE
C
C
            KK = KDEC(20)
C
              DO 102 I=30,1,-1
               K = KK - (2**(I-1)) * (KK/(2**(I-1)))
               IF(K .GE. KK) GO TO 102
               KK = K
               NERR(I) = 1
               IF(KK .EQ. 0) GO TO 103
 102           CONTINUE
C
 103        CONTINUE
C
            WRITE(*,10000)
            WRITE(*,20000)
            IF(KDEC(23) .EQ. 1) WRITE(*,30000) NUMBER
            IF(KDEC(23) .EQ. 2) WRITE(*,40000) NUMBER
            IF(KDEC(23) .EQ. 3) WRITE(*,50000) NUMBER
            IF(KDEC(23) .EQ. 4) WRITE(*,60000) NUMBER
            WRITE(*,70000)
C
              DO 104 I=1,30
               IF(NERR(I) .EQ. 1) WRITE(*,80000) I
 104           CONTINUE
C
            WRITE(*,20000)
C
10000       FORMAT(2X,///)
20000       FORMAT(2X,'=======================')
30000       FORMAT(2X,'=  PART A NUMBER',I4,'  =')
40000       FORMAT(2X,'=  PART B NUMBER',I4,'  =')
50000       FORMAT(2X,'=  PART C NUMBER',I4,'  =')
60000       FORMAT(2X,'=  PART D NUMBER',I4,'  =')
70000       FORMAT(2X,'=                     =')
80000       FORMAT(2X,'=  ERROR',I3,'           =')
C
            CALL PRTBULL(IMI,IEQ)
            CALL PRTKINT(KINT,1,ILN(KDEC(23)),MINDIC)
            CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      WRITE(*,90000)
90000 FORMAT(2X,116('='))
C
C
      RETURN
      END
      
      SUBROUTINE MARDSEN(LAT,LONG,M,IERROR)
C
C**** *MARDSEN*
C
C
C     PURPOSE.
C     --------
C
C         CHECK THE LAT&LONG AGAINST MARDSEN SQUARE
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *MARDSEN(LAT,LONG,M,IERROR)*
C
C          INPUT     : LATITUDE  IN HUNDREDTH'S OF DEGREE
C                      LONGITUDE IN HUNDREDTH'S OF DEGREE
C              M     - MARDSEN SQUARE VALUE GIVEN IN REPORT
C
C          OUTPUT   : IERROR  - ERROR INDICATOR
C
C     AUTHOR.
C     -------
C
C     A. HOLOPAINEN  JUNE -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.   CHECK POSITION.
C                ---------------
 100  CONTINUE
C
C
      IERROR = 0
      LOLO = LONG
C
C     DON'T CHECK IF POSITION ON THE LINE BETWEEN TWO (OR FOUR) SQUARES
C
      LAA = 1000*(LAT/1000)
      LOO = 1000*(LONG/1000)
C
      IF(LAA .EQ. LAT) RETURN
      IF(LOO .EQ. LONG) RETURN
C
      LAT = LAT /10
      LONG= LONG/10
C
C
      IF(LAT .GE. 0)
     C   THEN
            LO = IABS(LONG/100)+1
            IF(LOLO .GE. 0) LO = 37 - LO
C
            IF( LAT .LT. 800 )
     C         THEN
                  MMM = (LAT/100)*36 + LO
               ELSE
                  MMM = 900 + LO
               END IF
         END IF
C
C
      IF(LAT .LT. 0)
     C   THEN
            LO = IABS( LONG/100 )
            IF(LOLO .GE. 0) LO = 35 - LO
            MMM = 300 + IABS( LAT/100 )*36 +LO
         END IF
C
      IF(MMM .NE. M) IERROR = 1
C
      RETURN
C
      END
      
      SUBROUTINE IC3333(IQUADR,LAT,LONG,MINDIC,LAT2,LONG2)
C
C****
C*
C*    NAME     :  IC3333
C*
C*    FUNCTION :  DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C*                99LALALA QCL0L0L0L0
C*
C*    INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C*             :  LAT      LATITUDE IN TENTHS OF DEGREE
C*             :  LONG     LONGITUDE IN TENTHS OF DEGREE
C*             :  MINDIC   MISSING DATA VALUE
C*
C*
C*    OUTPUT   :  LAT2   LATITUDE IN HUNDREDTHS OF DEGREE
C*                       SOUTHERN LATITUDE NEGATIVE
C*             :  LONG2: LONGITUDE IN HUNDREDTHS OF DEGREE
C*                       WESTERN LONGITUDE NEGATIVE
C*
C*                LAT2 AND LONG2 ARE SET TO MISSING DATA VALUE IF
C*                ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C*
C****
C
C
      DIMENSION LATSIGN(4),LONSIGN(4)
C
      DATA LATSIGN/ 1,-1,-1, 1/
      DATA LONSIGN/ 1, 1,-1,-1/
C
C***  SET LAT2 AND LONG2 TO MISSING DATA VALUE
C
      LAT2=MINDIC
      LONG2=MINDIC
C
C
C     THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C     LAT. AND LONG. ARE NEGATIVE OR POSITIVE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF(IQUADR .NE. 1 .AND. IQUADR .NE. 3 .AND. IQUADR .NE.
     1     5 .AND. IQUADR .NE. 7) RETURN
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(LAT .LT. 0 .OR. LAT .GT. 900) RETURN
C
      IF(LONG .LT. 0 .OR. LONG .GT. 1800) RETURN
C
C
      IQ=(IQUADR+1)/2
C
      LAT2=10*LAT*LATSIGN(IQ)
      LONG2=10*LONG*LONSIGN(IQ)
C
      RETURN
      END
      
      SUBROUTINE STATION(IERR)
C
C**** *STATION*
C
C
C     PURPOSE.
C     --------
C         READ IN STATION LIST AND MAKE LIST OF IMPORTANT STATIONS.
C         ( WMO VOLUMEN A - LIST OF OBSERVING STATIONS)
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *STATION(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   READ IN STATION LIST.
C                ---------------------
 100  CONTINUE
C
      OPEN(UNIT=4,IOSTAT=IOS,ERR=300,
     1     FILE='station_list.dat',
     1     STATUS='OLD',
     1     FORM='UNFORMATTED')
C
      READ(4) IPARAMS,IPOINTS
c
c     call invbytes(33000*4,iparams)
c
C
      CLOSE(4)
C
C
C*           2.  FIND IMPORTANT STATIONS.
C                ------------------------
 200  CONTINUE
C
      CALL IMPSTAT
C
      RETURN
C
 300  CONTINUE
C
      WRITE(*,9901) IOS
 9901 FORMAT(1H ,' ERROR DURING OPENING  STATION FILE , ERROR=',I5)
C
C
      RETURN
      END
      
      SUBROUTINE IMPSTAT
C
C**** *IMPSTAT*
C
C
C     PURPOSE.
C     --------
C
C         DEFINES FROM WMO MASTER FILE THE SATION NUMBERS
C         FOR IMPORTANT STATIONS (ECMWF INTERNAL DEFINOTIONS)
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C             INPUT     : IPARAMS   STATION INFORMATION IN PACKED FORM
C                         IPOINTS   NUMBER OF STATION / WMO BLOCK
C
C             OUTPUT    : IMPSTA    THE NUMBERS OF IMPORTATNT SATIONS
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'parameter.h'
      include 'comwork.h'
      INCLUDE 'combuff.h'
C
C
C     ------------------------------------------------------------------
C*          1.   FIND IMPORTANT STATIONS.
C                ------------------------
C
      J = 0
      K = 1
C
C
            DO 300 I = 1,30000,3
C
            IF(IPARAMS(I) .EQ. MINDIC) GO TO 400
            IF(I .LT. IPOINTS(K+1)) GO TO 200
C
100         K = K + 1
            IF(K .GE. 99) GO TO 400
            IF(IPOINTS(K) .EQ. IPOINTS(K+1)) GO TO 100
C
200         CONTINUE
c
            CALL GBYTE(IPARAMS(I+2),ITEMP,28,1)
            CALL GBYTE(IPARAMS(I+2),IBIT ,25,1)
C
           IF(ITEMP .EQ. 1 .AND. IBIT .EQ. 1)
     C         THEN
                  CALL GBYTE(IPARAMS(I),III,0,10)
                  ISTA= 1000*K+ III
                  IF(J .NE. 0)
     C               THEN
                        DO 250 N=1,J
                        IF(ISTA .EQ. IMPSTA(N)) GO TO 300
250                     CONTINUE
                     END IF
                  J = J + 1
                  IF(J.GT.2000) THEN
                     PRINT*,'DIMENSION OF IMPSTA TOO SMALL'
                     GO TO 400
                  END IF
C
                  IMPSTA(J) = ISTA
               END IF
C
300        CONTINUE
C
C
400   CONTINUE
C
500   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE LOCSTAT ( IWIND,IRC )
C
C**** *LOCSTAT*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACT PARTICULARS OF WMO OBSERVING STATIONS AND
C         PUT IN DECODED REPORT HEADER.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LOCSTAT(IWIND,IRC)*
C
C          INPUT    : ARGUMENTS NOT USED ON INPUT .
C
C                     KINT(4) - WMO STATION NUMBER IN INTEGER.
C                     KDEC(4) - INTEGER DENOTING OBSERVATION TYPE.
C
C          OUTPUT   : KDEC(5) - LATITUDE IN HUNDREDTHS OF DEGREES ,
C                               NORTH + , SOUTH - .
C                     KDEC(6) - LONGITUDE IN HUNDREDTHS OF DEGREES ,
C                               EAST + , WEST - .
C                     KDEC(8) - STATION PRESSURE ELEVATION (H/P) OR IF
C                               R. CINTRA    *CPTEC* EXISTS STATION GROUND ELEVATION (H/A).
C                               IF NEITHER EXIST MINDIC IS RETURNED . VALUE
C                               IS INTEGER IN METRES.
C
C                     KDEC(15) - IMPORTANT STATION OR GOOD QUALITY STATION
C                                FLAG BITS SET IN THIS WORD.
C
C                     KDEC(16) - WMO COUNTRY NUMBER , EXCLUDING FIRST 2
C                                DIGITS ( REGION NUMBER ) . INTEGER.
C                     KDEC(17) - WMO REGION NUMBER , INTEGER.
C
C                     KDEC(23) - PRESSURE LEVEL INDICATOR , INTEGER.
C                            0 = SEA LEVEL
C                            1 = STATION LEVEL
C                            2 = 850 HPA
C                            3 = 700 HPA
C                            4 = 500 HPA
C                            5 = 1000 GPM
C                            6 = 2000 GPM
C                            7 = 3000 GPM
C                            8 = 4000 GPM
C                            9 = 900 HPA
C
C                     IRC - INTEGER RETURN CODE
C                            0 = NO ERROR
C                            1 = STATION NUMBER NOT IN DIRECTORY
C                            2 = INVALID STATION NUMBER
C                            3 = INVALID OBSERVATION TYPE
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KBPT,KSI)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   LOCATE STATION.                   .
C                ---------------
 100  CONTINUE
C
C     CLEAR ERROR RETURN INDICATOR
C
      IRC = 0
C
C     INITIALIZE TYPE OF STATION
C
      ITYPE = 0
C
C     'ITYPE' IS SET TO 4 FOR SYNOP , 2 FOR PILOT AND 1 FOR TEMP.
C
      IF ( KDEC(4).EQ.11.OR.KDEC(4).EQ.14 ) ITYPE = 4
      IF ( KDEC(4).EQ.32 ) ITYPE = 2
      IF ( KDEC(4).EQ.35 ) ITYPE = 1
C
      IF ( ITYPE.EQ.0 ) THEN
                            IRC = 3
                            RETURN
                        END IF
C
C     CHECK VALIDITY OF STATION NUMBER
C
      IF ( KINT(4).LE.1000.OR.KINT(4).GT.99999 )
     C                       THEN
                                 IRC = 2
                                 RETURN
                             END IF
C
C
C     LOCATE STARTING POINT IN ARRAY 'IPARAMS' OF THE WMO BLOCK
C     OF THE STATION.
C
C     EXTRACT WMO BLOCK NUMBER
C
      II = KINT(4) / 1000
C
C     WORD 'II' OF 'IPOINTS' SHOWS WHERE THE ENTRIES FOR BLOCK 'II'
C     START IN 'IPARAMS'.
C
      IND1 = IPOINTS(II)
      IND2 = IPOINTS(II+1)-3
C
C     STARTING AT THIS WORD A SEQUENTIAL SEARCH IS MADE FOR AN ENTRY
C     FOR THE REQUIRED STATION NUMBER ( III ) >
C
      III = KINT(4) - ( II * 1000 )
C
C     FOR ONE STATION ENTRY 3 WORDS ARE USED
C
      DO 101 I=IND1,IND2,3
         CALL GBYTE(IPARAMS(I),ISTN,0,10)
         IF(ISTN.EQ.III) GO TO 200
  101 CONTINUE
C
C     STATION NUMBER NOT FOUND
C
      IRC = 1
      RETURN
C
C
C     -----------------------------------------------------------------
C*             2.  EXTRACT REQUIRED PARAMETERS FROM 1st WORD ENTRY.
C                  -----------------------------------------------
 200  CONTINUE
C
C     PRESSURE LEVEL CODE FIGURE
C
      IF(ITYPE .EQ. 4)
     C   CALL GBYTE(IPARAMS(I),KDEC(23),16,4)
C
C
C     WIND SPEED UNIT INDICATOR
C
      CALL GBYTE(IPARAMS(I),IWIND,20,1)
C
C
C     STATION ELEVATION
C
      CALL GBYTE(IPARAMS(I),KDEC(8),24,14)
      IF ( KDEC(8).GT.9999 ) KDEC(8) = KDEC(8)-16383
      IF ( KDEC(8).EQ.9999 ) KDEC(8) = MINDIC
C
C     LONGITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(6),8,16)
      IF ( KDEC(6).EQ.65535 ) KDEC(6) = MINDIC
      IF ( KDEC(6).NE.MINDIC.AND.KDEC(6).GT.18000)
     C      KDEC(6) = KDEC(6) - 36000
C
C
C     LATITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(5),24,14)
      IF ( KDEC(5).EQ.16383 ) KDEC(5) = MINDIC
      CALL GBYTE(IPARAMS(I+2),ISGN,6,1)
      IF(ISGN.EQ.1.AND.KDEC(5).NE.MINDIC)
     C                KDEC(5) = - KDEC(5)
C
C
C     WMO REGION NUMBER
C
      CALL GBYTE(IPARAMS(I+2),KDEC(17),8,3)
      IF ( KDEC(17).EQ.0 ) KDEC(17) = 8
C
C
C     WMO COUNTRY NUMBER ( LAST 3 DIGITS )
C
      CALL GBYTE(IPARAMS(I+2),KDEC(16),11,10)
C
C
C     IMPORTANT STATION AND GOOD QUALITY FLAGS.
C
      CALL GBYTE(IPARAMS(I+2),ISGQ,24,2)
      KDEC(15) = KDEC(15).OR.ISGQ
C
C
C     CHECK THAT PARAMETERS ARE VALID FOR OBSERVATION TYPE REQUESTED.
C     SOME STATIONS HAVE MORE THAN 1 ENTRY , DEPENDING ON TYPE OF
C     OBSERVATION.
C
      IF(ITYPE.EQ.1) ISKIP=26
      IF(ITYPE.EQ.2) ISKIP=27
      IF(ITYPE.EQ.4) ISKIP=28
C
      CALL GBYTE(IPARAMS(I+2),ITP,ISKIP,1)
      IF (  ITP.NE.0 ) RETURN
C
C     PARAMETERS NOT CORRECT FOR CODE TYPE , SO USE NEXT ENTRY
C     IF IT EXIST
C
      I = I + 3
C
      CALL GBYTE(IPARAMS(I),ISTN,0,10)
      IF(ISTN.EQ.III) GO TO 200
C
C     RETAIN ALREADY EXTRACTED PARAMETERS
C     THAT MEAN THAT STATION TYPE DOES NOT CORRESPOND TO THE MESSAGE
C     RECEIVED. 
C     
      RETURN
      END
      
      SUBROUTINE EXTVAL ( I,N,IVAL)
C
C**** *EXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN IVAL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTVAL(I,N,IVAL)*
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTE
C
C         OUTPUT    : IVAL - INTEGER VALUE
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES FROM KCHAR ARRAY.
C                -----------------------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
      DO 101 J=IA,IB
C
C
C     STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE
C
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C          CHECK FOR SPACE CHARACTER .
C
           IF ( KAR.EQ.32 ) THEN
                                      IVAL = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     IVAL = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR.LT.48.OR.KAR.GT.57 )
     C                      THEN
                                  DO 102 JA=1,11
                                       IF ( KAR.EQ.ILET(JA))
     C                                       KAR = IFIG(JA)
  102                             CONTINUE
                           END IF
C
           IF ( KAR.GE.48.AND.KAR.LE.57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      IVAL = MINDIC
                                      RETURN
                                   END IF
C
      KCHAR(J)=KTEMP
C
  101 CONTINUE
C
      IVAL = IAC / 10
C
C
      RETURN
      END
      
      SUBROUTINE PRESEP ( I,J,*)
C
C**** *PRESEP*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRESEP(I,J,*)
C
C                 INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                             J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C                 OUTPUT    : I - POSITION OF PREVIOUS 'CR' OR 'LF' OR 'S
C                                 IF NO CHARACTER FOUND THE CONTROL RETUR
C                                 ALTERNATIVE RETURN POINT *
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C                ---------------------------------------------
C                CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C                --------------------------------------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE LETFIG(K)
C
C*****
C*
C*    NAME      : LETFIG
C*
C*    FUNCTION  : IF K IS NOT FIGURE CONVERT IT USING THE
C*                CCITT NO.2 LETTER/FIGURE RELATION SHIP.
C*
C*    INPUT     : K - KHARACTER VALUE TO BE CONVERTED
C*
C*    OUTPUT    : K - CONVERTED TO FIGURE IF IT WAS EITHER
C*                    E,O,P,Q,R,T,U,W,X,Y OR I, OTHERWISE
C*                    K REMAINS UNCHANGED.
C*
C*****
C
C
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( K.LT.48.OR.K.GT.57 )
     C                      THEN
                                  DO 100 JA=1,11
                                       IF ( K.EQ.ILET(JA))
     C                                       K = IFIG(JA)
  100                             CONTINUE
                           END IF
C
C
      RETURN
      END
      
      SUBROUTINE FIXUS
C
C**** *FIXUS*
C
C
C     PURPOSE.
C     --------
C         TRY TO FIX ERROR ON TEMP DECODING.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR PARITY BITS.
C                ------------------
 100  CONTINUE
C
      DO 101 I=IPT,IGS
         KCHAR(I) = KCHAR(I) .AND. 127
101   CONTINUE
C
C
      CALL REMEEE
C
      RETURN
      END
      
      SUBROUTINE NEXTNI(ISTEP,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     C                  * , * , * , * , * , * , * , * )
C
C**** *NEXTNI*
C
C
C     PURPOSE.
C     --------
C
C
C         FIND THE NEXT PRESSURE LEVEL IN TEMP PART B & D
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTNI(ISTEP,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
C    C                  * , * , * , * , * , * , * , * )*
C          INPUT      ISTEP   = 5 FOR TEMPERATURE LEVELS
C                             = 4 FOR WIND LEVELS
C                     IFIRST  = 0 IF FIRST DECODING ATTEMPT
C                             = 1 OTHERWISE
C                     LEVNUM  = THE NUMBER OF THE LEVEL (RUNNING FROM 0 -)
C                     LEVPRE  = INDICATOR OF THE PREVIOUS LEVEL
C
C          OUTPUT     LEVNUM
C                     IREMPOS   INDICATOR TO THE POINT OF THE FIRST ERROR
C                               (USED AS POINTER OF DELETION IF THERE ARE
C                               TOO MANY ERRORS).
C
C
C     METHOD.
C     -------
C
C         MULTIPLE RETURN ADDRES
C         1.ST  IF THE BEGINNING OF WIND SECTION FOUND
C         2.ND  -- --- --------- -- CLOUD ------ -----
C         3.RD  -- --- --------- -- REGIONAL --- -----
C         4.TH  -- --- --------- -- NATIONAL --- -----
C         5.TH  -- --- END OF REPORT             -----
C         6.TH  --     NOTHING USEFUL            -----
C         7.TH  -- --- FOLLOWING LEVEL           -----
C
C
C
C     EXTERNALS.
C     ----------
C
C           SUBROUTINE CALLED
C           ERRSTA  -  TO REGISTER ERRORS
C           EXTVAL  -  TO EXTRACT A VALUE
C           LEVCHEC -  TO CHECK THE PRESSURE LEVELS
C           NEXPRT2 -  SCANNING ROUTINE
C           NEXSEP2 -  SCANNING ROUTINE
C
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  DEC.83
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DATA N1N2PRE/-9999/
      DATA IFIX / 0 /
C
C     ------------------------------------------------------------------
C
C*          1.   FIND NEXT LEVEL IN THE B AND D PART OF TEMP REPORT.
C                ---------------------------------------------------
 100  CONTINUE
C
C
      ITRY = 0
      IDUP = 0
      IPART = 4
      IF(KDEC(23) .EQ. 4) IPART = 6
C
      IF(LEVNUM .LE. 0) N1N2PRE = -9999
      IF(LEVNUM .LE. 0) IFIX = 0
C
101   CONTINUE
C
C     NINI PIPIPI
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*9999)
C
C
      N1 = (KCHAR(IPT) .AND. 127) - 48
      N2 = (KCHAR(IPT+1) .AND. 127) - 48
      N1N2 = 10*N1 + N2
C
C
C     CHECK IF THIS IS CORRECT BEGINNING OF SIGNIFICANT LEVEL (N1=N2)
C
C     CHECK IF N1N2 = //
C
      IF(N1 .EQ. -1 .AND. N2 .EQ. -1)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*9999)
            GO TO 101
         END IF
C
C     CHECK IF THIS IS PART D AND NINI=00.  REJECT IT BEACUSE
C     SOME STATIONS INCLUDE INCORRECTLY STATION LEVEL IN PART D.
C
      IF(IPART .EQ. 6)
     C   THEN
            IF(N1N2 .EQ. 0)
     C         THEN
                  CALL NEXPRT2(IPT,IEQ,*9999)
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  CALL NEXPRT2(IPT,IEQ,*9999)
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
         END IF
C
      IPOS = 17
      IF(ISTEP .EQ. 4) IPOS = 318
C
      IF(LEVNUM .GT. 0)
     C   THEN
            IPOS = 17 + (LEVNUM-1)*5
            IF(ISTEP .EQ. 4) IPOS = 318 + (LEVNUM-1)*4
         END IF
C
C
C
      IF (N1 .NE. N2)
     C               THEN
C
C                       CHECK IF THIS IS THE BEGINNING
C                       OF SECTION 6,7,8,9,10
C
                        CALL EXTVAL(IPT,5,IVAL)
C
                        IF(ISTEP .EQ. 5)
     C                     THEN
                              IF(IVAL .EQ. 21212) RETURN 1
                           END IF
C
                        IF(IVAL.EQ.31313) RETURN 8
                        IF(IVAL .EQ. 41414) RETURN 2
C
                        IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C                     (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C                     (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C                     (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C                     (IVAL .EQ. 59595) .OR. (IVAL .EQ. 51525))
     C                     RETURN 3
C
                        IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C                     (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C                     (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C                     (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C                     (IVAL .EQ. 69696)) RETURN 4
C
C                       ERROR, IF NOT ANY SIGNIFICANT LEVEL OR OTHER
C                       SECTION. CHECK IF ONLY NINI IS ERRONEUSLY CODED.
C                       IF THE LEVL HAS TO BE REJECTED TRY TO FIND THE
C                       NEXT LEVEL.
C
                        NPT = IPT
                        CALL NEXSEP2(NPT,IEQ,*9999)
                        CALL NEXPRT2(NPT,IEQ,*9999)
C
                        IF(ITRY .EQ. 0 .AND. IFIX .EQ. 0)
     C                     THEN
                              KERR = 5
                                CALL ERRSTA(IPART,1,IFIRST,NUMERR)
                              IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
C
C                             CHECK IF THERE WERE DUPLICATE GROUPS
C                             ON PREVIOUS LEVEL
C
                              IDUP = 0
                              CALL DUPLIGR(IDUP)
C
                              IF(IDUP .EQ. 1)
     C                           THEN
                                    ITRY = ITRY + 1
                                    IFIX = IFIX + 1
                                    IFIXPOS = IPOS + ISTEP
                                    DO 150 I = IPOS,IPOS+4
                                    KINT(I) = MINDIC
150                                 CONTINUE
                                    GO TO 101
                                 END IF
C
C
C                             CHECK IF NINI GROUP IS ERRONEUS SO THAT
C                             ONE OF THE NI'S IS CORRECT.  IN THIS
C                             CASE CHECK THE 'NINI' OF THE NEXT LEVEL
C                             AND THE PRESSURE OF THIS LEVEL COMPARED
C                             TO THE PREVIOUS LEVEL.  ONLY IF ALL THESE
C                             CONDITIONS ARE FULLFILLED ACCEPT THIS
C                             THIS LEVEL.
C
                              NPT = IPT
                              CALL NEXSEP2(NPT,IEQ,*9999)
                              CALL NEXPRT2(NPT,IEQ,*9999)
                              CALL NEXSEP2(NPT,IEQ,*9999)
                              CALL NEXPRT2(NPT,IEQ,*9999)
                              IF(KCHAR(NPT) .EQ. KCHAR(NPT+1))
     C                           THEN
                                    N1PRE = N1N2PRE/10
                                    N2PRE = N1N2PRE - 10*N1PRE
                                    IF(LEVNUM .EQ. 0)
     C                                 THEN
                                          N1PRE = 0
                                          N2PRE = 0
                                       END IF
                                    N1NEW = N1PRE + 1
                                    N2NEW = N2PRE + 1
                                    IF(N1NEW .EQ. 10) N1NEW = 1
                                    IF(N2NEW .EQ. 10) N2NEW = 1
C
                                    IF(N1 .EQ. N1NEW)
     C                                 THEN
                                          N1N2 = 10*N1 + N1
                                          ITRY = ITRY + 1
                                          IFIX = IFIX + 1
                                          IFIXPOS = IPOS + ISTEP
                                          GO TO 300
                                       ELSE
                                          IF(N2 .EQ. N2NEW)
     C                                       THEN
                                                N1N2 = 10*N2 + N2
                                                ITRY = ITRY + 1
                                                IFIX = IFIX + 1
                                                IFIXPOS = IPOS + ISTEP
                                                GO TO 300
                                             END IF
                                       END IF
                                 END IF
C
C
                             ELSE
                                CALL ERRSTA(IPART,1,IFIRST,NUMERR)
                                 IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                             END IF
C
C
                          IF(LEVNUM .GE. 1 .AND. ITRY .GT. 1)
     C                       THEN
                                DO 200 I=IPOS,IPOS+4
                                KINT(I) = MINDIC
200                             CONTINUE
                             END IF
C
                          IF(IFIX .GE. 2)
     C                       THEN
                                DO 250 I=IFIXPOS,600
                                KINT(I) = MINDIC
250                             CONTINUE
                             END IF
C
                             ITRY = ITRY + 1
                             IF(ITRY .EQ. 1)
     C                          THEN
                                   IF(N2 .EQ. -16)
     C                                THEN
                                         NPT = IPT
                                         CALL PRESEP(NPT,IMI,*270)
                                         CALL PREPRT(NPT,IMI,*270)
                                         LEN = IPT - NPT + 1
                                        IF(LEN .NE. 5 .AND. LEN .NE. 10)
     C                                     THEN
                                              DO 260 I = IPOS,IPOS+6
                                              KINT(I) = MINDIC
260                                           CONTINUE
                                           END IF
                                      END IF
                                END IF
C
270   CONTINUE
                          CALL NEXSEP2(IPT,IEQ,*9999)
                          GO TO 101
                       END IF

300   CONTINUE
C
      CALL EXTVAL(IPT+2,3,IVAL2)
C
C
C
      IF(IVAL2 .EQ. MINDIC)
     C   THEN
            IF(KCHAR(IPT+2).EQ.47 .AND. KCHAR(IPT+3).EQ.47
     C        .AND. KCHAR(IPT+4).EQ.47 )
     C        THEN
                 CALL NEXSEP2(IPT,IEQ,*9999)
                 GO TO 101
              END IF
C
            IF(IPART .EQ. 4)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(IPART,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
C
C           COMMON PRACTICE IN PART D IS TO REPLACE THE LAST DIGIT
C           OF PRESSURE WITH /.  THIS IS REPLACED WITH 0.
C
C
            IF(IPART .EQ. 6)
     C         THEN
                 IF( (KCHAR(IPT+2).GE.48 .AND. KCHAR(IPT+2).LE.57) .AND.
     C               (KCHAR(IPT+3).GE.48 .AND. KCHAR(IPT+3).LE.57) .AND.
     C               (KCHAR(IPT+4).EQ.47) )
     C              THEN
                       KCHAR(IPT+4) = 48
                       CALL EXTVAL(IPT+2,3,IVAL2)
                    ELSE
                       KERR = 5
                       CALL ERRSTA(IPART,2,IFIRST,NUMERR)
                       IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                       CALL NEXSEP2(IPT,IEQ,*9999)
                       CALL NEXPRT2(IPT,IEQ,*9999)
                       CALL NEXSEP2(IPT,IEQ,*9999)
                       GO TO 101
                    END IF
                END IF
         END IF
C
C     CHECK IF THIS IS PART B AND PRESSURE IS < 100 MB
C
      IF(IPART .EQ. 4 .AND. LEVNUM .GT. 3 .AND. IVAL2 .LT. 100)
     C   THEN
C
C           SEE IF '21212' - INDICATOR WAS PASSED UNDETECTED
C
            IF(ISTEP .EQ. 5)
     C         THEN
                  CALL PRE2121(IFOUND)
                  IF(IFOUND .EQ. 1)
     C               THEN
                        NEWSEC = 21212
                        KINT(317) = 21212
                        RETURN 1
                     END IF
               END IF
C
            CALL NEXSEP2(IPT,IEQ,*9999)
            GO TO 101
         END IF
C
C
C     IF ERROR FOUND IN 'NINI' DONT ACCEPT NINI .LE. THE PREVIOUS
C
      IF(ITRY .GT. 0 .AND. IDUP .NE. 1)
     C   THEN
            IF(N1N2 .LE. N1N2PRE .AND. N1N2PRE .NE. 99)
     C         THEN
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
         END IF

C     CHECK THE PRESSURE AGAINST THE PREVIOUS LEVEL.  IF IT
C     LOWER CHECK WHETHER THIS LEVEL IS INCORRECT OR IF IT
C     WAS THE PREVIOUS ONE. REJECT THE ERRONEUS LEVEL.
C     FOR PART B THIS TEST IS CARRIED OUT ONLY FROM THIRD LEVEL
C     ONWARDS, BECAUSE FIRST TWO (OR THREE) LEVELS MAY BE OVER
C     1000 HPA AND ONLY THREE LAST FIGURES ARE USED (I.E. 11030,
C     22020,....)
C
      IF(LEVPRE .EQ. MINDIC) GO TO 500
C
      IF(LEVNUM .GT. 2 .OR. IPART .EQ. 6)
     C   THEN
            IF(IVAL2 .GT. LEVPRE)
     C         THEN
                  IF(IPART .EQ. 4 .AND. LEVNUM .EQ. 3 .AND.
     C               LEVPRE .LT. 50) GO TO 500
C
C
C                 CHECK IF ALL THE PREVIOUS LEVELS WERE ABOVE 1000MB.
C
                  IF(IPART .EQ. 4 .AND. LEVPRE .LT. 50)
     C               THEN
                        DO 400 I = 1,LEVNUM
                        IND = 18 + (I-1)*5
                        IF(ISTEP .EQ. 4) IND = 319 + (I-1)*4
                        IF(KINT(IND) .GT. 50) GO TO 410
400                     CONTINUE
                        GO TO 500
                     END IF
C
410            CONTINUE
C
C
               KERR = 8
C
               IND = 18 + (LEVNUM-1)*5
               IF(ISTEP .EQ. 4) IND = 319 + (LEVNUM-1)*4
               IF(KINT(IND) .LT. 100 .AND. KINT(IND) .NE. MINDIC)
     C            THEN
                     DO 450 I = 1,ISTEP
                     J = IND+I-1
                     KINT(J) = MINDIC
450                  CONTINUE
                  END IF
C
               CALL ERRSTA(IPART,1,IFIRST,NUMERR)
               IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
C                 CHECK WHICH LEVEL IS INCORRECT, OR IF
C                 THE BEGINNING OF NEXT SECTION HAS BEEN
C                 PASSED UNNOTICED (MAY HAPPEN IN CASE
C                 OF MISSING GROUP).
C
                  CALL LEVCHEC(LEVNUM,IPOS,ISTEP,LEVER,NEWSEC,NUMERR)
C
C
                  IF(NEWSEC .EQ. 21212) RETURN 1
                  IF(NEWSEC.EQ.31313) RETURN 8
                  IF(NEWSEC .EQ. 41414) RETURN 2
                  IF(NEWSEC .EQ. 51515) RETURN 3
                  IF(NEWSEC .EQ. 61616) RETURN 4
C
C
                  IF(LEVER .EQ. 2) GO TO 500
                  IF(LEVER .EQ. 3)
     C               THEN
                        ITRY = ITRY + 1
                        N1N2PRE = N1N2
                        GO TO 101
                     END IF
C
C
                 RETURN 6
              END IF
           END IF
C
C
500   CONTINUE
      N1N2PRE = N1N2
      RETURN 7
C
9999  CONTINUE
      RETURN 5
C
      END
      
      SUBROUTINE DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C**** *DDFFF*
C
C
C     PURPOSE.
C
C
C         DECODE WIND DIRECTION AND SPEED
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)*
C
C          INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C                   :  IFF     - WIND SPEEDIN METERS/SEC OR KNOTS
C                   :  IWW     - WIND SPEED INDICATOR (1 FOR KNOTS)
C                   :  ICOUNT  - COUNTRY NUMBER
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C                      ISPEED  - DECODED WIND SPEED
C
C              IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C              ANY ERRORS FOUND IN IDD, IFF OR IWW
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C*          1.   DECODE WIND DIRECTION AND SPEED.
C                --------------------------------
 100  CONTINUE
C
C      CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC .OR. IFF .EQ. MINDIC) RETURN
C
C     CHECK IF IDD ID FEASABLE
C
      IF(IDD .LT. 0 .OR. IDD .GT. 36) RETURN
C
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C
C
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
C
C
C
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      IF(ISPEED .GE. 500) THEN
                             ISPEED=ISPEED-500
                             IDIR=IDIR+5
                            END IF
C
C
C     IF SPEED IN KNOTS MODIFY IT TO M/S
C
      IF(IWW .EQ. 1) CALL KTOMPSI(ISPEED)
C
      RETURN
      END
      
      SUBROUTINE PREPRT(I,J,*)
C
C**** *PREPRT*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR PREVIOUS CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PREPRT(I,J,*)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE PRE2121 (IFOUND)
C
C**** *XXXXXXX*
C
C
C     PURPOSE.
C     --------
C
C         SCANS THE REPORT BACKWARDS TRYING TO FIND
C         '21212'-GROUP OR CORRUPTED '21212'-GROUP, WHERE
C         ALL BUT ONE FIGURE MATCH WITH CORRECT GROUP.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRE2121 (IFOUND)*
C
C          INPUT     : IPT    -   POINTER TO THE BEGINNING OF SCANNING
C
C          OUTPUT    : IFOUND = 1  IF THE GROUP WAS FOUND
C                             = 0  OTHERWISE
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION ICONST(5),KK(5)
C
      DATA ICONST / 20000 , 1000 , 200, 10 , 2 /
C
C
C     ------------------------------------------------------------------
C*          1.   TRY TO FIND 21212 GROUP.
C                ------------------------
 100  CONTINUE
C
C
      IFOUND = 0
      JPT = IPT
C
C     UP TO THREE PREVIOUS GROUPS ARE CHECKED
C
C
         DO 101 IROU=1,3
C
         CALL PRESEP(JPT,IMI,*10000)
         CALL PREPRT(JPT,IMI,*10000)
         CALL PRESEP(JPT,IMI,*10000)
         CALL NEXPRT2(JPT,IEQ,*10000)
C
C
C        SEE IF THIS IS COMPLETE '21212' - GROUP
C
         CALL EXTVAL(IPT,5,IVAL)
C
         IF(IVAL .EQ. 21212)
     C      THEN
               IFOUND = 1
               IPT = JPT
               RETURN
            END IF
C
            DO 102 I=1,5
            J = JPT+I-1
            KK(I) = KCHAR(J) .AND. 127
            KK(I) = KK(I) - 48
102         CONTINUE
C
C
            DO 103 I=1,5
            KCA = 0
               DO 104 J=1,5
               IF(J .EQ. I)
     C            THEN
                     KCA = KCA + ICONST(I)
                  ELSE
                     KCA = KCA + KK(J) * 10**(5-J)
                  END IF
104            CONTINUE
            IF(KCA .EQ. 21212)
     C         THEN
                  IFOUND = 1
                  IPT = JPT
                  RETURN
               END IF
103         CONTINUE
101      CONTINUE
C
10000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXSEP2 ( I,J,*)
C
C**** *NEXSEP2*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C         'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C                         IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                         ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXSEP2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C	R. CINTRA    *CPTEC*.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  SCAN BULLETIN.                     .
C                -------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXPRT2(I,J,*)
C
C**** *NEXPRT2*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXPRT2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXTEQ ( I,J )
C
C**** *NEXTEQ*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '=' CHARACTER.
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEQ(I,J)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
C     '=' IS 61 .
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 61) RETURN
  101 CONTINUE
C
      I=J
      RETURN
      END
      
      SUBROUTINE EXTINT ( I,N,K )
C
C**** *EXTINT*
C
C
C     PURPOSE.
C     --------
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN WORD K OF 'KINT' .
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTED.
C
C         OUTPUT    : I - POINTS TO CHARACTER AFTER THE LAST ONE EXTRACTED.
C                         MADE NEGATIVE IF A 'SEPARATOR' IS FOUND IN THE
C                         CHARACTERS BEING EXTRACTED.
C                         IF NEGATIVE , THE ABSOLUTE VALUE IS POSITION OF
C                         'SEPARATOR' ENCOUNTERED .
C                     K - INTEGER VALUE IN WORD K OF 'KINT'. MISSING DATA
C                         VALUE INSERTED IF '/' OR NON DIGIT ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTINT ( I,N,K )*
C
C     AUTHOR.
C     -------
C
C          J. HENNESSY
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES.
C                ------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
C*           1.1 STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE.
C                ------------------------------------------------------------
 110  CONTINUE
C
      DO 111 J=IA,IB
C
      KTEMP=KCHAR(J)
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C
C          CHECK FOR SPACE,LINE FEED AND CARRIAGE RETURN CHARACTER .
C
           IF ( KAR .EQ. 32 .OR. KAR .EQ. 10 .OR. KAR .EQ. 13)
     C                           THEN
                                      I = - J
                                      KINT(K) = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     I = IB + 1
                                     KINT(K) = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR .LT. 48 .OR. KAR .GT. 57 )
     C                      THEN
                                  DO 112 JA=1,11
                                       IF ( KAR .EQ. ILET(JA))
     C                                       KAR = IFIG(JA)
  112                             CONTINUE
                           END IF
C
           IF ( KAR .GE. 48 .AND. KAR .LE. 57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      KINT(K) = MINDIC
                                      I = IB + 1
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  111 CONTINUE
C
      KINT(K) = IAC / 10
      I = J
C
C
      RETURN
      END
      
      SUBROUTINE NEXTPRT ( I,J )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTSEP ( I,J )
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C                        'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTEND ( I,J )
C
C**** *NEXTEND*
C
C
C     PURPOSE.
C     --------
C         FUNCTION  : LOCATE NEXT OCCURRENCE OF EITHER 'CR' OR 'LF'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' CHARACTER.
C                     I > J INDICATES NO CHARACTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 .
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. 13 .OR. KAR .EQ. 10 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTBULL ( I,M )
C
C**** *PRTBULL*
C
C
C     PURPOSE.
C     --------
C         PRINTS BULLETIN IN ARRAY 'KCHAR'
C
C         INPUT      : BULLETIN IN 'KCHAR' .
C                      I - PRINT STARTS AT CHARACTER I
C                      M - PRINT ENDS AT CHARACTER M .
C
C         OUTPUT     : BULLETIN IS PRINTED . ARRAY 'KCHAR' AND POINTERS
C                      UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTBULL(I,M)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
C      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION LINE(80)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BULLETIN.
C                ---------------
 100  CONTINUE
C
      IP = I
      J = M
      K = 80
C
C*          1.1  SET OUTPUT LINE TO ALL SPACES .
C                -------------------------------
 110  CONTINUE
C
      DO 111 N=1,K
             LINE(N) = 32
  111 CONTINUE
C
C     LOCATE START AND END OF NEXT LINE OF CHARACTERS ( IF ANY ).
C
      CALL NEXTPRT ( IP,J )
      IF ( IP.GT.J ) RETURN
      JP = IP
      CALL NEXTEND ( JP,J )
      K = JP - IP
C
C     INSERT IN OUTPUT LINE AND SUPPRESS PARITY BIT.
C
      DO 112 N =1,K
             LINE(N) = KCHAR(IP).AND.127
             IP = IP + 1
  112 CONTINUE
C
      WRITE ( *,9900) (LINE(N),N=1,K)
C
C     GET NEXT LINE
C
      GO TO 110
C
 9900 FORMAT (1H ,80A1)
C
      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER *10 IFA
      CHARACTER CUNIT*24,CVAL*9
C
      CHARACTER CTABBEN*64,CTABBU*24
      CHARACTER*8 YDATE
      CHARACTER*5 YTIME,YFAMILY,YTASK
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comtab.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comstd.h'
      include 'comdate.h'
C
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE.
C
C
C
C
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING OF
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS ,
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'17777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                          '7777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CALL SETTAB( IERR )
      IF(IERR.NE.0) CALL EXIT(2)
C     --------------------------------------------------------------------
C*          9.   SET UP WMO STATION LIST AND IMPORTANT STATIONS.
C                -----------------------------------------------
 900  CONTINUE
C
      CALL STATION(IERR)
      IF(IERR.NE.0) CALL EXIT(2)
C     --------------------------------------------------------------------
C*          10.   SET UP date of observations.
C                -----------------------------------------------
 905  CONTINUE
C
      call datim (ny,nm,nd,nutc,nh,nmin,nsec,ncc)

      if (nm .lt. 0) nm = nm * -1     
c       print*,'initvar',ny,nm,nd 

C     --------------------------------------------------------------------
C*          10.   SET UP HEIGHT AND PRESSURE OF STANDARD ATMOSPHERE.
C                ---------------------------------------------------
1000  CONTINUE
C
      OPEN(UNIT=8,IOSTAT=IOS,ERR=1020,
     1     FILE='standard_atmosphere.dat',
     3     READONLY,
     4     STATUS='OLD')
c
      DO 1001 I=1,512
      READ(UNIT=8,FMT=7777,ERR=1010,END=1100,IOSTAT=IOS)  SH(I),P(I)
 7777 FORMAT(1X,F5.0,2X,F8.2)
 1001 CONTINUE
C
      CLOSE(8)
C
      GO TO 1100
c
 1020 CONTINUE
C
      PRINT*,' Open error ',ios,' on file standard_atmosphere.dat'
      CALL EXIT(2)
C
 1010 CONTINUE
c
      PRINT*,' Read error ',ios,' on file standard_atmosphere.dat'
      CALL EXIT(2)
C  
C*            11. GET SUPERVISOR DATE,TIME,FAMILY AND TASK.
C                 -----------------------------------------
 1100 CONTINUE
C
C      READ(*,'(A8,A5,A5,A5)') YDATE,YTIME,YFAMILY,YTASK
C
      RETURN
      END
      
      SUBROUTINE NEXTFIG ( I,K )
C
C**** *NEXTFIG*
C
C
C     PURPOSE.
C     --------
C         LOCATE FIRST WORD CONTAINING A FIGURE IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO FIGURE FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTFIG(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT FIGURE.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 48 .AND. KAR .LE. 57 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTLET ( I,K )
C
C**** *NEXTLET*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE FIRST WORD CONTAINING A LETTER IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO LETTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTLET(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT LETTER.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 110 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 65 .AND. KAR .LE. 90 ) RETURN
  110 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    N1 - NUMBER OF CHARACTERS CONVERTED TO FIRST INTEGER
C                    N2 -    "    "     "          "     " SECOND   "
C                    N3 -    "    "     "          "     "  THIRD   "
C                    N4 -    "    "     "          "     "  FOURTH  "
C                    N5 =    "    "     "          "     "  FIFTH   "
C
C
C                    N - INDEX TO ARRAY 'KINT' , WHERE THE INSERTION OF
C                        INTEGER VALUES STARTS.
C                        VALUES ARE INSERTED IN CONSECUTIVE WORDS.
C
C                    IRET = 0 , ALL CONVERSIONS PERFORMED OK.
C                         = N , ERROR FOUND IN N TH INTEGER CONVERSION.
C
C                    I - POINTS TO CHARACTER AFTER LAST ONE EXTRACTED ,
C                        UNLESS A 'SEPARATOR' (= 'SPACE' , 'LINE FEED',
C                        'CARRIAGE RETURN') IS ENCOUNTERED IN FIGURES
C                        BEING EXTRACTED . IN THIS CASE I IS MADE NEGATIVE
C                        WITH THE ABSOLUTE VALUE OF 'I' POINTING TO THE
C                        'SEPARATOR' FOUND. IN THIS CASE ALSO THE WHOLE
C                        GROUP IS DELETED FROM 'KINT'.
C
C                        INTEGER VALUES EXTRACTED PUT IN WORDS N,N+1 ETC
C                        OF ARRAY 'KINT' .
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXTINT(I,N,K)*
C
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      NN(1) = N1
      NN(2) = N2
      NN(3) = N3
      NN(4) = N4
      NN(5) = N5
C
      IRET = 0
C
      K = N
C
C
C
C*          1.1  CONVERT GROUP .
C                ---------------
 110  CONTINUE
C
      DO 111 J=1,5
         IF ( NN(J).EQ.0 ) RETURN
         CALL EXTINT ( I,NN(J),K )
         IF ( I.LT.0 ) THEN
                            IRET = J
                               DO 50 JJ=1,5
                               IF(NN(JJ) .EQ. 0) RETURN
                               KINT(N+JJ-1) = MINDIC
50                             CONTINUE
                            RETURN
                       END IF
         K = K + 1
  111 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRFILE( IHEAD,IERR )
C
C**** *ERRFILE*
C
C
C     PURPOSE.
C     --------
C         WRITE PROBLEM BULLETIN TO THE ERROR FILE TOGATHER WITH
C         KEY.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRFILE(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      CHARACTER*1 Y63
      CHARACTER*80 YOUT,YOUTA
      CHARACTER*16384 YCHAR
      CHARACTER*3 YSPEC
C
      YSPEC=CHAR(13)//CHAR(13)//CHAR(10)
      Y63  =CHAR(63)
C     ------------------------------------------------------------------
C
C*          1.   WRITE BULLETIN TO THE ERROR FILE.
C                ---------------------------------
 100  CONTINUE
C
      J1=1
C
C*          1.1  OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 110  CONTINUE
C
              OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C        FILE='PILO.error.dat',
     C        STATUS='UNKNOWN',
     C        CARRIAGECONTROL='LIST',
     C        SHARED,RECL=80                      )
C
C     -----------------------------------------------------------------
C*          2. INITIALIZE POINTERS.
C              --------------------
 200  CONTINUE
C
      IST=1
      IEND=1
C
C
C     -----------------------------------------------------------------
C*          3. WRITE BULLETIN INTO ERROR FILE AND MARK ERROR.
C              ----------------------------------------------
 300  CONTINUE
C
      YOUT=' '
      YOUTA=' '
C
      CALL NEXTEND(IEND,ILEN)
      IF(IEND.GT.ILEN) GO TO 500
      CALL NEXTPRT(IEND,ILEN)
C      IF(IEND.GT.ILEN) GO TO 500
      IEND=IEND-1
C
      II=0
C
      DO 301 I=IST,IEND
C
      II=II+1
      IF(KCHAR(I).GT.127) THEN
                             YOUTA(II:II)=Y63
                             ISIGN=1
                          END IF
      YOUT(II:II)=CHAR(KCHAR(I).AND.127)
C
 301  CONTINUE
C
      IEND=IEND+1
      IST=IEND
C
      WRITE(10,'(A)') YOUT
      IF(ISIGN.EQ.1)  WRITE(10,'(A)') YOUTA
      ISIGN=0
C
C
      GO TO 300
C
 400  CONTINUE
C
      PRINT*,'+++ ERROR DURING OPENNING UNIT 10 +++, IOS=',IOS
C
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTVAL ( I,N,K )
C
C**** *NEXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE FIRST WORD CONTAINING THE VALUE 'N' IN
C         ARRAY 'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT    : 'KCHAR' CONTAINS ONE BULLETIN , ONE CHARACTER PER
C                    WORD.
C
C         OUTPUT   : I = REQUIRED LOCATION . I > K MEANS VALUE NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTVAL(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT VALUE.
C                --------------
 100  CONTINUE
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. N ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKEDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE
C
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ. 1)  WRITE(*,30000) I,(IA(IK),IK=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(IK),IK=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(IK),IK=I,I2)
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE
C
C
C
C
C
      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,KL,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     KL      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,KL,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,KL
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PILOEXP(K,IERR )
C
C**** *PILOEXP*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR PILOT DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PILOEXP(K,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATUM(I,J,K)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h'
      include 'comdate.h'
C
      CHARACTER*9 CVAL,CIDENT
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C*          1.   INCREASE COUNTER OF SUBSETS BY ONE.
C                -----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
C     CHECK IF NIL REPORT
C
      IF(KDEC(20).EQ.1) THEN
         IERR=1
         RETURN
      END IF
C       
      NSUB=1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao 
c     do compilador FORTRAN
c	n = nsub
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------      
      Ns=NSUB
      IREP=0
C
      DO 101 I=1,JP22
      DO 102 J=1,JP1
      VALUES(I,J)=999999.
 102  CONTINUE
 101  CONTINUE
C
C*          1.1  GET CURRENT DATE (YEAR AND MONTH).
C                ----------------------------------
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
c      print*,'datum',iyear,imonth      
C
C     ------------------------------------------------------------------
C*          2.   PILOT - LAND BASED STATION.
C                --------------------------
 200  CONTINUE
C
      IF(KDEC(4).EQ.32) THEN
C     -----------------------------------------------------------------
C*          2.1  PILOT PART A OR C.
C                ------------
 210  CONTINUE
C
         IF(K.EQ.1.OR.K.EQ.3) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=FLOAT(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
C
            IREP=0
            IP=14
            IPKD=25
C
            IL=9
            IF(K.EQ.3) IL=5
C
            DO 211 I=1,IL
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 211
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=kdec(IPKD)*10.
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 211        CONTINUE
C
C
C           MAX. WIND LEVEL  ( pressure)
C
            IPKD=52
C
            DO 213 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+5
               ELSE
                  GO TO 215
               END IF

C
 213        CONTINUE
C
 215  CONTINUE
C
C           MAX. WIND LEVEL  ( geopotential )
C
            IPKD=67
C
            DO 2130 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=999999.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  IF(KDEC(IPKD).NE.MINDIC)
     1             VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+5
               ELSE
                  GO TO 2150
               END IF

C
 2130       CONTINUE
C
 2150 CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C 
            VALUES(13,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           WIND SHEAR AT MAX. WIND LEVEL ( pressure )
C
            IPKD=52
            ISHEAR=0
            IPTSH=IP
            IP=IP+1
C
            DO 216 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  ISHEAR=ISHEAR+1
                  VALUES(IPTSH,NSUB)=FLOAT(ISHEAR)
                  VALUES(IP  ,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+5
C
               ELSE
                  IF(ISHEAR.EQ.0) GO TO 217 
                  GO TO 2170
               END IF

C
 216        CONTINUE
C
 217  CONTINUE
C
C           WIND SHEAR AT MAX. WIND LEVEL ( geopotential )
C
            IPKD=67
            ISHEAR=0
C
            DO 2160 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  ISHEAR=ISHEAR+1
                  VALUES(IPTSH,NSUB)=FLOAT(ISHEAR)
                  VALUES(IP  ,NSUB)=999999.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  IF(KDEC(IPKD).NE.MINDIC)
     1             VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+5
C
               ELSE
                  GO TO 2170
               END IF

C
 2160       CONTINUE
C
 2170 CONTINUE
C
C     UPDATE M TOTAL LENGTH OF REPORT
C
      IF(ISHEAR.NE.0) M=IP-1
C
C             SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C             ----------------------------------------------
C
      NBUFTYPE=2       ! BUFR TABLE A 
      NTYPE=4                           ! WIND PROFILE
      IF(KDEC(4).EQ. 32) NSBTYPE=91      ! PILOT
      IF(KDEC(4).EQ. 33) NSBTYPE=92     ! PILOT SHIP
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT=CHAR(KINT(12))//CHAR(KINT(13))//
     1       CHAR(KINT(14))//CHAR(KINT(15))//
     2       CHAR(KINT(16))//'    '
      NRECR=1
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*          2.3  PILOT PART B OR D.
C                ------------------
 230  CONTINUE
C
         IF(K.EQ.2.OR.K.EQ.4) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=FLOAT(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
C
C
C           GEOPOTENTIAL AS VERTICAL COORDINATE
C
            IREP=0
            IP=14
            IPKD=25
C
            DO 231 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 231
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=999999.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC) THEN
               IF(KDEC(IPKD).EQ.0) THEN
                  VALUES(IP+1,NSUB)=66.
                  VALUES(IP+2,NSUB)=KDEC(8)*9.8
               ELSE
                   VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
               END IF
            END IF
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 231        CONTINUE
C
C           PRESSURE AS VERICAL COORDINATE
C
C
            IPKD=205
C
            DO 232 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 232
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 232        CONTINUE
C
C
C
C           UPDATE REPLICATION FACTOR
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C 
            VALUES(13,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C           ----------------------------------------------
C
      NBUFTYPE=2       ! BUFR TABLE A 
      NTYPE=4                           ! WIND PROFILE
      IF(KDEC(4).EQ. 32) NSBTYPE=91      ! PILOT
      IF(KDEC(4).EQ. 33) NSBTYPE=92     ! PILOT SHIP
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT=CHAR(KINT(12))//CHAR(KINT(13))//
     1       CHAR(KINT(14))//CHAR(KINT(15))//
     2       CHAR(KINT(16))//'    '
      NRECR=1
C
            RETURN
                    END IF
                       END IF 
C     -----------------------------------------------------------------
C*          3.   PILOT - SHIP REPORTS.
C                -------------------------
 300  CONTINUE
C
      IF(KDEC(4).EQ.33)
     1   THEN
C     -----------------------------------------------------------------
C*          3.1  PILOT PART A OR C.
C                ------------
 310  CONTINUE
C
         IF(K.EQ.1.OR.K.EQ.3) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(KINT(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=999999.
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
C
            IREP=0
C
            IP=14
            IPKD=25
c
            IL=9
            IF(K.EQ.3) IL=5
C
            DO 311 I=1,IL
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 311
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=kdec(IPKD)*10.
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 311        CONTINUE
C
C
C           MAX. WIND LEVEL ( pressure )
C
            IPKD=52
C
            DO 313 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+5
               ELSE
                  GO TO 315
               END IF

C
 313        CONTINUE
C
 315  CONTINUE
C
C           MAX. WIND LEVEL ( geopotential )
C
            IPKD=67
C
            DO 3130 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=999999.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  IF(KDEC(IPKD).NE.MINDIC)
     1             VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+5
               ELSE
                  GO TO 3150
               END IF

C
 3130       CONTINUE
C
 3150 CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C 
            VALUES(13,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           WIND SHEAR AT MAX. WIND LEVEL ( pressure )
C
            IPKD=52
            ISHEAR=0
            IPTSH=IP
            IP=IP+1
C
            DO 316 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  ISHEAR=ISHEAR+1
                  VALUES(IPTSH,NSUB)=FLOAT(ISHEAR)
                  VALUES(IP  ,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+5
C
               ELSE
                  IF(ISHEAR.NE.0) GO TO 3170
                  GO TO 317
               END IF

C
 316        CONTINUE
C
 317  CONTINUE
C
C           WIND SHEAR AT MAX. WIND LEVEL ( geopotential )
C
            IPKD=67
            ISHEAR=0
C
            DO 3160 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  ISHEAR=ISHEAR+1
                  VALUES(IPTSH,NSUB)=FLOAT(ISHEAR)
                  VALUES(IP  ,NSUB)=999999.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  IF(KDEC(IPKD).NE.MINDIC)
     1             VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+5
               ELSE
                  GO TO 3170
               END IF

C
 3160       CONTINUE
C
 3170 CONTINUE
C
C     UPDATE M TOTAL LENGTH OF REPORT
C
      IF(ISHEAR.NE.0) M=IP-1
C
C             SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C             ----------------------------------------------
C
      NBUFTYPE=2       ! BUFR TABLE A 
      NTYPE=4                           ! WIND PROFILE
      IF(KDEC(4).EQ. 32) NSBTYPE=91      ! PILOT
      IF(KDEC(4).EQ. 33) NSBTYPE=92     ! PILOT SHIP
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(12,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CVAL(NSUB)
      NRECR=1
C
            RETURN
                    END IF
C
C     -----------------------------------------------------------------
C*          3.3  PILOT PART B OR D.
C                ------------------
 330  CONTINUE
C
         IF(K.EQ.2.OR.K.EQ.4) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(KINT(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=999999.
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
C
C
C           GEOPOTENTIAL AS VERTICAL COORDINATE
C
            IREP=0
            IP=14
            IPKD=25
C
            DO 331 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 331
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=999999.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC)
     1       VALUES(IP+2,NSUB)=kdec(ipkd)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 331        CONTINUE
C
C           PRESSURE AS VERICAL COORDINATE
C
C
            IPKD=205
C
            DO 332 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 332
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+5
            IPKD=IPKD+3
C
 332        CONTINUE
C
C
C
C           UPDATE REPLICATION FACTOR
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C 
            VALUES(13,NSUB)=FLOAT(IREP)
            M=IP-1
C
C               SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C               ----------------------------------------------
C
      NBUFTYPE=2       ! BUFR TABLE A 
      NTYPE=4                           ! WIND PROFILE
      IF(KDEC(4).EQ. 32) NSBTYPE=91      ! PILOT
      IF(KDEC(4).EQ. 33) NSBTYPE=92     ! PILOT SHIP
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(12,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CVAL(NSUB)
      NRECR=1
C
            RETURN
           END IF
         END IF
C
      RETURN
      END
      
      SUBROUTINE BUFRENC(IERR )
C
C**** *BUFRENC*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL TEMP
C         REPORT FROM FULLY EXPANDED BUFR FORMAT INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUFRENC(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SETWT(IERR)*
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1(IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3(IERR)*
C         *CALL* *SEC4(IERR)*
C         *CALL* *SEC5(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C           1.1 SET WORKING TABLES AND BUFR SECTION DATA.
C               -----------------------------------------
 110  CONTINUE
C
      CALL SETWT( IERR )
      CALL SEC0 ( IERR )
      CALL SEC1 ( IERR )
      CALL SEC2 ( IERR )
      CALL SEC3 ( IERR )
      CALL SEC4 ( IERR )
      CALL SEC5 ( IERR )
C
      CALL PUTBUFR( IERR )
C     ------------------------------------------------------------------
C
      RETURN
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT,24)
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1( IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSNUM,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      RYEAR=VALUES(5,1)
      IF(KDEC(4).EQ.36) RYEAR=VALUES(6,1)
C
      IYEAR=RYEAR
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100.)
      if (iyear .eq. 0) iyear=100
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      IMONTH=VALUES(6,1)
      IF(KDEC(4).EQ.36) IMONTH=VALUES(7,1)
      CALL PACK(NBPW,MBUF(NWPT),IMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      IDAY=VALUES(7,1)
      IF(KDEC(4).EQ.36) IDAY=VALUES(8,1)
      CALL PACK(NBPW,MBUF(NWPT),IDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      IHOUR=VALUES(8,1)
      IF(KDEC(4).EQ.36) IHOUR=VALUES(9,1)
      CALL PACK(NBPW,MBUF(NWPT),IHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                --------------
 1400 CONTINUE
C
      IMIN=VALUES(9,1)
      IF(KDEC(4).EQ.36) IMIN=VALUES(10,1)
      CALL PACK(NBPW,MBUF(NWPT),IMINUTE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C.
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt = 0
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---- -------- -- --- -------- -- --- -------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY (48 BYTES).
C                --------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C
C     ------------------------------------------------------------------
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3(IERR )
C
C**** *SEC3*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS WHICH DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     PILOT - LAND STATION
C
      IF(KDEC(4).EQ.32) THEN
            CALL PACK(NBPW,MBUF(NWPT), 3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 8)
C 
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 5,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 7,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 4,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT), 8,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),10,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 3,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT, 8)
C
            IF(LSHEAR) THEN
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),61,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),62,NWPT,NBPT, 8)
            END IF
            GO TO 170
         END IF
C
C     PILOT - SHIP
C
      IF(KDEC(4).EQ.33)
     1   THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),23,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),10,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 8)
            IF(LSHEAR)
     1         THEN
                  CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),61,NWPT,NBPT, 8)
c
                  CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
                  CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
                  CALL PACK(NBPW,MBUF(NWPT),62,NWPT,NBPT, 8)
               END IF
         END IF
C
C     ------------------------------------------------------------------
C*          1.7  SET UP QUALITY CONTROL DECSCRIPTORS.
C                ------------------------------------
 170  CONTINUE
C
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 171 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 171  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 180
C
      MQ=M+4
      CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
c
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT), 33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),  7,NWPT,NBPT, 8)
C
C     ------------------------------------------------------------------
C*          1.8  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 180  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC4( IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      DO 201 I=1,Ns
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
C
      IF(YUNIT.EQ.'CCITTIA5') THEN
         IST=NINT(VAL)/1000
         NCHAR=NINT(VAL)-IST*1000
         YVAL=CVAL(IST)
         DO 203 II=1,NCHAR
         IPACK=ICHAR(YVAL(II:II))
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203     CONTINUE
         GO TO 202
      END IF
C
      IF(VAL.EQ.999999.) THEN
         CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
      ELSE
         IF(ISCALE.LT.0) THEN
            ISCALE=IABS(ISCALE)
            IPACK=NINT(VAL/10.**ISCALE) - IREF
         ELSE
            IPACK=NINT(VAL*10.**ISCALE) - IREF
         END IF
C
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
      END IF
C
 202  CONTINUE
C
      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.031031) THEN
C 
c          set replication factor for bit presence indicator
c
           CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT,16)
C
C          SET BIT FLAG
C
           IBIT1=0
C
           DO 215 JI=M+1,M+M
            IPACK=1
            IF(VALUES(JI,I).NE.999999.) IPACK=0
            CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
 215       CONTINUE
C           
        END IF
C
       IF(IREV.EQ.001031) THEN
          VAL=46.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
       IF(IREV.EQ.001032) THEN
          VAL=999999.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
C
       IF(IREV.EQ.001201) THEN
          VAL=1.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.033007) THEN
C
C          SET REPLICATION FACTOR FOR % CONFIDENCE
C
C
           IBIT1=0
           DO 217 IK=M+1,M+M
            IF(VALUES(IK,I).NE.999999.) IBIT1=IBIT1+1
 217       CONTINUE
C
           CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT,16)
C
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 216       CONTINUE
C
        END IF
C
 210    CONTINUE
C
      END IF
C
 201  CONTINUE
C
C
C     ------------------------------------------------------------------
C*         12.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 1200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 1300 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         croot='./'
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
      
C
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------      
      END
      
      SUBROUTINE SETWT(IERR)
C
C**** *SETWT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWT(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
C
      CHARACTER*9  CVAL
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
C
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
      
      DIMENSION ITBTRL(28),ITBTRS(28),ITBTRA(1000)
C
      DATA ITBTRL/001001,001002,002011,002012,004001
     1,           004002,004003,004004,004005,005001
     2,           006001,007001,031001,007004,008001
     5,           007003,011001,011002,031001,007004
     6,           008001,007003,011061,011062,031031
     7,           001031,001201,033007/
      DATA ITBTRS/001011,001012,001013,002011,002012
     1,           004001,004002,004003,004004,004005
     2,           005002,006002,031001,007004,008001
     4,           007003,011001,011002,031001,007004
     5,           008001,007003,011061,011062,031031
     6,           001031,001201,033007/
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR PILOT DATA.
C                -------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      LSHEAR=.FALSE.
C
      IF(KDEC(4).EQ.32)
     1   THEN
            J=0
C
            DO 101 I=1,13
            J=J+1
            ITBTRA(J)=ITBTRL(I)
 101        CONTINUE
C
            JJ=14
C
            IREP=NINT(VALUES(13,NSUB))
C
            DO 102 I=1,IREP
C
            J=J+1
            ITBTRA(J)=ITBTRL(JJ  )
            J=J+1
            ITBTRA(J)=ITBTRL(JJ+1)
            J=J+1
            ITBTRA(J)=ITBTRL(JJ+2)
            J=J+1
            ITBTRA(J)=ITBTRL(JJ+3)
            J=J+1
            ITBTRA(J)=ITBTRL(JJ+4)
C
 102        CONTINUE
C
            IS=IREP*5+13
            IF(IS.LT.M)
     1         THEN
                  LSHEAR=.TRUE.
                  J=J+1
                  ITBTRA(J)=ITBTRL(19)
                  IPTSH=IS+1
                  IREPS=NINT(VALUES(IPTSH,NSUB))
C
                  JJ=20
C
                  DO 103 I=1,IREPS
                  J=J+1
                  ITBTRA(J)=ITBTRL(JJ  )
                  J=J+1
                  ITBTRA(J)=ITBTRL(JJ+1)
                  J=J+1
                  ITBTRA(J)=ITBTRL(JJ+2)
                  J=J+1
                  ITBTRA(J)=ITBTRL(JJ+3)
                  J=J+1
                  ITBTRA(J)=ITBTRL(JJ+4)
 103              CONTINUE
C
               END IF
C
            J=J+1
            ITBTRA(J)=ITBTRL(25)
            J=J+1
            ITBTRA(J)=ITBTRL(26)
            J=J+1
            ITBTRA(J)=ITBTRL(27)
            J=J+1
            ITBTRA(J)=ITBTRL(28)
C
            GO TO 110
         END IF
C
      IF(KDEC(4).EQ.33)
     1   THEN
            J=0
C
            DO 111 I=1,13
            J=J+1
            ITBTRA(J)=ITBTRS(I)
 111        CONTINUE
C
            JJ=14
C
            IREP=NINT(VALUES(13,NSUB))
C
            DO 112 I=1,IREP
C
            J=J+1
            ITBTRA(J)=ITBTRS(JJ  )
            J=J+1
            ITBTRA(J)=ITBTRS(JJ+1)
            J=J+1
            ITBTRA(J)=ITBTRS(JJ+2)
            J=J+1
            ITBTRA(J)=ITBTRS(JJ+3)
            J=J+1
            ITBTRA(J)=ITBTRS(JJ+4)
C
 112        CONTINUE
C
            IS=IREP*5+13
            IF(IS.LT.M)
     1         THEN
                  LSHEAR=.TRUE.
                  J=J+1
                  ITBTRA(J)=ITBTRS(19)
                  IPTSH=IS+1
                  IREPS=NINT(VALUES(IPTSH,NSUB))
C
                  JJ=20
C
                  DO 113 I=1,IREPS
                  J=J+1
                  ITBTRA(J)=ITBTRS(JJ  )
                  J=J+1
                  ITBTRA(J)=ITBTRS(JJ+1)
                  J=J+1
                  ITBTRA(J)=ITBTRS(JJ+2)
                  J=J+1
                  ITBTRA(J)=ITBTRS(JJ+3)
                  J=J+1
                  ITBTRA(J)=ITBTRS(JJ+4)
 113              CONTINUE
C
               END IF
C
C
            J=J+1
            ITBTRA(J)=ITBTRS(25)
            J=J+1
            ITBTRA(J)=ITBTRS(26)
            J=J+1
            ITBTRA(J)=ITBTRS(27)
            J=J+1
            ITBTRA(J)=ITBTRS(28)
         END IF
C
 110  CONTINUE
C
      DO 121 I=1,J
C
      ITR=ITBTRA(I)
C
      DO 122 II=1,JP2
C
      IF(ITR.EQ.NTABBTR(II)) THEN
                               IWTR (I)=NTABBTR(II)
                               IWTS (I)=NTABBS (II)
                               IWTDW(I)=NTABBDW(II)
                               IWTRV(I)=NTABBRV(II)
                               CUNIT(I)=CTABBU(II)
                               GO TO 121
                            END IF
C
 122  CONTINUE
C
      PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 121  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PUTBUFR( IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C

      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      parameter (idime=19)
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
      include 'comrec.h'
      include 'comdate.h'      
C
      common /rec_writen/ irecswriten
      common /repetida/ irepetida
c
      character*99 recwriten,records_writen(4000)
      character*80 yfilename
      character*19 ysd
c
      common /comaux/ yfilename,ysd
c
      CHARACTER*15000 YOUT
      CHARACTER*9  CIDENT
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      CHARACTER*16 YTYPE
      character*18 CFNAME
      CHARACTER*16 YTIME
      CHARACTER*31 YCFNAME
      character*6  cc
c
      character*11 ctabname
      character*17 ctstamp
      character*4  cstream
C
      DIMENSION IKEY(12)
      dimension iflags(idime)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)
c
      data iflags/1,1,1,1,1,1,2,2,2,2,9*0/
C
C
C     ------------------------------------------------------------------
C*          1. DEFINE RDB FILE NAME AND OPEN RDB FILE.
C                -------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C 
      ierr=0
c      call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
       nmonth = nm
       nday = nd
       nhour = nh
       nminute = nmin
       nsecond = nsec
       
c      icen = ny*.01        
c      NY=NY - (icen *100) 
C
      WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101) 
     1      NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND

      ctabname='PILO_'//ytime(1:8)
      GO TO 102
C
 101  CONTINUE
C
      PRINT*,'BAD DATE OR TIME, REPORT SKIPPED. IOS=',IOS
      RETURN
C
 102  CONTINUE
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      YKEY(13:13)=CIDENT(1:1)
      YKEY(17:17)=CIDENT(5:5)
      YKEY(18:18)=CIDENT(4:4)
      YKEY(19:19)=CIDENT(3:3)
      YKEY(20:20)=CIDENT(2:2)
      YKEY(21:24)=' '
      YKEY(25:32)=' '
C
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
C
      IF(KDEC(21).EQ.MINDIC) THEN
                                NCORR=0
                             ELSE
                                NCORR=KDEC(21)
                             END IF
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN) 
                  END IF
C      
      IW =9
      IBT=0
C
c      CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc)
C
      iyyy=ny
      imo=nm
      idd=nd
      ihh=nh
      imm=nmin
      iss=nsec
C
C       SET LENGTH OF RECORD
C
      CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)      
C
C        SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C       SET TIME BULLETIN WAS RECEIVED
C
      CALL PACK(32,IKEY(IW),NRDAY,   IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,  IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NRMIN,   IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRSEC,   IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(1),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(1),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(2),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(2),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(3),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(3),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(4),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(4),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,     IW,IBT,8)      
      CALL PACK(32,IKEY(IW),0,       IW,IBT,24)      
C
C
C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
C
C     WORD 8 BIT 16 (atencao meio de palavra 9)
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c      pass = 9
c      do 10 ii = 1,41,4
c        pass = pass + 1
c         do 20 jj = 1,4
c            yout(((pass*4+1)-jj):((pass*4+1)-jj)) =
c     *       ckey_aux(((ii-1)+jj):((ii-1)+jj))
c 20   continue  
c 10   continue
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c
      yout(84:84) = ckey(47:47)
      yout(83:83) = ckey(48:48)
      mbuf(1)=ilength
C
C
C*          3.  WRITE REPORT INTO RDB.
C               ----------------------        
 300  CONTINUE
C
      ila=10
      ilo=11
      if(nsbtype.eq.92) then
         ila=11
         ilo=12
      end if

C*          3.1 write report into RDB.
C               ----------------------
 310  CONTINUE
C
      ierr=0
C
C     -----------------------------------------------------------------
      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      kcount = irecswriten
      recwriten = yfilename // ysd
      do 11 i=1,irecswriten
         if(records_writen(i)(1:99).eq.recwriten(1:99)) then
            irecswriten = i
            go to 12
         end if
 11   continue
 12   irec = irecswriten
      if(irec.lt.kcount) then
        kcount = kcount - 1
        irecswriten = kcount
	irepetida = irepetida + 1
      else
        records_writen(irec)(1:99) = recwriten(1:99)
      end if
      WRITE(99,'(a)',rec=irec)YOUT(5:ilength+4)
C     -----------------------------------------------------------------
 400  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE KTOMPSI(IA)
C
C**** *KTOMPSI*
C
C
C     PURPOSE.
C     --------
C
C         CONVERTS KNOTS TO METRES PER SECOND, ROUNDING
C         TO NEAREST METRE.
C
C         INPUT    :  IA WIND SPEED IN KNOTS (INTEGER)
C
C         OUTPUT   :  IA WIND SPEED IN M/S (INTEGER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KTOMPSI(IA)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C	R. CINTRA    *CPTEC*.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.   CONVERT WIND IN KNOTS TO METER PER SECOND .
C                -------------------------------------------
 100  CONTINUE
C
C
      IA=NINT(0.5148 * IA +0.5)
      RETURN
      END
      FUNCTION P(Z)
C
      DATA A/5.252368255329/, B/44330.769230769/
      DATA  C/0.000157583169442/
      DATA  PTRO/226.547172/, PO/1013.25/
C
      IF (Z.GT.11000.) GO TO 50
      Y = 1.-Z/B
      P = PO*(Y**A)
      RETURN
C
50    Y = -C*(Z-11000.)
      P = PTRO*EXP(Y)
      RETURN
      END
      
      SUBROUTINE SAVBULL ( IERR )
C
C**** *SAVBULL*
C
C
C     PURPOSE.
C     --------
C
C         WRITE COMPLETE BULLETIN TO ERROR FILE .
C
C         BULLETIN IN KCHAR(1)-KCHAR(IGS) IN CCITT 5.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVBULL(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
C
      CHARACTER*80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
C
c
      ierr = 1
c
      YLINE=' '
      YLINEA=' '
C
C
C
      OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='PILO.error.dat',
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,RECL=80                      )
C
      IP = 1
      JP = IP
      J = IGS
C
C*          1.1  OUTPUT INITIAL CONTROL CHARACTERS.
C                ----------------------------------
 110  CONTINUE
C
      CALL NEXTPRT (JP,IGS)
      K = JP - IP
      N1 = 0
      DO 111 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
                                   YLINEA(N1:N1)=Y63
                                   ISIGN=1
                                   KCHAR(IP)=KCHAR(IP).AND.127
                                          END IF
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
  111 CONTINUE
C
c
         if(k.le.2) go to 18
c
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 18   continue
c
      YLINE=' '
      YLINEA=' '
C
 120  CONTINUE
C
      CALL NEXTPRT (IP,J)
      IF (IP .GT. J) GO TO 400
      JP = IP
      CALL NEXTEND (JP,J)
      CALL NEXTPRT (JP,J)
      K = JP - IP
      N1 = 0
      DO 112 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127 )
     C                      THEN
                               YLINEA(N1:N1) = Y63
                               ISIGN= 1
                               KCHAR(IP) = KCHAR(IP).AND.127
                            END IF
C
      YLINE(N1:N1) = CHAR(KCHAR(IP))
      IP = IP + 1
C
  112 CONTINUE
c
         if(k.le.2) go to 19
c
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
C
      YLINE=' '
      YLINEA=' '
C
      GO TO 120
C
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS
 400  CONTINUE
C
      WRITE(10,'(A)') YGS
      CLOSE(10)
C
C     REMOVE PARITY BIT
C
      DO 410 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 410  CONTINUE
C
      RETURN
C
      END
      
      SUBROUTINE SAVREP ( IHEAD,IERR)
C
C**** *SAVREP*
C
C
C     PURPOSE.
C     --------
C
C         WRITE REPORT IN ERROR TO THE ERROR FILE.
C
C                 IHEAD = 0 , WRITE BULLETIN HEADER AND ERROR REPORT
C                             TO ERROR FILE.
C                       = 1 , WRITE ERROR REPORT ONLY.
C                       = 2 , WRITE 'GS' CHARACTER AT END.
C
C                 IERR NOT USED.
C
C                 IHEAD SET TO 1 IF HEADER WRITTEN , OTHERWISE
C                       UNCHANGED.
C
C                 IERR SET TO -1 , IF ERROR IN WRITE , OTHERWISE
C                       UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVREP(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
      DIMENSION ISTART(4),IFIN(4)
C
      CHARACTER *80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
C
c
      if(ihead.ne.2) ierr = 1
c
      YLINE=' '
      YLINEA=' '
C
C
C
      OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='PILO.error.dat',
     C     ACCESS='APPEND',
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,RECL=80                      )
C
C
C
C*          1.2  WRITE BULLETIN HEADER TO ERROR
C                ------------------------------
C                FILE IF NOT ALREADY DONE.
C                -------------------------
 120  CONTINUE
C
      IF ( IHEAD.NE.0 ) GO TO 130
C
C
      ISTART(1) = 1
      ISTART(2) = ISL
      ISTART(3) = IAH
      ISTART(4) = IMI
C
      IFIN(1) = ISL
      IFIN(2) = IAH
      IFIN(3) = JAH
      CALL NEXTEND(IFIN(3),IGS)
      CALL NEXTPRT(IFIN(3),IGS)
      IFIN(4) = JMI
      CALL NEXTEND(IFIN(4),IGS)
      CALL NEXTPRT(IFIN(4),IGS)
C
      IP = 0
      N2 = 0
C
      IHEAD = 1
C
      NN = 3
C
      DO 121 N=1,NN
         K = IFIN(N) - ISTART(N)
         DO 122 N1=1,K
            N2 = N2 + 1
            IP = IP + 1
            IF (KCHAR(IP).GT.127)
     C                      THEN
                                YLINEA(N2:N2) = Y63
                                ISIGN=1
                                KCHAR(IP)=KCHAR(IP).AND.127
                            END IF
C
            YLINE(N2:N2) = CHAR(KCHAR(IP))
C
  122    CONTINUE
c
         if(k.le.2) go to 18
c
C
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N2)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N2)
         ISIGN=0
      END IF
C
 18   continue
c
         YLINE=' '
         YLINEA=' '
C
      N2 = 0
C
  121 CONTINUE
C
C
C*           1.3   WRITE ERROR REPORT , IF REQUIRED.
C***               ---------------------------------
 130  CONTINUE
C
      IF ( IHEAD.EQ.2 ) GO TO 140
C
C
C     AVOID WRITING REPORT TWICE IF MIMIMJMJ  LINE IS
C     MISSING.
C
      IF ( IAH.EQ.KPT ) THEN
           CLOSE(10)
           RETURN
      END IF
C
C     AVOID WRITING MIMIMJMJ TWICE ( CORRUPT MIMIMJMJ CAN BE TAKEN
C     AS STATION NUMBER )
C
      IF ( KPT.LT.IFIN(4) ) KPT = IFIN(4)
C
C
      IP = KPT
      IF(KDEC(4) .EQ. 35 .OR. KDEC(4) .EQ. 36) IP = IMI
      IF(KDEC(4) .EQ. 32 .OR. KDEC(4) .EQ. 33) IP = IMI
      J = IEQ+ 3
      IF ( J.GT.IGS) J = IGS
C
  133 CALL NEXTPRT (IP,J)
      IF (IP.GT.J) THEN
          CLOSE(10)
          RETURN
      END IF
C 
      JP = IP
      CALL NEXTEND(JP,J)
      CALL NEXTPRT(JP,J)
      K= JP - IP
      IF(K.GT.80) THEN
         K=80
      END IF  
      N1 = 0
      DO 131 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127)
     C                        THEN
                                  YLINEA(N1:N1) = Y63
                                  ISIGN= 1
                                  KCHAR(IP) = KCHAR(IP).AND.127
                              END IF
C
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
 131  CONTINUE
C
c
         if(k.le.2) go to 19
c
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
c
      YLINE=' '
      YLINEA=' '
C
C
      GO TO 133
C
C
C*              1.4 WRITE 'GS' AT END OF BULLETIN.
C                   ------------------------------
 140  CONTINUE
C
      YLINE(1:4)= YGS
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE
      CLOSE(10)
C
      GO TO 400
C     ----------------------------------------------------------------
 300  IERR = -1
      PRINT*,'ERROR IN WRITING INTO ERROR FILE IOS=',IOS
C     ----------------------------------------------------------------
 400  CONTINUE
C
C     REMOVE PARITY BIT
C
      DO 500 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRSTA (IPART,IMARK,IFIRST,NUMBER)
C
C**** *ERRSTA*
C
C
C     PURPOSE.
C     --------
C
C         COUNTS THE NUMBER OF ERRORS IN THE REPORT
C         COUNTS THE NUMBER OF ERRORS IN THE DECODING JOB
C         MARKS THE ERROR BIT TO KDEC
C         ADDS ?-MARK TO KCHAR AT THE ERRONEUS GROUP
C
C         INPUT     : IPART    - INDICATOR OF NOER
C                                (IN TEMPS  3 = A, 4 = B, 5 = C, 6 = D)
C                     IMARK    = 1 IF ? IS TO BE ADDED TO ERRONEUS GROUP
C                     IFIRST   = O IF FIRST DECODING ATTEMPT OF THE REPORT
C                              = 1 OTHERWISE
C                     NUMBER   - NUMBER OF ERRORS IN THE REPORT SO FAR
C
C         OUTPUT    : NUMBER   - NEW NUMBER OF ERRORS
C                     NOER     - NUMBER OF ERRONEUS REPORT (INCREASED BY 1
C                                IF THE FIRST ERROR IN THE REPORT)
C                     KDEC(20) - ERROR BITS
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRSTA(IPART,IMARK,IFIRST,NUMBER)*
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOV.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C
 100  CONTINUE
C
      IF(NUMBER .GE. 0) NUMBER = NUMBER + 1
      IF ( IFIRST.EQ.0 )
     C   THEN
            IF(NUMBER .EQ. 1)
     C          NUMRERR(IPART)=NUMRERR(IPART) + 1
            NOER(IPART,KERR)=NOER(IPART,KERR) + 1
            KERBIT =ISHFT(KDEC(20),1-KERR) .AND. 1
            IF(KERBIT .EQ. 0) KDEC(20) = KDEC(20) + 2**(KERR-1)
         END IF
C
      IPT = IABS(IPT)
      IF(IMARK .EQ. 1) KCHAR(IPT) = KCHAR(IPT) .OR. 128
      IF(IMARK .EQ. 2)
     C   THEN
            NPT = IPT
            CALL NEXSEP2(NPT,IEQ,*200)
            CALL PREPRT(NPT,IMI,*200)
            KCHAR(NPT) = KCHAR(NPT) .OR. 128
         END IF
C
200   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE REMEEE
C
C**** *REMEEE*
C
C
C     PURPOSE.
C     --------
C
C         HANDLE TYPING ERRORS CORRECTED BY THE 'E E E'
C         PROCEDURE AS SPECIFIED IN GTS MANUAL.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *REMEEE*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C         OUTPUT    : E'S , ERRONEUS CHARACTERS AND REPEATED GROUPS REPLACED
C                     BY SPACE CHARACTERS. THESE ARE IGNORED IN SCANNING
C                     ROUTINES.
C
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CHECK FOR 'E E E'. 'EEE' IS ACCEPTED EVEN
C               THOUGH THIS MAY BE  AMBIGUOUS WITH A SYNOP '333' GROUP IN
C               LETTER SHIFT. FREQUENTLY  ONLY 1 OR 2 'E'S MAY BE USED.
C               THESE ALSO CATERED FOR.
 100  CONTINUE
C
C     SKIP PAST SHIP'S CALL SIGN AND LOCATE 'E' IF ANY EXISTS.
C
      I = IPT + 4
      N = 69
      CALL NEXTVAL(I,N,IEQ)
      IF(I .GT. IEQ) RETURN
C
C     'E' CHARACTER FOUND. REPLACE 'E' AND ANY FOLLOWING 'E'S BY SPACES
C     E.G.  40118 7012EE 40118 70500  BECOMES
C           40118 7012   40118 70500 .
C
      K = I
      CALL NEXTFIG(K,IEQ)
      IF(K .GE. IEQ) RETURN
C
            DO 101 J=I,K-1
               IF((KCHAR(J) .NE. 10) .AND. (KCHAR(J) .NE. 13))
     1             KCHAR(J) = 32
101         CONTINUE
C
C     SET POINTER TO CHARACTER BEFORE THE 'E'. CHANGE
C     THIS CHARACTER TO A 'SPACE'.
C       E.G.  40118 7012   40118 70500  BECOMES
C             40118 701    40118 70500 .
C
      N = I - 1
      IF((KCHAR(N) .NE. 10) .AND. (KCHAR(N) .NE. 13))
     1    KCHAR(N) = 32
C
C     SCANNING BACKWARDS REPLACE CHARACTERS BY 'SPACE'
C     UNTIL A 'SPACE' CHARACTER IS ENCOUNTERED.
C        E.G.  40118 701    40118 70500  BECOMES
C              40118        40118 70500 .
C
      DO 102 I=N-1,IPT,-1
          IF(KCHAR(I) .EQ. 32) GO TO 300
          IF((KCHAR(I) .NE. 10) .AND. (KCHAR(I) .NE. 13))
     1        KCHAR(I) = 32
  102 CONTINUE
C
C     NO CHARACTER FOUND
C
      GO TO 100
C
C     ---------------------------------------------------------------------
C*           3. 'I' NOW POINTS TO THE 'SPACE' AFTER LAST FIGURE OF THE GROUP
C               BEFORE THE SERIES OF SPACES AND 'K' POINTS TO FIRST FIGURE
C               OF FOLLOWING GROUP. IF THESE GROUPS ARE THE SAME REMOVE
C               ONE GROUP (SECOND).
C               E.G.  40118        40118 70500  BECOMES
C                     40118              70500 .
C
 300  CONTINUE
C
      I = I - 5
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   N = K + 4
                   DO 301 I=K,N
                       KCHAR(I) = 32
  301              CONTINUE
               END IF
C
C
C*           4.  SOMETIMES MORE THAN 1 GROUP HAS TO BE DELETED
C                E.G.  40118 59623 7012EE 40118 70500 .
C                THIS WILL NOW HAVE BECOME
C                40118 59623        40118         AND POINTERS ARE
C                      I            K
C                40118 59623 NEED TO BE REMOVED.
 400  CONTINUE
C
      I = I - 6
      N = K - 1
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   DO 401 J=I,N
                       KCHAR(J) = 32
  401              CONTINUE
               END IF
C
C     GO BACK TO BEGINNING OF SUBROUTINE TO FIND OUT
C     IF THERE ARE MORE 'E'-CORRECTIONS.
C
      GO TO 100
C
      END
      
      SUBROUTINE NEXTMI(I,J,II)
C
C**** *NEXTMI*
C
C
C     PURPOSE.
C     --------
C
C         TO FIND NEXT MIMIMJMJ GROUP IN THE BULLETIN.
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT GROUP OF
C         ('TTAA' OR 'TTBB' OR 'TTCC' OR 'TTDD' ETC.)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTMI(I,J,II)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C
C         OUTPUT    : II- POSITION OF THE FIRST CHARACTER
C                         IN REQUIRED GROUP
C                         IF CHARACTER NOT FOUND II = 99999
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION MIMJ(26)
C
C
      DATA MIMJ /65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
     &           80,81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C*          1.   FIND NEXT MIMIMJMJ GROUP.
C                -------------------------
 100  CONTINUE
C
C
      II=9999
      K =IABS(I)
      M =IABS(I)
C
 101  CONTINUE
C
      CALL NEXSEP2(M,J,*1000)
      CALL NEXPRT2(M,J,*1000)
C
      IF(M.GE.J) RETURN
C
      K1= KCHAR(M  )
      K2= KCHAR(M+1)
      K3= KCHAR(M+2)
      K4= KCHAR(M+3)
C
      DO 102 N=1,26
C
      IF(K1.EQ.MIMJ(N).AND.K2.EQ.MIMJ(N))
     &   THEN
C
            DO 103 NN=1,26
C
            IF(K3.EQ.MIMJ(NN).AND.K4.EQ.MIMJ(NN))
     &         THEN
                  CALL PRESEP(M,K,*1000)
                  CALL PREPRT(M,K,*1000)
                  II= M+1
                  RETURN
               END IF
C
 103        CONTINUE
C
         END IF
C
 102  CONTINUE
C
       GO TO 101
C
 1000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATIM(YDATE)*
C
C
C     MODIFICATIONS.
C     --------------
C
C	   M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'comdate.h'
      
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili 
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c       print*,iyear,imonth,iday,ihour,imin,isec
C
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      IF(IDAY.GE.IDD) THEN
                         IMM=IMONTH
                         IYY=IYEAR
                         ima=imonth
                         RETURN
                      END IF
C
      IF(IDAY.LT.IDD) THEN
                         IF(IMONTH.EQ.1) THEN
                                            IMM=12
                                            IYY=IYEAR-1
                                            RETURN
                                         END IF
                         IMM=IMONTH-1
                         IYY=IYEAR
                      END IF
C
      RETURN
      END
      
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C     
      include 'comdate.h'
      
      integer date_time (8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt. 1 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)
      else
c             PRINT*,'Passando a data'

             read(arg(1:4),'(i4.4)') ny
             read(arg(5:6),'(i2.2)') nm
             read(arg(7:8),'(i2.2)') nd
             read(arg(9:10),'(i2.2)') nh
             read(arg(11:12),'(i2.2)') nmin
             nutc = 0
             nsec = 0
             ncc = 0
             date_time(1) = ny
             date_time(2) = nm
             date_time(3) = nd
             date_time(4) = nutc
             date_time(5) = nh
             date_time(6) = nmin
             date_time(7) = nsec
             date_time(8) = ncc
            
      end if
c      print*,ny,nm,nd,nutc,NH,NMIN,NSEC,ncc
C----------------------------------------------------------------
      RETURN
      END      
      SUBROUTINE MRGPIL( IERR)
C
C**** *MRGPIL*
C
C
C     PURPOSE.
C     --------
C         MERGE PILOT PARTS A, B, C AND D INTO SINGLE OBSERVATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *MRGPIL( IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comstd.h' 
      INCLUDE 'comkey.h'
      include 'comdate.h'
C
      DIMENSION OCONT(4),VALUESA(900),VALUESB(900),VALUESC(900)
      DIMENSION PRESS(400),PRESSC(600),INX(400),INXA(400)
      DIMENSION ITEML(2000),YSHNAM(100),CVALA(10),IDM(12)
C
      CHARACTER CVAL*9,CVALA*9,CUNIT*24,YSHNAM*9
      CHARACTER*2 YMONTH,YDAY,YHOUR,YMIN
      character*4 year
      CHARACTER*80 YFILENAME
      character*3 cmonth(12)
      character*25 ct,current      
      CHARACTER*21 YSD
C
      DATA ITEML/2000*999999/,YSHNAM/100*'       '/
      DATA VALUESA/900*0.0/,PRESS/400*0.0/,INX/400*0/,INXA/400*0/
      DATA VALUESB/900*0.0/,VALUESC/900*0.0/
      DATA LSHEAR/.FALSE./
      DATA IDM/31,28,31,30,31,30,31,31,30,31,30,31/
C
      data cmonth/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
      STRUCTURE /MERGE/
       CHARACTER*21 STATION_DATE
       INTEGER*4    NNSNUM
       LOGICAL*1    OOCONT(4)
       INTEGER*4    NNCORN(4)
       INTEGER*4    MMA
       REAL         VVALUESA(900)
       INTEGER*4    IILENC
       CHARACTER*9  CCVALA(10)
      END STRUCTURE
C
      RECORD /MERGE/ OLD_PILOT
c
      common /comaux/ yfilename,ysd
C     ------------------------------------------------------------------
C
C*          1.   SET UP RECORD NUMBER FOR DIRECT ACCESS.
C                ---------------------------------------
 100  CONTINUE
C
      if(ierr.ne.0) return
c
      ocont(1)=.false.
      ocont(2)=.false.
      ocont(3)=.false.
      ocont(4)=.false.
C
      NCORN(1)= 0
      NCORN(2)= 0
      NCORN(3)= 0
      NCORN(4)= 0
C
C
C*          1.1  READ IN PREVIOUS REPORT IF ANY.
C                --------------------------------
 110  CONTINUE
C
C     DEFINE FILE NAME
C
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
      write(current(1:2),'(i2.2)') iday
      current(3:3)='-'
      current(4:6)=cmonth(imonth)
      current(7:7)='-'
      write(current(8:11),'(i4)') iyear
      current(12:12)=' '
      write(current(13:14),'(i2.2)') ihour
      current(15:15)=':'
      write(current(16:17),'(i2.2)') imin
      current(18:18)=':'
      write(current(19:20),'(i2.2)') isec
      current(21:21)='.'
      write(current(22:24),'(i3.3)') imili
c      print *,'current= ',current
      
      IYEAR=VALUES(5,1)
      IF(KDEC(4).EQ.33) then
        IYEAR =VALUES(6,1)
      endif
      
c        icen = (iyear * .01)
c        IYEAR=iYEAR - (icen * 100.)
      
      IMONTH=VALUES(6,1)
      IF(KDEC(4).EQ.33) IMONTH=VALUES(7,1)
      IDAY=VALUES(7,1)
      IF(KDEC(4).EQ.33) IDAY  =VALUES(8,1)
      IHOUR=VALUES(8,1)
      IF(KDEC(4).EQ.33) IHOUR =VALUES(9,1)
      imin=VALUES(9,1)
      IF(KDEC(4).EQ.33) imin=VALUES(10,1)
c
      iy=VALUES(5,1)
      write(ct(1:2),'(i2.2)') iday
      ct(3:3)='-'
      ct(4:6)=cmonth(imonth)
      ct(7:7)='-'
      write(ct(8:11),'(i4)') iy
      ct(12:12)=' '
      write(ct(13:14),'(i2.2)') ihour
      ct(15:15)=':'
      write(ct(16:17),'(i2.2)') imin
      ct(18:18)=':'
      write(ct(19:20),'(i2.2)') 0
      ct(21:21)='.'
      write(ct(22:23),'(i2.2)') 0
c      print*,'ct',ct
c
      
      call istime(current,nm1,iret)
      call istime(ct,nm0,iret)
      idf=nm1-nm0
c
      if(idf.le.0) then
         print*,' mrgpilo: data for future',ct
         ierr=1
         return
      end if

C
 115  CONTINUE
C
      WRITE(YEAR,'(I4.4)') IYEAR
      WRITE(YMONTH,'(I2.2)') IMONTH
      WRITE(YDAY,'(I2.2)') IDAY
      WRITE(YHOUR,'(I2.2)')IHOUR
      WRITE(YMIN,'(I2.2)') IMIN
C
      OLD_PILOT.STATION_DATE=' '
C
      IF(KDEC(4).EQ.32) THEN
         ISTNO=NINT(VALUES(1,NSUB))*1000+NINT(VALUES(2,NSUB))
         WRITE(OLD_PILOT.STATION_DATE(1:5),'(I5.5)') ISTNO
      ELSE
         OLD_PILOT.STATION_DATE(1:11)=CVAL(1)
      END IF
C
      OLD_PILOT.STATION_DATE(10:21)=YEAR//YMONTH//YDAY//YHOUR//YMIN
      YSD(1:21)=OLD_PILOT.STATION_DATE
         
C
      YFILENAME='WIND'//YEAR//YMONTH//YDAY//'MERGE'
C
      OPEN(UNIT=16,IOSTAT=IOS,ERR=120,FILE=YFILENAME,
     1            organization='relative',
     2            FORM='UNFORMATTED',
     4            RECL=1200,
     5            STATUS='UNKNOWN')
c
      ios = 0
      irderr = 0
      irecnum = 0
      
      call read_seq(16,irderr,ios,irecnum,old_pilot.station_date,
     1             yfilename,old_pilot)
      if (irderr.ne.0) go to 130
C
      DO 12 I=1,4
      OCONT(I)=OLD_PILOT.OOCONT(I)
      NCORN(I)=OLD_PILOT.NNCORN(I)
 12   CONTINUE
C
      DO 13 I=1,900
      VALUESA(I)=OLD_PILOT.VVALUESA(I)
 13   CONTINUE
C
      MA   =OLD_PILOT.MMA
      ILENC=OLD_PILOT.IILENC
      NSNUM=OLD_PILOT.NNSNUM
C
      DO 14 I=1,10
      CVALA(I)=OLD_PILOT.CCVALA(I)
 14   CONTINUE
      
      GO TO 200
C
 120  CONTINUE
C
C     IF FILE DOES NOT EXIST CREATE ONE AND WRITE A RECORD
C
      print*,'Open error on old ',yfilename,'.Error ',ios
c
      IF(IOS.EQ.127) THEN
         OPEN(UNIT=16,IOSTAT=IOS,ERR=125,
     1   FILE=YFILENAME,
     1   organization='relative',
     2   FORM='UNFORMATTED',
     4   RECL=1200,
     5   STATUS='NEW')
C
         MA=M
         ILENC=1
         CVALA(1)=CVAL(1)
         
         DO 121 I=1,M
         VALUESA(I)=VALUES(I,NSUB)
 121     CONTINUE
C
c         NSNUM=1
C
c         IF(KDEC(23).EQ.1) OCONT(1)=.TRUE.
c         IF(KDEC(23).EQ.2) OCONT(2)=.TRUE.
c         IF(KDEC(23).EQ.3) OCONT(3)=.TRUE.
c         IF(KDEC(23).EQ.4) OCONT(4)=.TRUE.
C
         GO TO 200
C
      END IF
C
 125  CONTINUE
C
      print*,'Error opening new ',yfilename,'. Error ',ios
      call exit(2)
C
 130  CONTINUE
C
C     IF RECORD DOES NOT EXIST WRITE THE RECORD
C
      IF(IOS.EQ.36) THEN
         MA=M
         ILENC=1
         CVALA(1)=CVAL(1)
         DO 131 I=1,M
         VALUESA(I)=VALUES(I,NSUB)
 131     CONTINUE
C
c         NSNUM=1 
C
c         IF(KDEC(23).EQ.1) OCONT(1)=.TRUE.
c         IF(KDEC(23).EQ.2) OCONT(2)=.TRUE.
c         IF(KDEC(23).EQ.3) OCONT(3)=.TRUE.
c         IF(KDEC(23).EQ.4) OCONT(4)=.TRUE.
C
         GO TO 200
      END IF
C
      print*,'Error during read on ',yfilename,' .Error ',ios
      call exit(2)
C
C     ------------------------------------------------------------------
C*           2. MERGE NEW AND OLD REPORT.
C               -------------------------
 200  CONTINUE
C
      IF(KDEC(23).EQ.1.AND.OCONT(1).EQ..TRUE.) THEN
         IF(KDEC(21).LT.NCORN(1)) THEN
            GO TO 231
         ELSE
            NCORN(1)=KDEC(21)
         END IF
      END IF
      IF(KDEC(23).EQ.1.AND.OCONT(1).EQ..FALSE.) THEN
         OCONT(1)=.TRUE.
         NCORN(1)=KDEC(21)
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.2.AND.OCONT(2).EQ..TRUE.) THEN
         IF(KDEC(21).LT.NCORN(2)) THEN
            GO TO 231
         ELSE
            NCORN(2)=KDEC(21)
         END IF
      END IF
      IF(KDEC(23).EQ.2.AND.OCONT(2).EQ..FALSE.) THEN
         OCONT(2)=.TRUE.
         NCORN(2)=KDEC(21)
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.3.AND.OCONT(3).EQ..TRUE.) THEN
         IF(KDEC(21).LT.NCORN(3)) THEN
            GO TO 231
         ELSE
            NCORN(3)=KDEC(21)
         END IF
      END IF
      IF(KDEC(23).EQ.3.AND.OCONT(3).EQ..FALSE.) THEN
         OCONT(3)=.TRUE.
         NCORN(3)=KDEC(21)
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.4.AND.OCONT(4).EQ..TRUE.) THEN
         IF(KDEC(21).LT.NCORN(4)) THEN
            GO TO 231
         ELSE
            NCORN(4)=KDEC(21)
         END IF
      END IF
      IF(KDEC(23).EQ.4.AND.OCONT(4).EQ..FALSE.) THEN
         OCONT(4)=.TRUE.
         NCORN(4)=KDEC(21)
         GO TO 230
      END IF
C
 231  CONTINUE
C
      MC=MA
      DO 232 I=1,MA
      VALUESC(I)=VALUESA(I)
 232  CONTINUE
C
      GO TO 400
C  
 230  CONTINUE
C
      MB=M+MA-13
C
      IS=NINT(VALUES(13,NSUB))*5+13
      ISA=NINT(VALUESA(13))*5+13
C
C     COPY VALUESA INTO VALUESB
C
      J=0
      DO 201 I=1,ISA
      J=J+1
      VALUESB(J)=VALUESA(I)
 201  CONTINUE
C
C     COPY VALUES INTO VALUESB
C
      DO 202 I=14,IS
      J=J+1
      VALUESB(J)=VALUES(I,NSUB)
 202  CONTINUE
C
C     UPDATE NUMBER OF LEVELS
C
      VALUESB(13)=VALUES(13,NSUB)+VALUESA(13)
C
      ISB=NINT(VALUESB(13))*5+13
C
C*           2.1 SORT PRESSURE LEVELS IN DESCENDING ORDER.
C                -----------------------------------------
 210  CONTINUE
C
      J=0
      DO 211 I=14,ISB,5
C
      J=J+1
C
      if(valuesb(i).eq.999999.)
     1   then
            sh1=valuesb(i+2)/9.8
            do 2222 ik=2,511
            shl=(sh(ik-1)+sh(ik))/2.
            shh=(sh(ik)+sh(ik+1))/2.
            if(sh1.ge.shl.and.sh1.le.shh)
     1         then
                  press(j)=p(ik)
                  inx(j)=i
                  go to 211
               end if
2222        continue
         end if   
c
      PRESS(J)=VALUESB(I)
      INX(J)=I
C
 211  CONTINUE
C
      JJA=9
      JJ=0
      DO 212 II=1,J
C
      PMAX=PRESS(1)
      IMAX=1
C
      DO 213 I=1,J
      IF(PRESS(I).GT.PMAX)
     1   THEN
            PMAX=PRESS(I)
            IMAX=I
         END IF
 213  CONTINUE
C
      PRESS(IMAX)=0.0
      JJA=JJA+5
      JJ=JJ+1
      PRESSC(JJA)=PMAX
      INXA(JJ)=INX(IMAX)
 212  CONTINUE
C
C     COPY FIRST 13 ELEMENTS OF VALUESB INTO VALUESC
C
      DO 214 I=1,13
      VALUESC(I)=VALUESB(I)
 214  CONTINUE
C
C
      IJ=14
C
      DO 215 I=1,JJ
C
      J=INXA(I)
C
      VALUESC(IJ  )=VALUESB(J)
      VALUESC(IJ+1)=VALUESB(J+1)
      VALUESC(IJ+2)=VALUESB(J+2)
      VALUESC(IJ+3)=VALUESB(J+3)
      VALUESC(IJ+4)=VALUESB(J+4)
C
      IJ=IJ+5
C
 215  CONTINUE
C
 220  CONTINUE
C
      ISC=ISB
C
C
C     DISCARD LEVELS WITH SAME PRESSURE
C
      ICOUNT=1
      I =14
      K =9
      IC=14
C
 250  CONTINUE
C
      K=K+5
      IF(K.GT.ISC) GO TO 260
C  
      IF(PRESSC(I).EQ.PRESSC(K)) THEN
         IA=NINT(VALUESC(I+1))
         IB=NINT(VALUESC(K+1))
         IAIB=IA.OR.IB
C
         VALUESC(IC  )=VALUESC(K)
         VALUESC(IC+1)=FLOAT(IAIB)
         VALUESC(IC+2)=VALUESC(K+2) 
         VALUESC(IC+3)=VALUESC(K+3) 
         VALUESC(IC+4)=VALUESC(K+4) 
C
         I=K
         GO TO 250
      ELSE
         ICOUNT=ICOUNT+1
         IC=IC+5
C
         VALUESC(IC  )=VALUESC(K)
         VALUESC(IC+1)=VALUESC(K+1)
         VALUESC(IC+2)=VALUESC(K+2) 
         VALUESC(IC+3)=VALUESC(K+3) 
         VALUESC(IC+4)=VALUESC(K+4) 
C
         I=K
         GO TO 250
C
      END IF
C
C
 260  CONTINUE         
C
C     UPDATE NUMBER OF LEVELS
C
      VALUESC(13)=FLOAT(ICOUNT)
      ISC=VALUESC(13)*5+13
      MC=ISC 
C
 280  CONTINUE
C
C     -----------------------------------------------------------------
C*         3. ADD WIND SHEAR LEVELS IF ANY.
C             -----------------------------
 300  CONTINUE
C
      IWLEVS=0
      IWLEVA=0
      DO 301 KB=1,600
      PRESSC(KB)=0.
 301  CONTINUE
C
      IF(IS.LT.M.OR.ISA.LT.MA)
     1   THEN
            J=ISC+1
            IF(IS.LT.M) THEN
                           IWLEVS=NINT(VALUES(IS+1,NSUB))
                           DO 262 I=IS+2,M
                           J=J+1
                           VALUESC(J)=VALUES(I,NSUB)
 262                       CONTINUE
                        END IF
C
            IF(ISA.LT.MA) THEN
                             IWLEVA=NINT(VALUESA(ISA+1))
                             DO 263 I=ISA+2,MA
                             J=J+1
                             VALUESC(J)=VALUESA(I)
 263                         CONTINUE
                          END IF
C
           IWLEVC=IWLEVS+IWLEVA
           VALUESC(ISC+1)=FLOAT(IWLEVC)
           MC=J
C
C*           3.1 SORT PRESSURE LEVELS IN DESCENDING ORDER.
C                -----------------------------------------
 310  CONTINUE
C
           J=0
           DO 311 I=ISC+2,MC,5
C
           J=J+1
           if(valuesc(i).eq.999999.)
     1        then
                 sh1=valuesc(i+2)/9.8
                 do 3222 ii=2,511
                 shl=(sh(ii-1)+sh(ii))/2.
                 shh=(sh(ii)+sh(ii+1))/2.
                 if(sh1.ge.shl.and.sh1.le.shh)
     1              then
                       press(j)=p(ii)
                       inx(j)=i
                       go to 311
                    end if
3222             continue
              end if
c
           PRESS(J)=VALUESC(I)
           INX(J)=I
C
 311       CONTINUE
C
           JJS=-4
           JJ=0
           DO 312 II=1,J
C
           PMAX=PRESS(1)
           IMAX=1
C
           DO 313 I=1,J
           IF(PRESS(I).GT.PMAX)
     1        THEN
                 PMAX=PRESS(I)
                 IMAX=I
              END IF
 313       CONTINUE
C
           PRESS(IMAX)=0.0
           JJ=JJ+1
           JJS=JJS+5
           PRESSC(JJS)=PMAX
           INXA(JJ)=INX(IMAX)
 312       CONTINUE
C
C
           DO 315 I=1,JJ
C
           J=INXA(I)
           IJ=(I-1)*5+1
C
           VALUESB(IJ  )=VALUESC(J)
           VALUESB(IJ+1)=VALUESC(J+1)
           VALUESB(IJ+2)=VALUESC(J+2)
           VALUESB(IJ+3)=VALUESC(J+3)
           valuesb(ij+4)=valuesc(j+4)
C
 315       CONTINUE
C
           IJ=IJ+4 
C
 320       CONTINUE
C
C         DISCARD LEVELS WITH SAME PRESSURE
C
          ICOUNT=1
          I=1
          K=-4
          IC=1
C
 330      CONTINUE
C
          K=K+5
          IF(K.GT.IJ) GO TO 360
C  
          IF(PRESSC(I).EQ.PRESSC(K)) THEN
             IA=NINT(VALUESB(I+1))
             IB=NINT(VALUESB(K+1))
             IAIB=IA.OR.IB
C
             VALUESB(IC  )=VALUESB(K)
             VALUESB(IC+1)=FLOAT(IAIB)
             VALUESB(IC+2)=VALUESB(K+2) 
             VALUESB(IC+3)=VALUESB(K+3) 
             VALUESB(IC+4)=VALUESB(K+4) 
C
             I=K
             GO TO 330
         ELSE
            ICOUNT=ICOUNT+1
            IC=IC+5
C
            VALUESB(IC  )=VALUESB(K)
            VALUESB(IC+1)=VALUESB(K+1)
            VALUESB(IC+2)=VALUESB(K+2) 
            VALUESB(IC+3)=VALUESB(K+3) 
            VALUESB(IC+4)=VALUESB(K+4) 
C
            I=K
            GO TO 330
C
         END IF
C
C
 360  CONTINUE         
C
C
C         UPDATE NUMBER OF LEVELS
C
          VALUESC(ISC+1)=FLOAT(ICOUNT)
          MC=NINT(VALUESC(ISC+1))*5+ISC+1
C
C
 380  CONTINUE
C
         JJ=ISC+1
         IIII=ICOUNT*5
C
         DO 362 II=1,IIII
         JJ=JJ+1
         VALUESC(JJ)=VALUESB(II)
 362     CONTINUE
C
      END IF
C
      ILENC=1
C
      CVALA(1)=CVAL(1)
C
C     ------------------------------------------------------------------
C*         4.  REWRITE  REPORT.
C              ----------------
 400  CONTINUE
C
      M=MC
c          ---- verificar a variavel a que foi atribuida  NSUB ----
      Ns=NSUB
C
      DO 401 I=1,MC
      VALUES(I,NSUB)=VALUESC(I)
 401  CONTINUE
C
      NSNUM=NSNUM+1
C
      DO 402 I=1,4
      IF(OCONT(I)) then
         NPART(I)=1
         else
         npart(i)=0
         endif
 402  CONTINUE
C
      OLD_PILOT.STATION_DATE=YSD
      DO 403 I=1,4
      OLD_PILOT.OOCONT(I)=OCONT(I)
      OLD_PILOT.NNCORN(I)=NCORN(I)
 403  CONTINUE
C
      OLD_PILOT.NNSNUM=NSNUM
      OLD_PILOT.MMA=MC
      OLD_PILOT.IILENC=ILENC
C
      DO 404 I=1,900
      OLD_PILOT.VVALUESA(I)=VALUESC(I)
 404  CONTINUE
C
      DO 405 I=1,10
      OLD_PILOT.CCVALA(I)=CVALA(I)
 405  CONTINUE
C
      write(unit=16,rec=irecnum,iostat=ios,err=410) old_pilot
C
      CLOSE(16)
C
      RETURN
C
 410  CONTINUE
C
      print*,'Error during write in ',yfilename,' Error ',ios
      CALL EXIT(2)
C
      RETURN
      END
      
      SUBROUTINE DUPLIGR(IFOUND)
C
C**** *DUPLIGR*
C
C
C     PURPOSE.
C     --------
C         FIND OUT IF TWO PREVIOUS GROUPS ARE DUPLICATES
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DUPLIGR(IFOUND)*
C
C          OUTPUT     IFOUND  = 1 IF DUPLICATE GROUPS FOUND
C                     IREMPOS   INDICATOR TO THE POINT OF THE FIRST ERROR
C                     IPT         POINTS TO THE BEGINNING OF THE SECOND
C                                 DUPLICATE.
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  JAN 84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
       INCLUDE 'parameter.h'
       INCLUDE 'comwork.h'
       INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.   FIND DUPLICATED GROUPS.
C                -----------------------
 100  CONTINUE
C
      IFOUND = 0
      NPT = IPT
C
      CALL PRESEP(NPT,IMI,*1000)
      CALL PREPRT(NPT,IMI,*1000)
      CALL PRESEP(NPT,IMI,*1000)
      CALL PREPRT(NPT,IMI,*1000)
      CALL PRESEP(NPT,IMI,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
C     POINTER TO THE FIRST POSSIBLE DUPLICATE
C
      IPO1 = NPT
C
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
C     POINTER TO THE SECOND POSSIBLE DUPLICATE
C
      IPO2 = NPT
C
C     CHECK THE VALUES
C
      CALL EXTVAL(IPO1,5,IVAL1)
      CALL EXTVAL(IPO2,5,IVAL2)
C
      IF(IVAL1 .EQ. MINDIC .OR. IVAL2 .EQ. MINDIC) RETURN
C
      IF(IVAL1 .EQ. IVAL2)
     C   THEN
C
C           DUPLICATE GROUPS FOUND  --  SET THE POINTER IPT TO THE
C                                       BEGINNING OF THE DUPLICATE.
C                                       DUPLICATE.
C
            IPT = NPT
            IFOUND = 1
            RETURN
         END IF
C
1000  CONTINUE
      RETURN
C
      END
      
      SUBROUTINE LEVCHEC (LEVNUM,IPOS,ISTEP,LEVER,NEWSEC)
C
C**** *LEVCHEC*
C
C
C     PURPOSE.
C     --------
C
C         TRY TO FIND MORE CORRECT LEVELS IN TEMP PARTB AND
C         PART D AFTER AND ERROR OF PRESSURE HAS BEEN FOUND.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LEVCHEC (LEVNUM,IPOS,ISTEP,LEVER,NEWSEC)*
C
C          INPUT     : LEVNUM - THE LEVEL NUMBER (0,1,2,...)
C                    : IPOS   - POINTER OF THE LEVEL IN KINT
C                    : ISTEP  - THE STEP OF LEVELS IN KINT
C
C          OUTPUT    : LEVER  - THE INDICATOR OF DELETED LEVEL
C                      NEWSEC - THE INDICATOR OF POSSIBLE NEW SECTION
C                               (= 21212 FOR WIND SECTION ETC.)
C
C     METHOD.
C     -------
C
C         FOUR LEVELS, TWO BEFORE AND AND ONE AFTER THE ERROR,
C         WILL BE CHECKED, BECAUSE THE HEIGHT MIGHT BE WRONG
C         EITHER IN THE 'ERROR' GROUP,IF IT IS TOO BIG OR THE
C         PREVIOUS GROUP IF IT IS TOO SMALL.
C         IF THE ERROR IS ON THE SECOND LEVEL, ONLY THREE
C         LEVELS WILL BE CHECKED.
C
C
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN DEC.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION LEV(4)
C
      DATA LEV /4*-999999/
C
C     ------------------------------------------------------------------
C
C*          1.   LEVEL CHECK.
C                ------------
 100  CONTINUE
C
C
      LEVER = 0
      NEWSEC = 0
C
C     SEE IF THE WIND SECTION INICATOR HAS BEEN PASSED
C
      IF(ISTEP .NE. 5) GO TO 102
C
      IF(KINT(IPOS+1) .GE. 100) GO TO 102
C
      CALL PRE2121(IFOUND)
C
      IF(IFOUND .EQ. 1)
     C   THEN
            NEWSEC = 21212
            DO 101 I=IPOS,600
            KINT(I) = MINDIC
101         CONTINUE
            KINT(317) = 21212
            RETURN
         END IF
C
 102  CONTINUE
C
C
C*          1.1  SEE IF THE CLOUD SECTION, OR REGIONAL/NATIONAL
C                SECTION INDICAROR HAS BEEN PASSED
 110  CONTINUE
C
C===  CALL PRESEC(NEWSEC)
C===  IF(NEWSEC .GT. 0) RETURN
C
C     GET THE POINTER OF THE THREE LEVELS
C
C
C
      NPT = IPT
      IPO3 = NPT
      CALL PRESEP(NPT,LPT,*1000)
C
      NN = 4
      IF(LEVNUM .LE. 1) NN = 2
C
         DO 111 I=1,NN
         CALL PREPRT(NPT,IMI,*1000)
         CALL PRESEP(NPT,IMI,*1000)
         IF(I .EQ. 2) IPO2 = NPT
         IF(I .EQ. 4) IPO1 = NPT
 111     CONTINUE
C
         CALL NEXPRT2(IPO2,IEQ,*1000)
         IF(LEVNUM .GT. 1) CALL NEXPRT2(IPO1,IEQ,*1000)
C
C     THE LOOP TO GET THE LEVEL INDICTORS AND PRESSURES
C
C
C
112   CONTINUE
C
      IF(LEVNUM .GT. 1) CALL EXTVAL(IPO1+2,3,LEV(1))
      CALL EXTVAL(IPO2+2,3,LEV(2))
      CALL EXTVAL(IPO3+2,3,LEV(3))
C
      NPT = IPT
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
      N1 = (KCHAR(NPT)   .AND. 127)  - 48
      N2 = (KCHAR(NPT+1) .AND. 127) - 48
C
C
C     CHECK IF THIS IS CORECT BEGINNING OF SIGNIFICANT LEVEL (N1=N2)
C
      IF(N1 .NE. N2) THEN
C
C                       CHECK IF THIS IS THE BEGINNING
C                       OF SECTION 6, 8, 9 OR 10
C
                        CALL EXTVAL(IPT,5,IVAL)
C
                        IF(ISTEP .EQ. 5)
     C                     THEN
                              IF(IVAL .EQ. 21212)
     C                           THEN
                                    LEVER = 3
                                    IPT = NPT
                                    RETURN
                                  END IF
                            END IF
C
                        IF(IVAL .EQ. 41412)
     C                     THEN
                              LEVER = 3
                              IPT = NPT
                              RETURN
                           END IF
C
                        IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C                     (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C                     (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C                     (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C                     (IVAL .EQ. 59595) .OR. (IVAL .EQ. 51525))
     C                        THEN
                                 LEVER = 3
                                 IPT = NPT
                                 RETURN
                              END IF
C
C
                        IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C                     (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C                     (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C                     (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C                     (IVAL .EQ. 69696))
     C                        THEN
                                 LEVER = 3
                                 IPT = NPT
                                 RETURN
                              END IF
C
C
               LEVER = 3
               IPT = NPT
                       RETURN
C
                    END IF
C
      CALL EXTVAL(NPT+2,3,LEV(4))

1000  CONTINUE
C
      NN = 1
      IF(LEVNUM .LE. 1) NN = 2
C
      DO 113 I=NN,4
      IF(LEV(I) .EQ. -999999) RETURN
 113  CONTINUE
C
C     CHECK WHICH OF THE LEVELS IS OUT OF SEQUENCE
C
      IF(LEV(3) .LT. LEV(1) .OR. LEVNUM .LE. 1)
     C   THEN
            IF(LEV(4) .LT. LEV(2))
     C         THEN
C
C                 LEV(3) IS INCORRECT
C
                  IPT = NPT
                  LEVER = 3
                  RETURN
               ELSE
C
C                 LEV(2) IS INCORRECT
C
                  DO 114 I = IPOS , IPOS+ISTEP-1
                  KINT(I) = MINDIC
 114              CONTINUE
                  LEVER = 2
                  RETURN
               END IF
         ELSE
C
C           LEV(3) IS INCORRECT
C
            LEVER = 3
            IPT = NPT
            RETURN
         END IF
C
      END
      
      SUBROUTINE GETNEXT(IERR )
C
C**** *GETNEXT*
C
C
C     PURPOSE.
C     --------
C         GET NEXT MESSAGE FROM MDB.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GETNEXT( IERR )*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      include 'comdate.h'
C
      character*15000 ychar
      character*25 ytime
      CHARACTER*19 CTSTAMP
      character*78 cstr
      character*4  cstream
c
      data cstr/'                   pilot decoding'/
C
      DATA NSKIP/0/
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR=0
      NWPT=2
      NBPT=0
      NSUB=0
      ilenby=0
      ychar=' '
C
c                write last time stamp processed.
c
      if(ostream) then
c         call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
         nmonth = nm
         nday = nd
         nhour = nh
         nminute = nmin
         nsecond = nsec
         WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=410)
     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
         print*,'ytime=',ytime
         WRITE(17,9906,IOSTAT=IOS,ERR=410)
     1      CSTR,CSTREAM,CTSTAMP,YTIME
C
         REWIND(17)
c
      end if
      go to 110
c
 410  continue
c
      print*,' Error writing time stamp.'
C
 9906 FORMAT(1h ,A,
     1     //1h ,'stream             ',A,
     1      /1h ,'time stamp         ',a,
     1     //1h ,'last time updated  ',a  )
c
c     call ebexit(2)
C
C
C           1.1  GET NEXT MESSAGE.
C                -----------------
 110  CONTINUE
C
      ostream=.true.
      ILEN=ILENBY
      print*,'Current time stamp is ',ctstamp(1:16)
C
      READ(CTSTAMP,'(4x,4i2)') NRDAY,NRHOUR,NRMIN,NRSEC
C
 115  CONTINUE
C
      NUMBULL=NUMBULL+1 
C
C           1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
c      WRITE(*,9902) NUMBULL
C
C           1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.EQ.NSKIP) GO TO 110
C
C
C           1.4  TRANSFER BULLETIN TO 'KCHAR' ONE CHARACTER PER WORD.
C                ----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
C      
      RETURN
C
C     -----------------------------------------------------------------
 400  CONTINUE
C
c 9902 FORMAT(1H ,' BULLETIN NUMBER = ',I9)
C
      END
      
      SUBROUTINE ISTIME(CTIME,ITM,IRET)
C
C**** *ISTIME*
C
C
C     PURPOSE.
C     --------
C         CALCULATE TIME IN MINUTES SINCE 1/1/1978,
C         GIVEN INPUT AS DD-MMM-YYYY HH:MM:SS.CC
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ISTIME(CTIME,ITM,IRET)*
C
C          INPUT :  CTIME (ASCII TIME)
C
C          OUTPUT:  ITM  ( TIME IN MINUTES SINCE 1/1/1978.)
C                   IRET ( RETURN CODE)            
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       21/10/89.
C
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA    *CPTEC*.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) CTIME
      CHARACTER*3 CM(12)
      DIMENSION IDM(13)
C
      
      DATA IDM/0,31,28,31,30,31,30,31,31,30,31,30,31/ 
      DATA CM /'Jan','Feb','Mar','Apr','May','Jun',
     1         'Jul','Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C*          1.   SET MONTH.
C                ----------
 100  CONTINUE
C
      idays=0
c
      
      DO 101 I=1,12
       IF(CTIME(4:6).EQ.CM(I)) THEN
          IM=I
          IM=IM+1
          GO TO  110
       END IF
 101  CONTINUE 
C  
C
C*          1.1  SET MINUTES.
C                ------------
 110  CONTINUE
C
      READ (CTIME,'(I2,5X,I4,1X,I2,1X,I2)') ID,IY,IH,IMIN      
C 
      DO 111 I=1978,IY-1
       IDAYS=IDAYS+365
       IF(MOD(I,4).EQ.0) IDAYS=IDAYS+1
 111  CONTINUE
C
      DO 112 I=1,IM-1
       IDAYS=IDAYS+IDM(I) 
       IF(I.EQ.3) THEN
          IF(MOD(IY,4).EQ.0) IDAYS=IDAYS+1
       END IF
 112  CONTINUE
C
      IDAYS=IDAYS+ID-1
C
      ITM=IDAYS*1440+IH*60+IMIN
C
      RETURN
      END 

      SUBROUTINE read_seq(iunit,ierr,ios,irecnum,key,yfilename,rec)
cc
      integer iunit,ierr,ios,irecnum
      character*21 key
      character*21 yfilename
c
      structure /merge/
      character*21 station_date
      logical*1 oocont(4)
      integer*4 nncorn(4)
      integer*4 nma
      real      vvaluesa(900)
      integer*4 iilenc
      character*9 ccvala(10)
      end structure
c
      record /merge/ rec
c
      character*21 key_table(500)
      character*21 key_table1
c
      common /keytable/ key_table
      common /com_krecords/ krecords ! p/ contornar erro oriundo do
                                     ! enderecamento de variavel
                                     ! local na area de dados.
C
      krecords = krecords + 1

      do 11 i=1,krecords
c      print*,'keytable ',i,key_table(i)
c      print*,'key ',key
         if(key_table(i).eq.key) then
            irec = i
            go to 12
         end if
 11   continue
      irec = krecords
 12   irecnum = irec
      if(irec.lt.krecords) then
        krecords = krecords - 1
      end if
      key_table(irec)=key
c
c       nao sei porque a "key" muda de valor apos a leitura
c        key_table1
      key_table1=key
c
      ios = 0
 10   read(unit=iunit,iostat=ios,rec=irec) rec
c      print*,'ios ',ios,'irec ',irec
c      print*,'rec.station_date ',rec.station_date
c      print*,'keytable',key_table1
      if(ios .eq. 0 ) then        
        if(key_table1.eq.rec.station_date(1:21)) then
          ierr = 0
          return
        else
         key_table(irec)(1:21) = rec.station_date(1:21)
         irec = irec + 1
         irecnum = irec
c         key_table(irec) = key_table1
         go to 10
        endif 
      endif
      if (ios .eq. 36) then
         key_table(irec) = key_table1
         key = key_table(irecnum)
         krecords = irecnum
c         print*,'grava irec',irecnum,key_table(irec)(1:21)
         ierr = 1
         return
      endif
      if (ios .ne.0) go to 200
      
 200  write(6,220) iunit,ios
 220  format(' ********** ERROR DURING READING FILE ',i3,
     1       ' IOSTATUS = ',i3)
      ierr = -1
      return
      END
      
